/*
MICROSOFT SOFTWARE LICENSE TERMS
MICROSOFT AZURE MAPS WEB SDK

These license terms are an agreement between you and Microsoft Corporation (or one of its affiliates). They apply to the software named above and any Microsoft services or software updates (except to the extent such services or updates are accompanied by new or additional terms, in which case those different terms apply prospectively and do not alter your or Microsoft’s rights relating to pre-updated software or services). IF YOU COMPLY WITH THESE LICENSE TERMS, YOU HAVE THE RIGHTS BELOW.  BY USING THE SOFTWARE, YOU ACCEPT THESE TERMS.

1. INSTALLATION AND USE RIGHTS.
  a) General. You may install and use any number of copies of the software to develop and test your applications.
  b) User Region Parameters. The software will allow you to select from a View list to set the map view within your application for a given customer. By default the View parameter (also referred to as “user region parameter” is set to “Unified”.  Countries/Regions that are not on the View list will default to the “Unified” View. It is your responsibility to determine the location of your users, and then set the View parameter correctly for that location. The View parameter must be used in compliance with applicable laws, including those regarding mapping, of the country where maps, images and other data and third party content that You are authorized to access via the software is made available. 
  c) Third Party Software. The software may include third party applications that Microsoft, not the third party, licenses to you under this agreement. Any included notices for third party applications are for your information only.
  d) Microsoft Online Subscription Agreement. Some features of the software provide access to, or rely on, Microsoft Azure Services. The use of those services (but not the software) is governed by the separate terms and privacy policies associated with your Microsoft Azure subscription. The services may not be available in all regions. For more information see https://go.microsoft.com/fwLink/?LinkID=522330&amp;clcid=0x9.

2. DISTRIBUTABLE CODE. The software is comprised of “Distributable Code”. “Distributable Code” is code that you are permitted to distribute in applications you develop if you comply with the terms below and otherwise set forth in these license terms. 
  a) Distribution Rights. 
    i. You may copy and distribute the object code form of the software.
    i. Third Party Distribution. You may permit distributors of your applications to copy and distribute any of this distributable code you elect to distribute with your applications.
  b) Distribution Requirements. For any code you distribute, you must:
    i. add significant primary functionality to it in your applications;
    ii. require distributors and external end users to agree to terms that protect it and Microsoft at least as much as this agreement; and
    iii. indemnify, defend, and hold harmless Microsoft from any claims, including attorneys’ fees, related to the distribution or use of your applications, except to the extent that any claim is based solely on the unmodified distributable code.
  c) Distribution Restrictions. You may not:
    i. use Microsoft’s trademarks or trade dress in your application in any way that suggests your application comes from or is endorsed by Microsoft; or
    ii. modify or distribute the source code of any distributable code so that any part of it becomes subject to any license that requires that the distributable code, any other part of the software, or any of Microsoft’s other intellectual property be disclosed or distributed in source code form, or that others have the right to modify it.

3. DATA COLLECTION. The software may collect information about you and your use of the software and send that to Microsoft. Microsoft may use this information to provide services and improve Microsoft’s products and services. Your opt-out rights, if any, are described in the product documentation. Some features in the software may enable collection of data from users of your applications that access or use the software. If you use these features to enable data collection in your applications, you must comply with applicable law, including getting any required user consent, and maintain a prominent privacy policy that accurately informs users about how you use, collect, and share their data. You can learn more about Microsoft’s data collection and use in the product documentation and the Microsoft Privacy Statement at https://go.microsoft.com/fwlink/?LinkId=512132. You agree to comply with all applicable provisions of the Microsoft Privacy Statement.

4. SCOPE OF LICENSE. The software is licensed, not sold. Microsoft reserves all other rights. Unless applicable law gives you more rights despite this limitation, you will not (and have no right to):
  a) work around any technical limitations in the software that only allow you to use it in certain ways;
  b) reverse engineer, decompile, or disassemble the software, or attempt to do so, except and only to the extent permitted by licensing terms governing the use of open-source components that may be included with the software;
  c) remove, minimize, block, or modify any notices of Microsoft or its suppliers in the software;
  d) use the software in any way that is against the law or to create or propagate malware; or
  e) share, publish, distribute, or lend the software (except for any distributable code, subject to the terms above), provide the software as a stand-alone hosted solution for others to use, or transfer the software or this agreement to any third party.

5. EXPORT RESTRICTIONS. You must comply with all domestic and international export laws and regulations that apply to the software, which include restrictions on destinations, end users, and end use. For further information on export restrictions, visit http://aka.ms/exporting.

6. SUPPORT SERVICES. Microsoft is not obligated under this agreement to provide any support services for the software. Any support provided is “as is”, “with all faults”, and without warranty of any kind.

7. UPDATES. The software may periodically check for updates, and download and install them for you. You may obtain updates only from Microsoft or authorized sources. Microsoft may need to update your system to provide you with updates. You agree to receive these automatic updates without any additional notice. Updates may not include or support all existing software features, services, or peripheral devices.

8. ENTIRE AGREEMENT. This agreement, and any other terms Microsoft may provide for supplements, updates, or third-party applications, is the entire agreement for the software.

9. APPLICABLE LAW AND PLACE TO RESOLVE DISPUTES. If you acquired the software in the United States or Canada, the laws of the state or province where you live (or, if a business, where your principal place of business is located) govern the interpretation of this agreement, claims for its breach, and all other claims (including consumer protection, unfair competition, and tort claims), regardless of conflict of laws principles. If you acquired the software in any other country, its laws apply. If U.S. federal jurisdiction exists, you and Microsoft consent to exclusive jurisdiction and venue in the federal court in King County, Washington for all disputes heard in court. If not, you and Microsoft consent to exclusive jurisdiction and venue in the Superior Court of King County, Washington for all disputes heard in court.

10. CONSUMER RIGHTS; REGIONAL VARIATIONS. This agreement describes certain legal rights. You may have other rights, including consumer rights, under the laws of your state or country. Separate and apart from your relationship with Microsoft, you may also have rights with respect to the party from which you acquired the software. This agreement does not change those other rights if the laws of your state or country do not permit it to do so. For example, if you acquired the software in one of the below regions, or mandatory country law applies, then the following provisions apply to you:
  a) Australia. You have statutory guarantees under the Australian Consumer Law and nothing in this agreement is intended to affect those rights.
  b) Canada. If you acquired this software in Canada, you may stop receiving updates by turning off the automatic update feature, disconnecting your device from the Internet (if and when you re-connect to the Internet, however, the software will resume checking for and installing updates), or uninstalling the software. The product documentation, if any, may also specify how to turn off updates for your specific device or software.
  c) Germany and Austria.
    i. Warranty. The properly licensed software will perform substantially as described in any Microsoft materials that accompany the software. However, Microsoft gives no contractual guarantee in relation to the licensed software.
    ii. Limitation of Liability. In case of intentional conduct, gross negligence, claims based on the Product Liability Act, as well as, in case of death or personal or physical injury, Microsoft is liable according to the statutory law.
  Subject to the foregoing clause ii., Microsoft will only be liable for slight negligence if Microsoft is in breach of such material contractual obligations, the fulfillment of which facilitate the due performance of this agreement, the breach of which would endanger the purpose of this agreement and the compliance with which a party may constantly trust in (so-called "cardinal obligations"). In other cases of slight negligence, Microsoft will not be liable for slight negligence.

11. DISCLAIMER OF WARRANTY. THE SOFTWARE IS LICENSED “AS IS.” YOU BEAR THE RISK OF USING IT. MICROSOFT GIVES NO EXPRESS WARRANTIES, GUARANTEES, OR CONDITIONS. TO THE EXTENT PERMITTED UNDER APPLICABLE LAWS, MICROSOFT EXCLUDES ALL IMPLIED WARRANTIES, INCLUDING MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, AND NON-INFRINGEMENT.

12. LIMITATION ON AND EXCLUSION OF DAMAGES. IF YOU HAVE ANY BASIS FOR RECOVERING DAMAGES DESPITE THE PRECEDING DISCLAIMER OF WARRANTY, YOU CAN RECOVER FROM MICROSOFT AND ITS SUPPLIERS ONLY DIRECT DAMAGES UP TO U.S. $5.00. YOU CANNOT RECOVER ANY OTHER DAMAGES, INCLUDING CONSEQUENTIAL, LOST PROFITS, SPECIAL, INDIRECT, OR INCIDENTAL DAMAGES.
This limitation applies to (a) anything related to the software, services, content (including code) on third party Internet sites, or third party applications; and (b) claims for breach of contract, warranty, guarantee, or condition; strict liability, negligence, or other tort; or any other claim; in each case to the extent permitted by applicable law.
It also applies even if Microsoft knew or should have known about the possibility of the damages. The above limitation or exclusion may not apply to you because your state, province, or country may not allow the exclusion or limitation of incidental, consequential, or other damages.

Please note: As this software is distributed in Canada, some of the clauses in this agreement are provided below in French.

Remarque: Ce logiciel étant distribué au Canada, certaines des clauses dans ce contrat sont fournies ci-dessous en français.

EXONÉRATION DE GARANTIE. Le logiciel visé par une licence est offert « tel quel ». Toute utilisation de ce logiciel est à votre seule risque et péril. Microsoft n’accorde aucune autre garantie expresse. Vous pouvez bénéficier de droits additionnels en vertu du droit local sur la protection des consommateurs, que ce contrat ne peut modifier. La ou elles sont permises par le droit locale, les garanties implicites de qualité marchande, d’adéquation à un usage particulier et d’absence de contrefaçon sont exclues.

LIMITATION DES DOMMAGES-INTÉRÊTS ET EXCLUSION DE RESPONSABILITÉ POUR LES DOMMAGES. Vous pouvez obtenir de Microsoft et de ses fournisseurs une indemnisation en cas de dommages directs uniquement à hauteur de 5,00 $ US. Vous ne pouvez prétendre à aucune indemnisation pour les autres dommages, y compris les dommages spéciaux, indirects ou accessoires et pertes de bénéfices.

Cette limitation concerne:
• tout ce qui est relié au logiciel, aux services ou au contenu (y compris le code) figurant sur des sites Internet tiers ou dans des programmes tiers; et
• les réclamations au titre de violation de contrat ou de garantie, ou au titre de responsabilité stricte, de négligence ou d’une autre faute dans la limite autorisée par la loi en vigueur.

Elle s’applique également, même si Microsoft connaissait ou devrait connaître l’éventualité d’un tel dommage. Si votre pays n’autorise pas l’exclusion ou la limitation de responsabilité pour les dommages indirects, accessoires ou de quelque nature que ce soit, il se peut que la limitation ou l’exclusion ci-dessus ne s’appliquera pas à votre égard.

EFFET JURIDIQUE. Le présent contrat décrit certains droits juridiques. Vous pourriez avoir d’autres droits prévus par les lois de votre pays. Le présent contrat ne modifie pas les droits que vous confèrent les lois de votre pays si celles-ci ne le permettent pas.
---
title: THIRD PARTY NOTICES FOR Azure Maps Drawing Tools Module
preamble: |
	Do Not Translate or Localize

	This file is based on or incorporates material from the projects listed below (Third Party IP).
	The original copyright notice and the license under which Microsoft received such Third Party IP,
	are set forth below. Such licenses and notices are provided for informational purposes only.
	Microsoft licenses the Third Party IP to you under the licensing terms for the Microsoft product.
	Microsoft reserves all other rights not expressly granted under this agreement, whether by implication,
	estoppel or otherwise.


registrations:
	- component:
		name: @rollup/plugin-commonjs
		version: 25.0.3
		license: |
The MIT License (MIT)

Copyright (c) 2019 RollupJS Plugin Contributors (https://github.com/rollup/plugins/graphs/contributors)

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.


	- component:
		name: @rollup/plugin-node-resolve
		version: 15.1.0
		license: |
The MIT License (MIT)

Copyright (c) 2019 RollupJS Plugin Contributors (https://github.com/rollup/plugins/graphs/contributors)

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.


	- component:
		name: @types/lodash
		version: 4.14.197
		license: |
    MIT License

    Copyright (c) Microsoft Corporation.

    Permission is hereby granted, free of charge, to any person obtaining a copy
    of this software and associated documentation files (the "Software"), to deal
    in the Software without restriction, including without limitation the rights
    to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    copies of the Software, and to permit persons to whom the Software is
    furnished to do so, subject to the following conditions:

    The above copyright notice and this permission notice shall be included in all
    copies or substantial portions of the Software.

    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    SOFTWARE


	- component:
		name: @types/node
		version: 18.17.4
		license: |
    MIT License

    Copyright (c) Microsoft Corporation.

    Permission is hereby granted, free of charge, to any person obtaining a copy
    of this software and associated documentation files (the "Software"), to deal
    in the Software without restriction, including without limitation the rights
    to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    copies of the Software, and to permit persons to whom the Software is
    furnished to do so, subject to the following conditions:

    The above copyright notice and this permission notice shall be included in all
    copies or substantial portions of the Software.

    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    SOFTWARE


	- component:
		name: azure-maps-control
		version: 2.3.2
		license: |
MICROSOFT SOFTWARE LICENSE TERMS
MICROSOFT AZURE MAPS WEB SDK
These license terms are an agreement between you and Microsoft Corporation (or one of its affiliates). They apply to the software named above and any Microsoft services or software updates (except to the extent such services or updates are accompanied by new or additional terms, in which case those different terms apply prospectively and do not alter your or Microsoft’s rights relating to pre-updated software or services). IF YOU COMPLY WITH THESE LICENSE TERMS, YOU HAVE THE RIGHTS BELOW.  BY USING THE SOFTWARE, YOU ACCEPT THESE TERMS.
1. INSTALLATION AND USE RIGHTS.
  a) General. You may install and use any number of copies of the software to develop and test your applications.
  b) User Region Parameters. The software will allow you to select from a View list to set the map view within your application for a given customer. By default the View parameter (also referred to as “user region parameter” is set to “Unified”.  Countries/Regions that are not on the View list will default to the “Unified” View. It is your responsibility to determine the location of your users, and then set the View parameter correctly for that location. The View parameter must be used in compliance with applicable laws, including those regarding mapping, of the country where maps, images and other data and third party content that You are authorized to access via the software is made available. 
  c) Third Party Software. The software may include third party applications that Microsoft, not the third party, licenses to you under this agreement. Any included notices for third party applications are for your information only.
  d) Microsoft Online Subscription Agreement. Some features of the software provide access to, or rely on, Microsoft Azure Services. The use of those services (but not the software) is governed by the separate terms and privacy policies associated with your Microsoft Azure subscription. The services may not be available in all regions. For more information see https://go.microsoft.com/fwLink/?LinkID=522330&amp;clcid=0x9.
2. DISTRIBUTABLE CODE. The software is comprised of “Distributable Code”. “Distributable Code” is code that you are permitted to distribute in applications you develop if you comply with the terms below and otherwise set forth in these license terms. 
  a) Distribution Rights. 
    i. You may copy and distribute the object code form of the software.
    i. Third Party Distribution. You may permit distributors of your applications to copy and distribute any of this distributable code you elect to distribute with your applications.
  b) Distribution Requirements. For any code you distribute, you must:
    i. add significant primary functionality to it in your applications;
    ii. require distributors and external end users to agree to terms that protect it and Microsoft at least as much as this agreement; and
    iii. indemnify, defend, and hold harmless Microsoft from any claims, including attorneys’ fees, related to the distribution or use of your applications, except to the extent that any claim is based solely on the unmodified distributable code.
  c) Distribution Restrictions. You may not:
    i. use Microsoft’s trademarks or trade dress in your application in any way that suggests your application comes from or is endorsed by Microsoft; or
    ii. modify or distribute the source code of any distributable code so that any part of it becomes subject to any license that requires that the distributable code, any other part of the software, or any of Microsoft’s other intellectual property be disclosed or distributed in source code form, or that others have the right to modify it.
3. DATA COLLECTION. The software may collect information about you and your use of the software and send that to Microsoft. Microsoft may use this information to provide services and improve Microsoft’s products and services. Your opt-out rights, if any, are described in the product documentation. Some features in the software may enable collection of data from users of your applications that access or use the software. If you use these features to enable data collection in your applications, you must comply with applicable law, including getting any required user consent, and maintain a prominent privacy policy that accurately informs users about how you use, collect, and share their data. You can learn more about Microsoft’s data collection and use in the product documentation and the Microsoft Privacy Statement at https://go.microsoft.com/fwlink/?LinkId=512132. You agree to comply with all applicable provisions of the Microsoft Privacy Statement.
4. SCOPE OF LICENSE. The software is licensed, not sold. Microsoft reserves all other rights. Unless applicable law gives you more rights despite this limitation, you will not (and have no right to):
  a) work around any technical limitations in the software that only allow you to use it in certain ways;
  b) reverse engineer, decompile, or disassemble the software, or attempt to do so, except and only to the extent permitted by licensing terms governing the use of open-source components that may be included with the software;
  c) remove, minimize, block, or modify any notices of Microsoft or its suppliers in the software;
  d) use the software in any way that is against the law or to create or propagate malware; or
  e) share, publish, distribute, or lend the software (except for any distributable code, subject to the terms above), provide the software as a stand-alone hosted solution for others to use, or transfer the software or this agreement to any third party.
5. EXPORT RESTRICTIONS. You must comply with all domestic and international export laws and regulations that apply to the software, which include restrictions on destinations, end users, and end use. For further information on export restrictions, visit http://aka.ms/exporting.
6. SUPPORT SERVICES. Microsoft is not obligated under this agreement to provide any support services for the software. Any support provided is “as is”, “with all faults”, and without warranty of any kind.
7. UPDATES. The software may periodically check for updates, and download and install them for you. You may obtain updates only from Microsoft or authorized sources. Microsoft may need to update your system to provide you with updates. You agree to receive these automatic updates without any additional notice. Updates may not include or support all existing software features, services, or peripheral devices.
8. ENTIRE AGREEMENT. This agreement, and any other terms Microsoft may provide for supplements, updates, or third-party applications, is the entire agreement for the software.
9. APPLICABLE LAW AND PLACE TO RESOLVE DISPUTES. If you acquired the software in the United States or Canada, the laws of the state or province where you live (or, if a business, where your principal place of business is located) govern the interpretation of this agreement, claims for its breach, and all other claims (including consumer protection, unfair competition, and tort claims), regardless of conflict of laws principles. If you acquired the software in any other country, its laws apply. If U.S. federal jurisdiction exists, you and Microsoft consent to exclusive jurisdiction and venue in the federal court in King County, Washington for all disputes heard in court. If not, you and Microsoft consent to exclusive jurisdiction and venue in the Superior Court of King County, Washington for all disputes heard in court.
10. CONSUMER RIGHTS; REGIONAL VARIATIONS. This agreement describes certain legal rights. You may have other rights, including consumer rights, under the laws of your state or country. Separate and apart from your relationship with Microsoft, you may also have rights with respect to the party from which you acquired the software. This agreement does not change those other rights if the laws of your state or country do not permit it to do so. For example, if you acquired the software in one of the below regions, or mandatory country law applies, then the following provisions apply to you:
  a) Australia. You have statutory guarantees under the Australian Consumer Law and nothing in this agreement is intended to affect those rights.
  b) Canada. If you acquired this software in Canada, you may stop receiving updates by turning off the automatic update feature, disconnecting your device from the Internet (if and when you re-connect to the Internet, however, the software will resume checking for and installing updates), or uninstalling the software. The product documentation, if any, may also specify how to turn off updates for your specific device or software.
  c) Germany and Austria.
    i. Warranty. The properly licensed software will perform substantially as described in any Microsoft materials that accompany the software. However, Microsoft gives no contractual guarantee in relation to the licensed software.
    ii. Limitation of Liability. In case of intentional conduct, gross negligence, claims based on the Product Liability Act, as well as, in case of death or personal or physical injury, Microsoft is liable according to the statutory law.
  Subject to the foregoing clause ii., Microsoft will only be liable for slight negligence if Microsoft is in breach of such material contractual obligations, the fulfillment of which facilitate the due performance of this agreement, the breach of which would endanger the purpose of this agreement and the compliance with which a party may constantly trust in (so-called "cardinal obligations"). In other cases of slight negligence, Microsoft will not be liable for slight negligence.
11. DISCLAIMER OF WARRANTY. THE SOFTWARE IS LICENSED “AS IS.” YOU BEAR THE RISK OF USING IT. MICROSOFT GIVES NO EXPRESS WARRANTIES, GUARANTEES, OR CONDITIONS. TO THE EXTENT PERMITTED UNDER APPLICABLE LAWS, MICROSOFT EXCLUDES ALL IMPLIED WARRANTIES, INCLUDING MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, AND NON-INFRINGEMENT.
12. LIMITATION ON AND EXCLUSION OF DAMAGES. IF YOU HAVE ANY BASIS FOR RECOVERING DAMAGES DESPITE THE PRECEDING DISCLAIMER OF WARRANTY, YOU CAN RECOVER FROM MICROSOFT AND ITS SUPPLIERS ONLY DIRECT DAMAGES UP TO U.S. $5.00. YOU CANNOT RECOVER ANY OTHER DAMAGES, INCLUDING CONSEQUENTIAL, LOST PROFITS, SPECIAL, INDIRECT, OR INCIDENTAL DAMAGES.
This limitation applies to (a) anything related to the software, services, content (including code) on third party Internet sites, or third party applications; and (b) claims for breach of contract, warranty, guarantee, or condition; strict liability, negligence, or other tort; or any other claim; in each case to the extent permitted by applicable law.
It also applies even if Microsoft knew or should have known about the possibility of the damages. The above limitation or exclusion may not apply to you because your state, province, or country may not allow the exclusion or limitation of incidental, consequential, or other damages.
Please note: As this software is distributed in Canada, some of the clauses in this agreement are provided below in French.
Remarque: Ce logiciel étant distribué au Canada, certaines des clauses dans ce contrat sont fournies ci-dessous en français.
EXONÉRATION DE GARANTIE. Le logiciel visé par une licence est offert « tel quel ». Toute utilisation de ce logiciel est à votre seule risque et péril. Microsoft n’accorde aucune autre garantie expresse. Vous pouvez bénéficier de droits additionnels en vertu du droit local sur la protection des consommateurs, que ce contrat ne peut modifier. La ou elles sont permises par le droit locale, les garanties implicites de qualité marchande, d’adéquation à un usage particulier et d’absence de contrefaçon sont exclues.
LIMITATION DES DOMMAGES-INTÉRÊTS ET EXCLUSION DE RESPONSABILITÉ POUR LES DOMMAGES. Vous pouvez obtenir de Microsoft et de ses fournisseurs une indemnisation en cas de dommages directs uniquement à hauteur de 5,00 $ US. Vous ne pouvez prétendre à aucune indemnisation pour les autres dommages, y compris les dommages spéciaux, indirects ou accessoires et pertes de bénéfices.
Cette limitation concerne:
• tout ce qui est relié au logiciel, aux services ou au contenu (y compris le code) figurant sur des sites Internet tiers ou dans des programmes tiers; et
• les réclamations au titre de violation de contrat ou de garantie, ou au titre de responsabilité stricte, de négligence ou d’une autre faute dans la limite autorisée par la loi en vigueur.
Elle s’applique également, même si Microsoft connaissait ou devrait connaître l’éventualité d’un tel dommage. Si votre pays n’autorise pas l’exclusion ou la limitation de responsabilité pour les dommages indirects, accessoires ou de quelque nature que ce soit, il se peut que la limitation ou l’exclusion ci-dessus ne s’appliquera pas à votre égard.
EFFET JURIDIQUE. Le présent contrat décrit certains droits juridiques. Vous pourriez avoir d’autres droits prévus par les lois de votre pays. Le présent contrat ne modifie pas les droits que vous confèrent les lois de votre pays si celles-ci ne le permettent pas.


	- component:
		name: lodash
		version: 4.17.21
		license: |
Copyright OpenJS Foundation and other contributors <https://openjsf.org/>

Based on Underscore.js, copyright Jeremy Ashkenas,
DocumentCloud and Investigative Reporters & Editors <http://underscorejs.org/>

This software consists of voluntary contributions made by many
individuals. For exact contribution history, see the revision history
available at https://github.com/lodash/lodash

The following license applies to all parts of this software except as
documented below:

====

Permission is hereby granted, free of charge, to any person obtaining
a copy of this software and associated documentation files (the
"Software"), to deal in the Software without restriction, including
without limitation the rights to use, copy, modify, merge, publish,
distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to
the following conditions:

The above copyright notice and this permission notice shall be
included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

====

Copyright and related rights for sample code are waived via CC0. Sample
code is defined as all source code displayed within the prose of the
documentation.

CC0: http://creativecommons.org/publicdomain/zero/1.0/

====

Files located in the node_modules and vendor directories are externally
maintained libraries used by this software which have their own
licenses; we recommend you read them, as their terms may differ from the
terms above.


	- component:
		name: typescript
		version: 5.1.6
		license: |
Apache License

Version 2.0, January 2004

http://www.apache.org/licenses/ 

TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION

1. Definitions.

"License" shall mean the terms and conditions for use, reproduction, and distribution as defined by Sections 1 through 9 of this document.

"Licensor" shall mean the copyright owner or entity authorized by the copyright owner that is granting the License.

"Legal Entity" shall mean the union of the acting entity and all other entities that control, are controlled by, or are under common control with that entity. For the purposes of this definition, "control" means (i) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the outstanding shares, or (iii) beneficial ownership of such entity.

"You" (or "Your") shall mean an individual or Legal Entity exercising permissions granted by this License.

"Source" form shall mean the preferred form for making modifications, including but not limited to software source code, documentation source, and configuration files.

"Object" form shall mean any form resulting from mechanical transformation or translation of a Source form, including but not limited to compiled object code, generated documentation, and conversions to other media types.

"Work" shall mean the work of authorship, whether in Source or Object form, made available under the License, as indicated by a copyright notice that is included in or attached to the work (an example is provided in the Appendix below).

"Derivative Works" shall mean any work, whether in Source or Object form, that is based on (or derived from) the Work and for which the editorial revisions, annotations, elaborations, or other modifications represent, as a whole, an original work of authorship. For the purposes of this License, Derivative Works shall not include works that remain separable from, or merely link (or bind by name) to the interfaces of, the Work and Derivative Works thereof.

"Contribution" shall mean any work of authorship, including the original version of the Work and any modifications or additions to that Work or Derivative Works thereof, that is intentionally submitted to Licensor for inclusion in the Work by the copyright owner or by an individual or Legal Entity authorized to submit on behalf of the copyright owner. For the purposes of this definition, "submitted" means any form of electronic, verbal, or written communication sent to the Licensor or its representatives, including but not limited to communication on electronic mailing lists, source code control systems, and issue tracking systems that are managed by, or on behalf of, the Licensor for the purpose of discussing and improving the Work, but excluding communication that is conspicuously marked or otherwise designated in writing by the copyright owner as "Not a Contribution."

"Contributor" shall mean Licensor and any individual or Legal Entity on behalf of whom a Contribution has been received by Licensor and subsequently incorporated within the Work.

2. Grant of Copyright License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable copyright license to reproduce, prepare Derivative Works of, publicly display, publicly perform, sublicense, and distribute the Work and such Derivative Works in Source or Object form.

3. Grant of Patent License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable (except as stated in this section) patent license to make, have made, use, offer to sell, sell, import, and otherwise transfer the Work, where such license applies only to those patent claims licensable by such Contributor that are necessarily infringed by their Contribution(s) alone or by combination of their Contribution(s) with the Work to which such Contribution(s) was submitted. If You institute patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Work or a Contribution incorporated within the Work constitutes direct or contributory patent infringement, then any patent licenses granted to You under this License for that Work shall terminate as of the date such litigation is filed.

4. Redistribution. You may reproduce and distribute copies of the Work or Derivative Works thereof in any medium, with or without modifications, and in Source or Object form, provided that You meet the following conditions:

You must give any other recipients of the Work or Derivative Works a copy of this License; and

You must cause any modified files to carry prominent notices stating that You changed the files; and

You must retain, in the Source form of any Derivative Works that You distribute, all copyright, patent, trademark, and attribution notices from the Source form of the Work, excluding those notices that do not pertain to any part of the Derivative Works; and

If the Work includes a "NOTICE" text file as part of its distribution, then any Derivative Works that You distribute must include a readable copy of the attribution notices contained within such NOTICE file, excluding those notices that do not pertain to any part of the Derivative Works, in at least one of the following places: within a NOTICE text file distributed as part of the Derivative Works; within the Source form or documentation, if provided along with the Derivative Works; or, within a display generated by the Derivative Works, if and wherever such third-party notices normally appear. The contents of the NOTICE file are for informational purposes only and do not modify the License. You may add Your own attribution notices within Derivative Works that You distribute, alongside or as an addendum to the NOTICE text from the Work, provided that such additional attribution notices cannot be construed as modifying the License. You may add Your own copyright statement to Your modifications and may provide additional or different license terms and conditions for use, reproduction, or distribution of Your modifications, or for any such Derivative Works as a whole, provided Your use, reproduction, and distribution of the Work otherwise complies with the conditions stated in this License.

5. Submission of Contributions. Unless You explicitly state otherwise, any Contribution intentionally submitted for inclusion in the Work by You to the Licensor shall be under the terms and conditions of this License, without any additional terms or conditions. Notwithstanding the above, nothing herein shall supersede or modify the terms of any separate license agreement you may have executed with Licensor regarding such Contributions.

6. Trademarks. This License does not grant permission to use the trade names, trademarks, service marks, or product names of the Licensor, except as required for reasonable and customary use in describing the origin of the Work and reproducing the content of the NOTICE file.

7. Disclaimer of Warranty. Unless required by applicable law or agreed to in writing, Licensor provides the Work (and each Contributor provides its Contributions) on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied, including, without limitation, any warranties or conditions of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are solely responsible for determining the appropriateness of using or redistributing the Work and assume any risks associated with Your exercise of permissions under this License.

8. Limitation of Liability. In no event and under no legal theory, whether in tort (including negligence), contract, or otherwise, unless required by applicable law (such as deliberate and grossly negligent acts) or agreed to in writing, shall any Contributor be liable to You for damages, including any direct, indirect, special, incidental, or consequential damages of any character arising as a result of this License or out of the use or inability to use the Work (including but not limited to damages for loss of goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages or losses), even if such Contributor has been advised of the possibility of such damages.

9. Accepting Warranty or Additional Liability. While redistributing the Work or Derivative Works thereof, You may choose to offer, and charge a fee for, acceptance of support, warranty, indemnity, or other liability obligations and/or rights consistent with this License. However, in accepting such obligations, You may act only on Your own behalf and on Your sole responsibility, not on behalf of any other Contributor, and only if You agree to indemnify, defend, and hold each Contributor harmless for any liability incurred by, or claims asserted against, such Contributor by reason of your accepting any such warranty or additional liability.

END OF TERMS AND CONDITIONS
*/

'use strict';

var azmaps = require('azure-maps-control');

function _interopNamespaceDefault(e) {
    var n = Object.create(null);
    if (e) {
        Object.keys(e).forEach(function (k) {
            if (k !== 'default') {
                var d = Object.getOwnPropertyDescriptor(e, k);
                Object.defineProperty(n, k, d.get ? d : {
                    enumerable: true,
                    get: function () { return e[k]; }
                });
            }
        });
    }
    n.default = e;
    return Object.freeze(n);
}

var azmaps__namespace = /*#__PURE__*/_interopNamespaceDefault(azmaps);

var __assign$1 = (undefined && undefined.__assign) || function () {
    __assign$1 = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign$1.apply(this, arguments);
};
var Namespace = /** @class */ (function () {
    function Namespace() {
    }
    Namespace.merge = function (namespace, base) {
        var context = window || global;
        var parts = namespace.split(".");
        for (var _i = 0, parts_1 = parts; _i < parts_1.length; _i++) {
            var part = parts_1[_i];
            if (context[part]) {
                context = context[part];
            }
            else {
                return base;
            }
        }
        return __assign$1(__assign$1({}, context), base);
    };
    return Namespace;
}());

var commonjsGlobal = typeof globalThis !== 'undefined' ? globalThis : typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};

function getDefaultExportFromCjs (x) {
	return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, 'default') ? x['default'] : x;
}

/**
 * Removes all key-value entries from the list cache.
 *
 * @private
 * @name clear
 * @memberOf ListCache
 */

function listCacheClear$1() {
  this.__data__ = [];
  this.size = 0;
}

var _listCacheClear = listCacheClear$1;

/**
 * Performs a
 * [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)
 * comparison between two values to determine if they are equivalent.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to compare.
 * @param {*} other The other value to compare.
 * @returns {boolean} Returns `true` if the values are equivalent, else `false`.
 * @example
 *
 * var object = { 'a': 1 };
 * var other = { 'a': 1 };
 *
 * _.eq(object, object);
 * // => true
 *
 * _.eq(object, other);
 * // => false
 *
 * _.eq('a', 'a');
 * // => true
 *
 * _.eq('a', Object('a'));
 * // => false
 *
 * _.eq(NaN, NaN);
 * // => true
 */

function eq$3(value, other) {
  return value === other || (value !== value && other !== other);
}

var eq_1 = eq$3;

var eq$2 = eq_1;

/**
 * Gets the index at which the `key` is found in `array` of key-value pairs.
 *
 * @private
 * @param {Array} array The array to inspect.
 * @param {*} key The key to search for.
 * @returns {number} Returns the index of the matched value, else `-1`.
 */
function assocIndexOf$4(array, key) {
  var length = array.length;
  while (length--) {
    if (eq$2(array[length][0], key)) {
      return length;
    }
  }
  return -1;
}

var _assocIndexOf = assocIndexOf$4;

var assocIndexOf$3 = _assocIndexOf;

/** Used for built-in method references. */
var arrayProto = Array.prototype;

/** Built-in value references. */
var splice = arrayProto.splice;

/**
 * Removes `key` and its value from the list cache.
 *
 * @private
 * @name delete
 * @memberOf ListCache
 * @param {string} key The key of the value to remove.
 * @returns {boolean} Returns `true` if the entry was removed, else `false`.
 */
function listCacheDelete$1(key) {
  var data = this.__data__,
      index = assocIndexOf$3(data, key);

  if (index < 0) {
    return false;
  }
  var lastIndex = data.length - 1;
  if (index == lastIndex) {
    data.pop();
  } else {
    splice.call(data, index, 1);
  }
  --this.size;
  return true;
}

var _listCacheDelete = listCacheDelete$1;

var assocIndexOf$2 = _assocIndexOf;

/**
 * Gets the list cache value for `key`.
 *
 * @private
 * @name get
 * @memberOf ListCache
 * @param {string} key The key of the value to get.
 * @returns {*} Returns the entry value.
 */
function listCacheGet$1(key) {
  var data = this.__data__,
      index = assocIndexOf$2(data, key);

  return index < 0 ? undefined : data[index][1];
}

var _listCacheGet = listCacheGet$1;

var assocIndexOf$1 = _assocIndexOf;

/**
 * Checks if a list cache value for `key` exists.
 *
 * @private
 * @name has
 * @memberOf ListCache
 * @param {string} key The key of the entry to check.
 * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
 */
function listCacheHas$1(key) {
  return assocIndexOf$1(this.__data__, key) > -1;
}

var _listCacheHas = listCacheHas$1;

var assocIndexOf = _assocIndexOf;

/**
 * Sets the list cache `key` to `value`.
 *
 * @private
 * @name set
 * @memberOf ListCache
 * @param {string} key The key of the value to set.
 * @param {*} value The value to set.
 * @returns {Object} Returns the list cache instance.
 */
function listCacheSet$1(key, value) {
  var data = this.__data__,
      index = assocIndexOf(data, key);

  if (index < 0) {
    ++this.size;
    data.push([key, value]);
  } else {
    data[index][1] = value;
  }
  return this;
}

var _listCacheSet = listCacheSet$1;

var listCacheClear = _listCacheClear,
    listCacheDelete = _listCacheDelete,
    listCacheGet = _listCacheGet,
    listCacheHas = _listCacheHas,
    listCacheSet = _listCacheSet;

/**
 * Creates an list cache object.
 *
 * @private
 * @constructor
 * @param {Array} [entries] The key-value pairs to cache.
 */
function ListCache$4(entries) {
  var index = -1,
      length = entries == null ? 0 : entries.length;

  this.clear();
  while (++index < length) {
    var entry = entries[index];
    this.set(entry[0], entry[1]);
  }
}

// Add methods to `ListCache`.
ListCache$4.prototype.clear = listCacheClear;
ListCache$4.prototype['delete'] = listCacheDelete;
ListCache$4.prototype.get = listCacheGet;
ListCache$4.prototype.has = listCacheHas;
ListCache$4.prototype.set = listCacheSet;

var _ListCache = ListCache$4;

var ListCache$3 = _ListCache;

/**
 * Removes all key-value entries from the stack.
 *
 * @private
 * @name clear
 * @memberOf Stack
 */
function stackClear$1() {
  this.__data__ = new ListCache$3;
  this.size = 0;
}

var _stackClear = stackClear$1;

/**
 * Removes `key` and its value from the stack.
 *
 * @private
 * @name delete
 * @memberOf Stack
 * @param {string} key The key of the value to remove.
 * @returns {boolean} Returns `true` if the entry was removed, else `false`.
 */

function stackDelete$1(key) {
  var data = this.__data__,
      result = data['delete'](key);

  this.size = data.size;
  return result;
}

var _stackDelete = stackDelete$1;

/**
 * Gets the stack value for `key`.
 *
 * @private
 * @name get
 * @memberOf Stack
 * @param {string} key The key of the value to get.
 * @returns {*} Returns the entry value.
 */

function stackGet$1(key) {
  return this.__data__.get(key);
}

var _stackGet = stackGet$1;

/**
 * Checks if a stack value for `key` exists.
 *
 * @private
 * @name has
 * @memberOf Stack
 * @param {string} key The key of the entry to check.
 * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
 */

function stackHas$1(key) {
  return this.__data__.has(key);
}

var _stackHas = stackHas$1;

/** Detect free variable `global` from Node.js. */

var freeGlobal$1 = typeof commonjsGlobal == 'object' && commonjsGlobal && commonjsGlobal.Object === Object && commonjsGlobal;

var _freeGlobal = freeGlobal$1;

var freeGlobal = _freeGlobal;

/** Detect free variable `self`. */
var freeSelf = typeof self == 'object' && self && self.Object === Object && self;

/** Used as a reference to the global object. */
var root$8 = freeGlobal || freeSelf || Function('return this')();

var _root = root$8;

var root$7 = _root;

/** Built-in value references. */
var Symbol$4 = root$7.Symbol;

var _Symbol = Symbol$4;

var Symbol$3 = _Symbol;

/** Used for built-in method references. */
var objectProto$e = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty$b = objectProto$e.hasOwnProperty;

/**
 * Used to resolve the
 * [`toStringTag`](http://ecma-international.org/ecma-262/7.0/#sec-object.prototype.tostring)
 * of values.
 */
var nativeObjectToString$1 = objectProto$e.toString;

/** Built-in value references. */
var symToStringTag$1 = Symbol$3 ? Symbol$3.toStringTag : undefined;

/**
 * A specialized version of `baseGetTag` which ignores `Symbol.toStringTag` values.
 *
 * @private
 * @param {*} value The value to query.
 * @returns {string} Returns the raw `toStringTag`.
 */
function getRawTag$1(value) {
  var isOwn = hasOwnProperty$b.call(value, symToStringTag$1),
      tag = value[symToStringTag$1];

  try {
    value[symToStringTag$1] = undefined;
    var unmasked = true;
  } catch (e) {}

  var result = nativeObjectToString$1.call(value);
  if (unmasked) {
    if (isOwn) {
      value[symToStringTag$1] = tag;
    } else {
      delete value[symToStringTag$1];
    }
  }
  return result;
}

var _getRawTag = getRawTag$1;

/** Used for built-in method references. */

var objectProto$d = Object.prototype;

/**
 * Used to resolve the
 * [`toStringTag`](http://ecma-international.org/ecma-262/7.0/#sec-object.prototype.tostring)
 * of values.
 */
var nativeObjectToString = objectProto$d.toString;

/**
 * Converts `value` to a string using `Object.prototype.toString`.
 *
 * @private
 * @param {*} value The value to convert.
 * @returns {string} Returns the converted string.
 */
function objectToString$1(value) {
  return nativeObjectToString.call(value);
}

var _objectToString = objectToString$1;

var Symbol$2 = _Symbol,
    getRawTag = _getRawTag,
    objectToString = _objectToString;

/** `Object#toString` result references. */
var nullTag = '[object Null]',
    undefinedTag = '[object Undefined]';

/** Built-in value references. */
var symToStringTag = Symbol$2 ? Symbol$2.toStringTag : undefined;

/**
 * The base implementation of `getTag` without fallbacks for buggy environments.
 *
 * @private
 * @param {*} value The value to query.
 * @returns {string} Returns the `toStringTag`.
 */
function baseGetTag$4(value) {
  if (value == null) {
    return value === undefined ? undefinedTag : nullTag;
  }
  return (symToStringTag && symToStringTag in Object(value))
    ? getRawTag(value)
    : objectToString(value);
}

var _baseGetTag = baseGetTag$4;

/**
 * Checks if `value` is the
 * [language type](http://www.ecma-international.org/ecma-262/7.0/#sec-ecmascript-language-types)
 * of `Object`. (e.g. arrays, functions, objects, regexes, `new Number(0)`, and `new String('')`)
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is an object, else `false`.
 * @example
 *
 * _.isObject({});
 * // => true
 *
 * _.isObject([1, 2, 3]);
 * // => true
 *
 * _.isObject(_.noop);
 * // => true
 *
 * _.isObject(null);
 * // => false
 */

function isObject$5(value) {
  var type = typeof value;
  return value != null && (type == 'object' || type == 'function');
}

var isObject_1 = isObject$5;

var baseGetTag$3 = _baseGetTag,
    isObject$4 = isObject_1;

/** `Object#toString` result references. */
var asyncTag = '[object AsyncFunction]',
    funcTag$2 = '[object Function]',
    genTag$1 = '[object GeneratorFunction]',
    proxyTag = '[object Proxy]';

/**
 * Checks if `value` is classified as a `Function` object.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a function, else `false`.
 * @example
 *
 * _.isFunction(_);
 * // => true
 *
 * _.isFunction(/abc/);
 * // => false
 */
function isFunction$2(value) {
  if (!isObject$4(value)) {
    return false;
  }
  // The use of `Object#toString` avoids issues with the `typeof` operator
  // in Safari 9 which returns 'object' for typed arrays and other constructors.
  var tag = baseGetTag$3(value);
  return tag == funcTag$2 || tag == genTag$1 || tag == asyncTag || tag == proxyTag;
}

var isFunction_1 = isFunction$2;

var root$6 = _root;

/** Used to detect overreaching core-js shims. */
var coreJsData$1 = root$6['__core-js_shared__'];

var _coreJsData = coreJsData$1;

var coreJsData = _coreJsData;

/** Used to detect methods masquerading as native. */
var maskSrcKey = (function() {
  var uid = /[^.]+$/.exec(coreJsData && coreJsData.keys && coreJsData.keys.IE_PROTO || '');
  return uid ? ('Symbol(src)_1.' + uid) : '';
}());

/**
 * Checks if `func` has its source masked.
 *
 * @private
 * @param {Function} func The function to check.
 * @returns {boolean} Returns `true` if `func` is masked, else `false`.
 */
function isMasked$1(func) {
  return !!maskSrcKey && (maskSrcKey in func);
}

var _isMasked = isMasked$1;

/** Used for built-in method references. */

var funcProto$1 = Function.prototype;

/** Used to resolve the decompiled source of functions. */
var funcToString$1 = funcProto$1.toString;

/**
 * Converts `func` to its source code.
 *
 * @private
 * @param {Function} func The function to convert.
 * @returns {string} Returns the source code.
 */
function toSource$2(func) {
  if (func != null) {
    try {
      return funcToString$1.call(func);
    } catch (e) {}
    try {
      return (func + '');
    } catch (e) {}
  }
  return '';
}

var _toSource = toSource$2;

var isFunction$1 = isFunction_1,
    isMasked = _isMasked,
    isObject$3 = isObject_1,
    toSource$1 = _toSource;

/**
 * Used to match `RegExp`
 * [syntax characters](http://ecma-international.org/ecma-262/7.0/#sec-patterns).
 */
var reRegExpChar = /[\\^$.*+?()[\]{}|]/g;

/** Used to detect host constructors (Safari). */
var reIsHostCtor = /^\[object .+?Constructor\]$/;

/** Used for built-in method references. */
var funcProto = Function.prototype,
    objectProto$c = Object.prototype;

/** Used to resolve the decompiled source of functions. */
var funcToString = funcProto.toString;

/** Used to check objects for own properties. */
var hasOwnProperty$a = objectProto$c.hasOwnProperty;

/** Used to detect if a method is native. */
var reIsNative = RegExp('^' +
  funcToString.call(hasOwnProperty$a).replace(reRegExpChar, '\\$&')
  .replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, '$1.*?') + '$'
);

/**
 * The base implementation of `_.isNative` without bad shim checks.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a native function,
 *  else `false`.
 */
function baseIsNative$1(value) {
  if (!isObject$3(value) || isMasked(value)) {
    return false;
  }
  var pattern = isFunction$1(value) ? reIsNative : reIsHostCtor;
  return pattern.test(toSource$1(value));
}

var _baseIsNative = baseIsNative$1;

/**
 * Gets the value at `key` of `object`.
 *
 * @private
 * @param {Object} [object] The object to query.
 * @param {string} key The key of the property to get.
 * @returns {*} Returns the property value.
 */

function getValue$1(object, key) {
  return object == null ? undefined : object[key];
}

var _getValue = getValue$1;

var baseIsNative = _baseIsNative,
    getValue = _getValue;

/**
 * Gets the native function at `key` of `object`.
 *
 * @private
 * @param {Object} object The object to query.
 * @param {string} key The key of the method to get.
 * @returns {*} Returns the function if it's native, else `undefined`.
 */
function getNative$7(object, key) {
  var value = getValue(object, key);
  return baseIsNative(value) ? value : undefined;
}

var _getNative = getNative$7;

var getNative$6 = _getNative,
    root$5 = _root;

/* Built-in method references that are verified to be native. */
var Map$3 = getNative$6(root$5, 'Map');

var _Map = Map$3;

var getNative$5 = _getNative;

/* Built-in method references that are verified to be native. */
var nativeCreate$4 = getNative$5(Object, 'create');

var _nativeCreate = nativeCreate$4;

var nativeCreate$3 = _nativeCreate;

/**
 * Removes all key-value entries from the hash.
 *
 * @private
 * @name clear
 * @memberOf Hash
 */
function hashClear$1() {
  this.__data__ = nativeCreate$3 ? nativeCreate$3(null) : {};
  this.size = 0;
}

var _hashClear = hashClear$1;

/**
 * Removes `key` and its value from the hash.
 *
 * @private
 * @name delete
 * @memberOf Hash
 * @param {Object} hash The hash to modify.
 * @param {string} key The key of the value to remove.
 * @returns {boolean} Returns `true` if the entry was removed, else `false`.
 */

function hashDelete$1(key) {
  var result = this.has(key) && delete this.__data__[key];
  this.size -= result ? 1 : 0;
  return result;
}

var _hashDelete = hashDelete$1;

var nativeCreate$2 = _nativeCreate;

/** Used to stand-in for `undefined` hash values. */
var HASH_UNDEFINED$2 = '__lodash_hash_undefined__';

/** Used for built-in method references. */
var objectProto$b = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty$9 = objectProto$b.hasOwnProperty;

/**
 * Gets the hash value for `key`.
 *
 * @private
 * @name get
 * @memberOf Hash
 * @param {string} key The key of the value to get.
 * @returns {*} Returns the entry value.
 */
function hashGet$1(key) {
  var data = this.__data__;
  if (nativeCreate$2) {
    var result = data[key];
    return result === HASH_UNDEFINED$2 ? undefined : result;
  }
  return hasOwnProperty$9.call(data, key) ? data[key] : undefined;
}

var _hashGet = hashGet$1;

var nativeCreate$1 = _nativeCreate;

/** Used for built-in method references. */
var objectProto$a = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty$8 = objectProto$a.hasOwnProperty;

/**
 * Checks if a hash value for `key` exists.
 *
 * @private
 * @name has
 * @memberOf Hash
 * @param {string} key The key of the entry to check.
 * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
 */
function hashHas$1(key) {
  var data = this.__data__;
  return nativeCreate$1 ? (data[key] !== undefined) : hasOwnProperty$8.call(data, key);
}

var _hashHas = hashHas$1;

var nativeCreate = _nativeCreate;

/** Used to stand-in for `undefined` hash values. */
var HASH_UNDEFINED$1 = '__lodash_hash_undefined__';

/**
 * Sets the hash `key` to `value`.
 *
 * @private
 * @name set
 * @memberOf Hash
 * @param {string} key The key of the value to set.
 * @param {*} value The value to set.
 * @returns {Object} Returns the hash instance.
 */
function hashSet$1(key, value) {
  var data = this.__data__;
  this.size += this.has(key) ? 0 : 1;
  data[key] = (nativeCreate && value === undefined) ? HASH_UNDEFINED$1 : value;
  return this;
}

var _hashSet = hashSet$1;

var hashClear = _hashClear,
    hashDelete = _hashDelete,
    hashGet = _hashGet,
    hashHas = _hashHas,
    hashSet = _hashSet;

/**
 * Creates a hash object.
 *
 * @private
 * @constructor
 * @param {Array} [entries] The key-value pairs to cache.
 */
function Hash$1(entries) {
  var index = -1,
      length = entries == null ? 0 : entries.length;

  this.clear();
  while (++index < length) {
    var entry = entries[index];
    this.set(entry[0], entry[1]);
  }
}

// Add methods to `Hash`.
Hash$1.prototype.clear = hashClear;
Hash$1.prototype['delete'] = hashDelete;
Hash$1.prototype.get = hashGet;
Hash$1.prototype.has = hashHas;
Hash$1.prototype.set = hashSet;

var _Hash = Hash$1;

var Hash = _Hash,
    ListCache$2 = _ListCache,
    Map$2 = _Map;

/**
 * Removes all key-value entries from the map.
 *
 * @private
 * @name clear
 * @memberOf MapCache
 */
function mapCacheClear$1() {
  this.size = 0;
  this.__data__ = {
    'hash': new Hash,
    'map': new (Map$2 || ListCache$2),
    'string': new Hash
  };
}

var _mapCacheClear = mapCacheClear$1;

/**
 * Checks if `value` is suitable for use as unique object key.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is suitable, else `false`.
 */

function isKeyable$1(value) {
  var type = typeof value;
  return (type == 'string' || type == 'number' || type == 'symbol' || type == 'boolean')
    ? (value !== '__proto__')
    : (value === null);
}

var _isKeyable = isKeyable$1;

var isKeyable = _isKeyable;

/**
 * Gets the data for `map`.
 *
 * @private
 * @param {Object} map The map to query.
 * @param {string} key The reference key.
 * @returns {*} Returns the map data.
 */
function getMapData$4(map, key) {
  var data = map.__data__;
  return isKeyable(key)
    ? data[typeof key == 'string' ? 'string' : 'hash']
    : data.map;
}

var _getMapData = getMapData$4;

var getMapData$3 = _getMapData;

/**
 * Removes `key` and its value from the map.
 *
 * @private
 * @name delete
 * @memberOf MapCache
 * @param {string} key The key of the value to remove.
 * @returns {boolean} Returns `true` if the entry was removed, else `false`.
 */
function mapCacheDelete$1(key) {
  var result = getMapData$3(this, key)['delete'](key);
  this.size -= result ? 1 : 0;
  return result;
}

var _mapCacheDelete = mapCacheDelete$1;

var getMapData$2 = _getMapData;

/**
 * Gets the map value for `key`.
 *
 * @private
 * @name get
 * @memberOf MapCache
 * @param {string} key The key of the value to get.
 * @returns {*} Returns the entry value.
 */
function mapCacheGet$1(key) {
  return getMapData$2(this, key).get(key);
}

var _mapCacheGet = mapCacheGet$1;

var getMapData$1 = _getMapData;

/**
 * Checks if a map value for `key` exists.
 *
 * @private
 * @name has
 * @memberOf MapCache
 * @param {string} key The key of the entry to check.
 * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
 */
function mapCacheHas$1(key) {
  return getMapData$1(this, key).has(key);
}

var _mapCacheHas = mapCacheHas$1;

var getMapData = _getMapData;

/**
 * Sets the map `key` to `value`.
 *
 * @private
 * @name set
 * @memberOf MapCache
 * @param {string} key The key of the value to set.
 * @param {*} value The value to set.
 * @returns {Object} Returns the map cache instance.
 */
function mapCacheSet$1(key, value) {
  var data = getMapData(this, key),
      size = data.size;

  data.set(key, value);
  this.size += data.size == size ? 0 : 1;
  return this;
}

var _mapCacheSet = mapCacheSet$1;

var mapCacheClear = _mapCacheClear,
    mapCacheDelete = _mapCacheDelete,
    mapCacheGet = _mapCacheGet,
    mapCacheHas = _mapCacheHas,
    mapCacheSet = _mapCacheSet;

/**
 * Creates a map cache object to store key-value pairs.
 *
 * @private
 * @constructor
 * @param {Array} [entries] The key-value pairs to cache.
 */
function MapCache$2(entries) {
  var index = -1,
      length = entries == null ? 0 : entries.length;

  this.clear();
  while (++index < length) {
    var entry = entries[index];
    this.set(entry[0], entry[1]);
  }
}

// Add methods to `MapCache`.
MapCache$2.prototype.clear = mapCacheClear;
MapCache$2.prototype['delete'] = mapCacheDelete;
MapCache$2.prototype.get = mapCacheGet;
MapCache$2.prototype.has = mapCacheHas;
MapCache$2.prototype.set = mapCacheSet;

var _MapCache = MapCache$2;

var ListCache$1 = _ListCache,
    Map$1 = _Map,
    MapCache$1 = _MapCache;

/** Used as the size to enable large array optimizations. */
var LARGE_ARRAY_SIZE = 200;

/**
 * Sets the stack `key` to `value`.
 *
 * @private
 * @name set
 * @memberOf Stack
 * @param {string} key The key of the value to set.
 * @param {*} value The value to set.
 * @returns {Object} Returns the stack cache instance.
 */
function stackSet$1(key, value) {
  var data = this.__data__;
  if (data instanceof ListCache$1) {
    var pairs = data.__data__;
    if (!Map$1 || (pairs.length < LARGE_ARRAY_SIZE - 1)) {
      pairs.push([key, value]);
      this.size = ++data.size;
      return this;
    }
    data = this.__data__ = new MapCache$1(pairs);
  }
  data.set(key, value);
  this.size = data.size;
  return this;
}

var _stackSet = stackSet$1;

var ListCache = _ListCache,
    stackClear = _stackClear,
    stackDelete = _stackDelete,
    stackGet = _stackGet,
    stackHas = _stackHas,
    stackSet = _stackSet;

/**
 * Creates a stack cache object to store key-value pairs.
 *
 * @private
 * @constructor
 * @param {Array} [entries] The key-value pairs to cache.
 */
function Stack$2(entries) {
  var data = this.__data__ = new ListCache(entries);
  this.size = data.size;
}

// Add methods to `Stack`.
Stack$2.prototype.clear = stackClear;
Stack$2.prototype['delete'] = stackDelete;
Stack$2.prototype.get = stackGet;
Stack$2.prototype.has = stackHas;
Stack$2.prototype.set = stackSet;

var _Stack = Stack$2;

/**
 * A specialized version of `_.forEach` for arrays without support for
 * iteratee shorthands.
 *
 * @private
 * @param {Array} [array] The array to iterate over.
 * @param {Function} iteratee The function invoked per iteration.
 * @returns {Array} Returns `array`.
 */

function arrayEach$1(array, iteratee) {
  var index = -1,
      length = array == null ? 0 : array.length;

  while (++index < length) {
    if (iteratee(array[index], index, array) === false) {
      break;
    }
  }
  return array;
}

var _arrayEach = arrayEach$1;

var getNative$4 = _getNative;

var defineProperty$1 = (function() {
  try {
    var func = getNative$4(Object, 'defineProperty');
    func({}, '', {});
    return func;
  } catch (e) {}
}());

var _defineProperty = defineProperty$1;

var defineProperty = _defineProperty;

/**
 * The base implementation of `assignValue` and `assignMergeValue` without
 * value checks.
 *
 * @private
 * @param {Object} object The object to modify.
 * @param {string} key The key of the property to assign.
 * @param {*} value The value to assign.
 */
function baseAssignValue$2(object, key, value) {
  if (key == '__proto__' && defineProperty) {
    defineProperty(object, key, {
      'configurable': true,
      'enumerable': true,
      'value': value,
      'writable': true
    });
  } else {
    object[key] = value;
  }
}

var _baseAssignValue = baseAssignValue$2;

var baseAssignValue$1 = _baseAssignValue,
    eq$1 = eq_1;

/** Used for built-in method references. */
var objectProto$9 = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty$7 = objectProto$9.hasOwnProperty;

/**
 * Assigns `value` to `key` of `object` if the existing value is not equivalent
 * using [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)
 * for equality comparisons.
 *
 * @private
 * @param {Object} object The object to modify.
 * @param {string} key The key of the property to assign.
 * @param {*} value The value to assign.
 */
function assignValue$2(object, key, value) {
  var objValue = object[key];
  if (!(hasOwnProperty$7.call(object, key) && eq$1(objValue, value)) ||
      (value === undefined && !(key in object))) {
    baseAssignValue$1(object, key, value);
  }
}

var _assignValue = assignValue$2;

var assignValue$1 = _assignValue,
    baseAssignValue = _baseAssignValue;

/**
 * Copies properties of `source` to `object`.
 *
 * @private
 * @param {Object} source The object to copy properties from.
 * @param {Array} props The property identifiers to copy.
 * @param {Object} [object={}] The object to copy properties to.
 * @param {Function} [customizer] The function to customize copied values.
 * @returns {Object} Returns `object`.
 */
function copyObject$4(source, props, object, customizer) {
  var isNew = !object;
  object || (object = {});

  var index = -1,
      length = props.length;

  while (++index < length) {
    var key = props[index];

    var newValue = customizer
      ? customizer(object[key], source[key], key, object, source)
      : undefined;

    if (newValue === undefined) {
      newValue = source[key];
    }
    if (isNew) {
      baseAssignValue(object, key, newValue);
    } else {
      assignValue$1(object, key, newValue);
    }
  }
  return object;
}

var _copyObject = copyObject$4;

/**
 * The base implementation of `_.times` without support for iteratee shorthands
 * or max array length checks.
 *
 * @private
 * @param {number} n The number of times to invoke `iteratee`.
 * @param {Function} iteratee The function invoked per iteration.
 * @returns {Array} Returns the array of results.
 */

function baseTimes$1(n, iteratee) {
  var index = -1,
      result = Array(n);

  while (++index < n) {
    result[index] = iteratee(index);
  }
  return result;
}

var _baseTimes = baseTimes$1;

/**
 * Checks if `value` is object-like. A value is object-like if it's not `null`
 * and has a `typeof` result of "object".
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is object-like, else `false`.
 * @example
 *
 * _.isObjectLike({});
 * // => true
 *
 * _.isObjectLike([1, 2, 3]);
 * // => true
 *
 * _.isObjectLike(_.noop);
 * // => false
 *
 * _.isObjectLike(null);
 * // => false
 */

function isObjectLike$6(value) {
  return value != null && typeof value == 'object';
}

var isObjectLike_1 = isObjectLike$6;

var baseGetTag$2 = _baseGetTag,
    isObjectLike$5 = isObjectLike_1;

/** `Object#toString` result references. */
var argsTag$3 = '[object Arguments]';

/**
 * The base implementation of `_.isArguments`.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is an `arguments` object,
 */
function baseIsArguments$1(value) {
  return isObjectLike$5(value) && baseGetTag$2(value) == argsTag$3;
}

var _baseIsArguments = baseIsArguments$1;

var baseIsArguments = _baseIsArguments,
    isObjectLike$4 = isObjectLike_1;

/** Used for built-in method references. */
var objectProto$8 = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty$6 = objectProto$8.hasOwnProperty;

/** Built-in value references. */
var propertyIsEnumerable$1 = objectProto$8.propertyIsEnumerable;

/**
 * Checks if `value` is likely an `arguments` object.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is an `arguments` object,
 *  else `false`.
 * @example
 *
 * _.isArguments(function() { return arguments; }());
 * // => true
 *
 * _.isArguments([1, 2, 3]);
 * // => false
 */
var isArguments$1 = baseIsArguments(function() { return arguments; }()) ? baseIsArguments : function(value) {
  return isObjectLike$4(value) && hasOwnProperty$6.call(value, 'callee') &&
    !propertyIsEnumerable$1.call(value, 'callee');
};

var isArguments_1 = isArguments$1;

/**
 * Checks if `value` is classified as an `Array` object.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is an array, else `false`.
 * @example
 *
 * _.isArray([1, 2, 3]);
 * // => true
 *
 * _.isArray(document.body.children);
 * // => false
 *
 * _.isArray('abc');
 * // => false
 *
 * _.isArray(_.noop);
 * // => false
 */

var isArray$4 = Array.isArray;

var isArray_1 = isArray$4;

var isBuffer$3 = {exports: {}};

/**
 * This method returns `false`.
 *
 * @static
 * @memberOf _
 * @since 4.13.0
 * @category Util
 * @returns {boolean} Returns `false`.
 * @example
 *
 * _.times(2, _.stubFalse);
 * // => [false, false]
 */

function stubFalse() {
  return false;
}

var stubFalse_1 = stubFalse;

isBuffer$3.exports;

(function (module, exports) {
	var root = _root,
	    stubFalse = stubFalse_1;

	/** Detect free variable `exports`. */
	var freeExports = exports && !exports.nodeType && exports;

	/** Detect free variable `module`. */
	var freeModule = freeExports && 'object' == 'object' && module && !module.nodeType && module;

	/** Detect the popular CommonJS extension `module.exports`. */
	var moduleExports = freeModule && freeModule.exports === freeExports;

	/** Built-in value references. */
	var Buffer = moduleExports ? root.Buffer : undefined;

	/* Built-in method references for those with the same name as other `lodash` methods. */
	var nativeIsBuffer = Buffer ? Buffer.isBuffer : undefined;

	/**
	 * Checks if `value` is a buffer.
	 *
	 * @static
	 * @memberOf _
	 * @since 4.3.0
	 * @category Lang
	 * @param {*} value The value to check.
	 * @returns {boolean} Returns `true` if `value` is a buffer, else `false`.
	 * @example
	 *
	 * _.isBuffer(new Buffer(2));
	 * // => true
	 *
	 * _.isBuffer(new Uint8Array(2));
	 * // => false
	 */
	var isBuffer = nativeIsBuffer || stubFalse;

	module.exports = isBuffer; 
} (isBuffer$3, isBuffer$3.exports));

var isBufferExports = isBuffer$3.exports;

/** Used as references for various `Number` constants. */

var MAX_SAFE_INTEGER$1 = 9007199254740991;

/** Used to detect unsigned integer values. */
var reIsUint = /^(?:0|[1-9]\d*)$/;

/**
 * Checks if `value` is a valid array-like index.
 *
 * @private
 * @param {*} value The value to check.
 * @param {number} [length=MAX_SAFE_INTEGER] The upper bounds of a valid index.
 * @returns {boolean} Returns `true` if `value` is a valid index, else `false`.
 */
function isIndex$1(value, length) {
  var type = typeof value;
  length = length == null ? MAX_SAFE_INTEGER$1 : length;

  return !!length &&
    (type == 'number' ||
      (type != 'symbol' && reIsUint.test(value))) &&
        (value > -1 && value % 1 == 0 && value < length);
}

var _isIndex = isIndex$1;

/** Used as references for various `Number` constants. */

var MAX_SAFE_INTEGER = 9007199254740991;

/**
 * Checks if `value` is a valid array-like length.
 *
 * **Note:** This method is loosely based on
 * [`ToLength`](http://ecma-international.org/ecma-262/7.0/#sec-tolength).
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a valid length, else `false`.
 * @example
 *
 * _.isLength(3);
 * // => true
 *
 * _.isLength(Number.MIN_VALUE);
 * // => false
 *
 * _.isLength(Infinity);
 * // => false
 *
 * _.isLength('3');
 * // => false
 */
function isLength$2(value) {
  return typeof value == 'number' &&
    value > -1 && value % 1 == 0 && value <= MAX_SAFE_INTEGER;
}

var isLength_1 = isLength$2;

var baseGetTag$1 = _baseGetTag,
    isLength$1 = isLength_1,
    isObjectLike$3 = isObjectLike_1;

/** `Object#toString` result references. */
var argsTag$2 = '[object Arguments]',
    arrayTag$2 = '[object Array]',
    boolTag$3 = '[object Boolean]',
    dateTag$3 = '[object Date]',
    errorTag$2 = '[object Error]',
    funcTag$1 = '[object Function]',
    mapTag$5 = '[object Map]',
    numberTag$3 = '[object Number]',
    objectTag$3 = '[object Object]',
    regexpTag$3 = '[object RegExp]',
    setTag$5 = '[object Set]',
    stringTag$3 = '[object String]',
    weakMapTag$2 = '[object WeakMap]';

var arrayBufferTag$3 = '[object ArrayBuffer]',
    dataViewTag$4 = '[object DataView]',
    float32Tag$2 = '[object Float32Array]',
    float64Tag$2 = '[object Float64Array]',
    int8Tag$2 = '[object Int8Array]',
    int16Tag$2 = '[object Int16Array]',
    int32Tag$2 = '[object Int32Array]',
    uint8Tag$2 = '[object Uint8Array]',
    uint8ClampedTag$2 = '[object Uint8ClampedArray]',
    uint16Tag$2 = '[object Uint16Array]',
    uint32Tag$2 = '[object Uint32Array]';

/** Used to identify `toStringTag` values of typed arrays. */
var typedArrayTags = {};
typedArrayTags[float32Tag$2] = typedArrayTags[float64Tag$2] =
typedArrayTags[int8Tag$2] = typedArrayTags[int16Tag$2] =
typedArrayTags[int32Tag$2] = typedArrayTags[uint8Tag$2] =
typedArrayTags[uint8ClampedTag$2] = typedArrayTags[uint16Tag$2] =
typedArrayTags[uint32Tag$2] = true;
typedArrayTags[argsTag$2] = typedArrayTags[arrayTag$2] =
typedArrayTags[arrayBufferTag$3] = typedArrayTags[boolTag$3] =
typedArrayTags[dataViewTag$4] = typedArrayTags[dateTag$3] =
typedArrayTags[errorTag$2] = typedArrayTags[funcTag$1] =
typedArrayTags[mapTag$5] = typedArrayTags[numberTag$3] =
typedArrayTags[objectTag$3] = typedArrayTags[regexpTag$3] =
typedArrayTags[setTag$5] = typedArrayTags[stringTag$3] =
typedArrayTags[weakMapTag$2] = false;

/**
 * The base implementation of `_.isTypedArray` without Node.js optimizations.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a typed array, else `false`.
 */
function baseIsTypedArray$1(value) {
  return isObjectLike$3(value) &&
    isLength$1(value.length) && !!typedArrayTags[baseGetTag$1(value)];
}

var _baseIsTypedArray = baseIsTypedArray$1;

/**
 * The base implementation of `_.unary` without support for storing metadata.
 *
 * @private
 * @param {Function} func The function to cap arguments for.
 * @returns {Function} Returns the new capped function.
 */

function baseUnary$3(func) {
  return function(value) {
    return func(value);
  };
}

var _baseUnary = baseUnary$3;

var _nodeUtil = {exports: {}};

_nodeUtil.exports;

(function (module, exports) {
	var freeGlobal = _freeGlobal;

	/** Detect free variable `exports`. */
	var freeExports = exports && !exports.nodeType && exports;

	/** Detect free variable `module`. */
	var freeModule = freeExports && 'object' == 'object' && module && !module.nodeType && module;

	/** Detect the popular CommonJS extension `module.exports`. */
	var moduleExports = freeModule && freeModule.exports === freeExports;

	/** Detect free variable `process` from Node.js. */
	var freeProcess = moduleExports && freeGlobal.process;

	/** Used to access faster Node.js helpers. */
	var nodeUtil = (function() {
	  try {
	    // Use `util.types` for Node.js 10+.
	    var types = freeModule && freeModule.require && freeModule.require('util').types;

	    if (types) {
	      return types;
	    }

	    // Legacy `process.binding('util')` for Node.js < 10.
	    return freeProcess && freeProcess.binding && freeProcess.binding('util');
	  } catch (e) {}
	}());

	module.exports = nodeUtil; 
} (_nodeUtil, _nodeUtil.exports));

var _nodeUtilExports = _nodeUtil.exports;

var baseIsTypedArray = _baseIsTypedArray,
    baseUnary$2 = _baseUnary,
    nodeUtil$2 = _nodeUtilExports;

/* Node.js helper references. */
var nodeIsTypedArray = nodeUtil$2 && nodeUtil$2.isTypedArray;

/**
 * Checks if `value` is classified as a typed array.
 *
 * @static
 * @memberOf _
 * @since 3.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a typed array, else `false`.
 * @example
 *
 * _.isTypedArray(new Uint8Array);
 * // => true
 *
 * _.isTypedArray([]);
 * // => false
 */
var isTypedArray$2 = nodeIsTypedArray ? baseUnary$2(nodeIsTypedArray) : baseIsTypedArray;

var isTypedArray_1 = isTypedArray$2;

var baseTimes = _baseTimes,
    isArguments = isArguments_1,
    isArray$3 = isArray_1,
    isBuffer$2 = isBufferExports,
    isIndex = _isIndex,
    isTypedArray$1 = isTypedArray_1;

/** Used for built-in method references. */
var objectProto$7 = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty$5 = objectProto$7.hasOwnProperty;

/**
 * Creates an array of the enumerable property names of the array-like `value`.
 *
 * @private
 * @param {*} value The value to query.
 * @param {boolean} inherited Specify returning inherited property names.
 * @returns {Array} Returns the array of property names.
 */
function arrayLikeKeys$2(value, inherited) {
  var isArr = isArray$3(value),
      isArg = !isArr && isArguments(value),
      isBuff = !isArr && !isArg && isBuffer$2(value),
      isType = !isArr && !isArg && !isBuff && isTypedArray$1(value),
      skipIndexes = isArr || isArg || isBuff || isType,
      result = skipIndexes ? baseTimes(value.length, String) : [],
      length = result.length;

  for (var key in value) {
    if ((inherited || hasOwnProperty$5.call(value, key)) &&
        !(skipIndexes && (
           // Safari 9 has enumerable `arguments.length` in strict mode.
           key == 'length' ||
           // Node.js 0.10 has enumerable non-index properties on buffers.
           (isBuff && (key == 'offset' || key == 'parent')) ||
           // PhantomJS 2 has enumerable non-index properties on typed arrays.
           (isType && (key == 'buffer' || key == 'byteLength' || key == 'byteOffset')) ||
           // Skip index properties.
           isIndex(key, length)
        ))) {
      result.push(key);
    }
  }
  return result;
}

var _arrayLikeKeys = arrayLikeKeys$2;

/** Used for built-in method references. */

var objectProto$6 = Object.prototype;

/**
 * Checks if `value` is likely a prototype object.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a prototype, else `false`.
 */
function isPrototype$3(value) {
  var Ctor = value && value.constructor,
      proto = (typeof Ctor == 'function' && Ctor.prototype) || objectProto$6;

  return value === proto;
}

var _isPrototype = isPrototype$3;

/**
 * Creates a unary function that invokes `func` with its argument transformed.
 *
 * @private
 * @param {Function} func The function to wrap.
 * @param {Function} transform The argument transform.
 * @returns {Function} Returns the new function.
 */

function overArg$2(func, transform) {
  return function(arg) {
    return func(transform(arg));
  };
}

var _overArg = overArg$2;

var overArg$1 = _overArg;

/* Built-in method references for those with the same name as other `lodash` methods. */
var nativeKeys$1 = overArg$1(Object.keys, Object);

var _nativeKeys = nativeKeys$1;

var isPrototype$2 = _isPrototype,
    nativeKeys = _nativeKeys;

/** Used for built-in method references. */
var objectProto$5 = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty$4 = objectProto$5.hasOwnProperty;

/**
 * The base implementation of `_.keys` which doesn't treat sparse arrays as dense.
 *
 * @private
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of property names.
 */
function baseKeys$1(object) {
  if (!isPrototype$2(object)) {
    return nativeKeys(object);
  }
  var result = [];
  for (var key in Object(object)) {
    if (hasOwnProperty$4.call(object, key) && key != 'constructor') {
      result.push(key);
    }
  }
  return result;
}

var _baseKeys = baseKeys$1;

var isFunction = isFunction_1,
    isLength = isLength_1;

/**
 * Checks if `value` is array-like. A value is considered array-like if it's
 * not a function and has a `value.length` that's an integer greater than or
 * equal to `0` and less than or equal to `Number.MAX_SAFE_INTEGER`.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is array-like, else `false`.
 * @example
 *
 * _.isArrayLike([1, 2, 3]);
 * // => true
 *
 * _.isArrayLike(document.body.children);
 * // => true
 *
 * _.isArrayLike('abc');
 * // => true
 *
 * _.isArrayLike(_.noop);
 * // => false
 */
function isArrayLike$2(value) {
  return value != null && isLength(value.length) && !isFunction(value);
}

var isArrayLike_1 = isArrayLike$2;

var arrayLikeKeys$1 = _arrayLikeKeys,
    baseKeys = _baseKeys,
    isArrayLike$1 = isArrayLike_1;

/**
 * Creates an array of the own enumerable property names of `object`.
 *
 * **Note:** Non-object values are coerced to objects. See the
 * [ES spec](http://ecma-international.org/ecma-262/7.0/#sec-object.keys)
 * for more details.
 *
 * @static
 * @since 0.1.0
 * @memberOf _
 * @category Object
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of property names.
 * @example
 *
 * function Foo() {
 *   this.a = 1;
 *   this.b = 2;
 * }
 *
 * Foo.prototype.c = 3;
 *
 * _.keys(new Foo);
 * // => ['a', 'b'] (iteration order is not guaranteed)
 *
 * _.keys('hi');
 * // => ['0', '1']
 */
function keys$3(object) {
  return isArrayLike$1(object) ? arrayLikeKeys$1(object) : baseKeys(object);
}

var keys_1 = keys$3;

var copyObject$3 = _copyObject,
    keys$2 = keys_1;

/**
 * The base implementation of `_.assign` without support for multiple sources
 * or `customizer` functions.
 *
 * @private
 * @param {Object} object The destination object.
 * @param {Object} source The source object.
 * @returns {Object} Returns `object`.
 */
function baseAssign$1(object, source) {
  return object && copyObject$3(source, keys$2(source), object);
}

var _baseAssign = baseAssign$1;

/**
 * This function is like
 * [`Object.keys`](http://ecma-international.org/ecma-262/7.0/#sec-object.keys)
 * except that it includes inherited enumerable properties.
 *
 * @private
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of property names.
 */

function nativeKeysIn$1(object) {
  var result = [];
  if (object != null) {
    for (var key in Object(object)) {
      result.push(key);
    }
  }
  return result;
}

var _nativeKeysIn = nativeKeysIn$1;

var isObject$2 = isObject_1,
    isPrototype$1 = _isPrototype,
    nativeKeysIn = _nativeKeysIn;

/** Used for built-in method references. */
var objectProto$4 = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty$3 = objectProto$4.hasOwnProperty;

/**
 * The base implementation of `_.keysIn` which doesn't treat sparse arrays as dense.
 *
 * @private
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of property names.
 */
function baseKeysIn$1(object) {
  if (!isObject$2(object)) {
    return nativeKeysIn(object);
  }
  var isProto = isPrototype$1(object),
      result = [];

  for (var key in object) {
    if (!(key == 'constructor' && (isProto || !hasOwnProperty$3.call(object, key)))) {
      result.push(key);
    }
  }
  return result;
}

var _baseKeysIn = baseKeysIn$1;

var arrayLikeKeys = _arrayLikeKeys,
    baseKeysIn = _baseKeysIn,
    isArrayLike = isArrayLike_1;

/**
 * Creates an array of the own and inherited enumerable property names of `object`.
 *
 * **Note:** Non-object values are coerced to objects.
 *
 * @static
 * @memberOf _
 * @since 3.0.0
 * @category Object
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of property names.
 * @example
 *
 * function Foo() {
 *   this.a = 1;
 *   this.b = 2;
 * }
 *
 * Foo.prototype.c = 3;
 *
 * _.keysIn(new Foo);
 * // => ['a', 'b', 'c'] (iteration order is not guaranteed)
 */
function keysIn$3(object) {
  return isArrayLike(object) ? arrayLikeKeys(object, true) : baseKeysIn(object);
}

var keysIn_1 = keysIn$3;

var copyObject$2 = _copyObject,
    keysIn$2 = keysIn_1;

/**
 * The base implementation of `_.assignIn` without support for multiple sources
 * or `customizer` functions.
 *
 * @private
 * @param {Object} object The destination object.
 * @param {Object} source The source object.
 * @returns {Object} Returns `object`.
 */
function baseAssignIn$1(object, source) {
  return object && copyObject$2(source, keysIn$2(source), object);
}

var _baseAssignIn = baseAssignIn$1;

var _cloneBuffer = {exports: {}};

_cloneBuffer.exports;

(function (module, exports) {
	var root = _root;

	/** Detect free variable `exports`. */
	var freeExports = exports && !exports.nodeType && exports;

	/** Detect free variable `module`. */
	var freeModule = freeExports && 'object' == 'object' && module && !module.nodeType && module;

	/** Detect the popular CommonJS extension `module.exports`. */
	var moduleExports = freeModule && freeModule.exports === freeExports;

	/** Built-in value references. */
	var Buffer = moduleExports ? root.Buffer : undefined,
	    allocUnsafe = Buffer ? Buffer.allocUnsafe : undefined;

	/**
	 * Creates a clone of  `buffer`.
	 *
	 * @private
	 * @param {Buffer} buffer The buffer to clone.
	 * @param {boolean} [isDeep] Specify a deep clone.
	 * @returns {Buffer} Returns the cloned buffer.
	 */
	function cloneBuffer(buffer, isDeep) {
	  if (isDeep) {
	    return buffer.slice();
	  }
	  var length = buffer.length,
	      result = allocUnsafe ? allocUnsafe(length) : new buffer.constructor(length);

	  buffer.copy(result);
	  return result;
	}

	module.exports = cloneBuffer; 
} (_cloneBuffer, _cloneBuffer.exports));

var _cloneBufferExports = _cloneBuffer.exports;

/**
 * Copies the values of `source` to `array`.
 *
 * @private
 * @param {Array} source The array to copy values from.
 * @param {Array} [array=[]] The array to copy values to.
 * @returns {Array} Returns `array`.
 */

function copyArray$1(source, array) {
  var index = -1,
      length = source.length;

  array || (array = Array(length));
  while (++index < length) {
    array[index] = source[index];
  }
  return array;
}

var _copyArray = copyArray$1;

/**
 * A specialized version of `_.filter` for arrays without support for
 * iteratee shorthands.
 *
 * @private
 * @param {Array} [array] The array to iterate over.
 * @param {Function} predicate The function invoked per iteration.
 * @returns {Array} Returns the new filtered array.
 */

function arrayFilter$1(array, predicate) {
  var index = -1,
      length = array == null ? 0 : array.length,
      resIndex = 0,
      result = [];

  while (++index < length) {
    var value = array[index];
    if (predicate(value, index, array)) {
      result[resIndex++] = value;
    }
  }
  return result;
}

var _arrayFilter = arrayFilter$1;

/**
 * This method returns a new empty array.
 *
 * @static
 * @memberOf _
 * @since 4.13.0
 * @category Util
 * @returns {Array} Returns the new empty array.
 * @example
 *
 * var arrays = _.times(2, _.stubArray);
 *
 * console.log(arrays);
 * // => [[], []]
 *
 * console.log(arrays[0] === arrays[1]);
 * // => false
 */

function stubArray$2() {
  return [];
}

var stubArray_1 = stubArray$2;

var arrayFilter = _arrayFilter,
    stubArray$1 = stubArray_1;

/** Used for built-in method references. */
var objectProto$3 = Object.prototype;

/** Built-in value references. */
var propertyIsEnumerable = objectProto$3.propertyIsEnumerable;

/* Built-in method references for those with the same name as other `lodash` methods. */
var nativeGetSymbols$1 = Object.getOwnPropertySymbols;

/**
 * Creates an array of the own enumerable symbols of `object`.
 *
 * @private
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of symbols.
 */
var getSymbols$3 = !nativeGetSymbols$1 ? stubArray$1 : function(object) {
  if (object == null) {
    return [];
  }
  object = Object(object);
  return arrayFilter(nativeGetSymbols$1(object), function(symbol) {
    return propertyIsEnumerable.call(object, symbol);
  });
};

var _getSymbols = getSymbols$3;

var copyObject$1 = _copyObject,
    getSymbols$2 = _getSymbols;

/**
 * Copies own symbols of `source` to `object`.
 *
 * @private
 * @param {Object} source The object to copy symbols from.
 * @param {Object} [object={}] The object to copy symbols to.
 * @returns {Object} Returns `object`.
 */
function copySymbols$1(source, object) {
  return copyObject$1(source, getSymbols$2(source), object);
}

var _copySymbols = copySymbols$1;

/**
 * Appends the elements of `values` to `array`.
 *
 * @private
 * @param {Array} array The array to modify.
 * @param {Array} values The values to append.
 * @returns {Array} Returns `array`.
 */

function arrayPush$2(array, values) {
  var index = -1,
      length = values.length,
      offset = array.length;

  while (++index < length) {
    array[offset + index] = values[index];
  }
  return array;
}

var _arrayPush = arrayPush$2;

var overArg = _overArg;

/** Built-in value references. */
var getPrototype$2 = overArg(Object.getPrototypeOf, Object);

var _getPrototype = getPrototype$2;

var arrayPush$1 = _arrayPush,
    getPrototype$1 = _getPrototype,
    getSymbols$1 = _getSymbols,
    stubArray = stubArray_1;

/* Built-in method references for those with the same name as other `lodash` methods. */
var nativeGetSymbols = Object.getOwnPropertySymbols;

/**
 * Creates an array of the own and inherited enumerable symbols of `object`.
 *
 * @private
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of symbols.
 */
var getSymbolsIn$2 = !nativeGetSymbols ? stubArray : function(object) {
  var result = [];
  while (object) {
    arrayPush$1(result, getSymbols$1(object));
    object = getPrototype$1(object);
  }
  return result;
};

var _getSymbolsIn = getSymbolsIn$2;

var copyObject = _copyObject,
    getSymbolsIn$1 = _getSymbolsIn;

/**
 * Copies own and inherited symbols of `source` to `object`.
 *
 * @private
 * @param {Object} source The object to copy symbols from.
 * @param {Object} [object={}] The object to copy symbols to.
 * @returns {Object} Returns `object`.
 */
function copySymbolsIn$1(source, object) {
  return copyObject(source, getSymbolsIn$1(source), object);
}

var _copySymbolsIn = copySymbolsIn$1;

var arrayPush = _arrayPush,
    isArray$2 = isArray_1;

/**
 * The base implementation of `getAllKeys` and `getAllKeysIn` which uses
 * `keysFunc` and `symbolsFunc` to get the enumerable property names and
 * symbols of `object`.
 *
 * @private
 * @param {Object} object The object to query.
 * @param {Function} keysFunc The function to get the keys of `object`.
 * @param {Function} symbolsFunc The function to get the symbols of `object`.
 * @returns {Array} Returns the array of property names and symbols.
 */
function baseGetAllKeys$2(object, keysFunc, symbolsFunc) {
  var result = keysFunc(object);
  return isArray$2(object) ? result : arrayPush(result, symbolsFunc(object));
}

var _baseGetAllKeys = baseGetAllKeys$2;

var baseGetAllKeys$1 = _baseGetAllKeys,
    getSymbols = _getSymbols,
    keys$1 = keys_1;

/**
 * Creates an array of own enumerable property names and symbols of `object`.
 *
 * @private
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of property names and symbols.
 */
function getAllKeys$2(object) {
  return baseGetAllKeys$1(object, keys$1, getSymbols);
}

var _getAllKeys = getAllKeys$2;

var baseGetAllKeys = _baseGetAllKeys,
    getSymbolsIn = _getSymbolsIn,
    keysIn$1 = keysIn_1;

/**
 * Creates an array of own and inherited enumerable property names and
 * symbols of `object`.
 *
 * @private
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of property names and symbols.
 */
function getAllKeysIn$1(object) {
  return baseGetAllKeys(object, keysIn$1, getSymbolsIn);
}

var _getAllKeysIn = getAllKeysIn$1;

var getNative$3 = _getNative,
    root$4 = _root;

/* Built-in method references that are verified to be native. */
var DataView$1 = getNative$3(root$4, 'DataView');

var _DataView = DataView$1;

var getNative$2 = _getNative,
    root$3 = _root;

/* Built-in method references that are verified to be native. */
var Promise$2 = getNative$2(root$3, 'Promise');

var _Promise = Promise$2;

var getNative$1 = _getNative,
    root$2 = _root;

/* Built-in method references that are verified to be native. */
var Set$1 = getNative$1(root$2, 'Set');

var _Set = Set$1;

var getNative = _getNative,
    root$1 = _root;

/* Built-in method references that are verified to be native. */
var WeakMap$1 = getNative(root$1, 'WeakMap');

var _WeakMap = WeakMap$1;

var DataView = _DataView,
    Map = _Map,
    Promise$1 = _Promise,
    Set = _Set,
    WeakMap = _WeakMap,
    baseGetTag = _baseGetTag,
    toSource = _toSource;

/** `Object#toString` result references. */
var mapTag$4 = '[object Map]',
    objectTag$2 = '[object Object]',
    promiseTag = '[object Promise]',
    setTag$4 = '[object Set]',
    weakMapTag$1 = '[object WeakMap]';

var dataViewTag$3 = '[object DataView]';

/** Used to detect maps, sets, and weakmaps. */
var dataViewCtorString = toSource(DataView),
    mapCtorString = toSource(Map),
    promiseCtorString = toSource(Promise$1),
    setCtorString = toSource(Set),
    weakMapCtorString = toSource(WeakMap);

/**
 * Gets the `toStringTag` of `value`.
 *
 * @private
 * @param {*} value The value to query.
 * @returns {string} Returns the `toStringTag`.
 */
var getTag$4 = baseGetTag;

// Fallback for data views, maps, sets, and weak maps in IE 11 and promises in Node.js < 6.
if ((DataView && getTag$4(new DataView(new ArrayBuffer(1))) != dataViewTag$3) ||
    (Map && getTag$4(new Map) != mapTag$4) ||
    (Promise$1 && getTag$4(Promise$1.resolve()) != promiseTag) ||
    (Set && getTag$4(new Set) != setTag$4) ||
    (WeakMap && getTag$4(new WeakMap) != weakMapTag$1)) {
  getTag$4 = function(value) {
    var result = baseGetTag(value),
        Ctor = result == objectTag$2 ? value.constructor : undefined,
        ctorString = Ctor ? toSource(Ctor) : '';

    if (ctorString) {
      switch (ctorString) {
        case dataViewCtorString: return dataViewTag$3;
        case mapCtorString: return mapTag$4;
        case promiseCtorString: return promiseTag;
        case setCtorString: return setTag$4;
        case weakMapCtorString: return weakMapTag$1;
      }
    }
    return result;
  };
}

var _getTag = getTag$4;

/** Used for built-in method references. */

var objectProto$2 = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty$2 = objectProto$2.hasOwnProperty;

/**
 * Initializes an array clone.
 *
 * @private
 * @param {Array} array The array to clone.
 * @returns {Array} Returns the initialized clone.
 */
function initCloneArray$1(array) {
  var length = array.length,
      result = new array.constructor(length);

  // Add properties assigned by `RegExp#exec`.
  if (length && typeof array[0] == 'string' && hasOwnProperty$2.call(array, 'index')) {
    result.index = array.index;
    result.input = array.input;
  }
  return result;
}

var _initCloneArray = initCloneArray$1;

var root = _root;

/** Built-in value references. */
var Uint8Array$2 = root.Uint8Array;

var _Uint8Array = Uint8Array$2;

var Uint8Array$1 = _Uint8Array;

/**
 * Creates a clone of `arrayBuffer`.
 *
 * @private
 * @param {ArrayBuffer} arrayBuffer The array buffer to clone.
 * @returns {ArrayBuffer} Returns the cloned array buffer.
 */
function cloneArrayBuffer$3(arrayBuffer) {
  var result = new arrayBuffer.constructor(arrayBuffer.byteLength);
  new Uint8Array$1(result).set(new Uint8Array$1(arrayBuffer));
  return result;
}

var _cloneArrayBuffer = cloneArrayBuffer$3;

var cloneArrayBuffer$2 = _cloneArrayBuffer;

/**
 * Creates a clone of `dataView`.
 *
 * @private
 * @param {Object} dataView The data view to clone.
 * @param {boolean} [isDeep] Specify a deep clone.
 * @returns {Object} Returns the cloned data view.
 */
function cloneDataView$1(dataView, isDeep) {
  var buffer = isDeep ? cloneArrayBuffer$2(dataView.buffer) : dataView.buffer;
  return new dataView.constructor(buffer, dataView.byteOffset, dataView.byteLength);
}

var _cloneDataView = cloneDataView$1;

/** Used to match `RegExp` flags from their coerced string values. */

var reFlags = /\w*$/;

/**
 * Creates a clone of `regexp`.
 *
 * @private
 * @param {Object} regexp The regexp to clone.
 * @returns {Object} Returns the cloned regexp.
 */
function cloneRegExp$1(regexp) {
  var result = new regexp.constructor(regexp.source, reFlags.exec(regexp));
  result.lastIndex = regexp.lastIndex;
  return result;
}

var _cloneRegExp = cloneRegExp$1;

var Symbol$1 = _Symbol;

/** Used to convert symbols to primitives and strings. */
var symbolProto$1 = Symbol$1 ? Symbol$1.prototype : undefined,
    symbolValueOf$1 = symbolProto$1 ? symbolProto$1.valueOf : undefined;

/**
 * Creates a clone of the `symbol` object.
 *
 * @private
 * @param {Object} symbol The symbol object to clone.
 * @returns {Object} Returns the cloned symbol object.
 */
function cloneSymbol$1(symbol) {
  return symbolValueOf$1 ? Object(symbolValueOf$1.call(symbol)) : {};
}

var _cloneSymbol = cloneSymbol$1;

var cloneArrayBuffer$1 = _cloneArrayBuffer;

/**
 * Creates a clone of `typedArray`.
 *
 * @private
 * @param {Object} typedArray The typed array to clone.
 * @param {boolean} [isDeep] Specify a deep clone.
 * @returns {Object} Returns the cloned typed array.
 */
function cloneTypedArray$1(typedArray, isDeep) {
  var buffer = isDeep ? cloneArrayBuffer$1(typedArray.buffer) : typedArray.buffer;
  return new typedArray.constructor(buffer, typedArray.byteOffset, typedArray.length);
}

var _cloneTypedArray = cloneTypedArray$1;

var cloneArrayBuffer = _cloneArrayBuffer,
    cloneDataView = _cloneDataView,
    cloneRegExp = _cloneRegExp,
    cloneSymbol = _cloneSymbol,
    cloneTypedArray = _cloneTypedArray;

/** `Object#toString` result references. */
var boolTag$2 = '[object Boolean]',
    dateTag$2 = '[object Date]',
    mapTag$3 = '[object Map]',
    numberTag$2 = '[object Number]',
    regexpTag$2 = '[object RegExp]',
    setTag$3 = '[object Set]',
    stringTag$2 = '[object String]',
    symbolTag$2 = '[object Symbol]';

var arrayBufferTag$2 = '[object ArrayBuffer]',
    dataViewTag$2 = '[object DataView]',
    float32Tag$1 = '[object Float32Array]',
    float64Tag$1 = '[object Float64Array]',
    int8Tag$1 = '[object Int8Array]',
    int16Tag$1 = '[object Int16Array]',
    int32Tag$1 = '[object Int32Array]',
    uint8Tag$1 = '[object Uint8Array]',
    uint8ClampedTag$1 = '[object Uint8ClampedArray]',
    uint16Tag$1 = '[object Uint16Array]',
    uint32Tag$1 = '[object Uint32Array]';

/**
 * Initializes an object clone based on its `toStringTag`.
 *
 * **Note:** This function only supports cloning values with tags of
 * `Boolean`, `Date`, `Error`, `Map`, `Number`, `RegExp`, `Set`, or `String`.
 *
 * @private
 * @param {Object} object The object to clone.
 * @param {string} tag The `toStringTag` of the object to clone.
 * @param {boolean} [isDeep] Specify a deep clone.
 * @returns {Object} Returns the initialized clone.
 */
function initCloneByTag$1(object, tag, isDeep) {
  var Ctor = object.constructor;
  switch (tag) {
    case arrayBufferTag$2:
      return cloneArrayBuffer(object);

    case boolTag$2:
    case dateTag$2:
      return new Ctor(+object);

    case dataViewTag$2:
      return cloneDataView(object, isDeep);

    case float32Tag$1: case float64Tag$1:
    case int8Tag$1: case int16Tag$1: case int32Tag$1:
    case uint8Tag$1: case uint8ClampedTag$1: case uint16Tag$1: case uint32Tag$1:
      return cloneTypedArray(object, isDeep);

    case mapTag$3:
      return new Ctor;

    case numberTag$2:
    case stringTag$2:
      return new Ctor(object);

    case regexpTag$2:
      return cloneRegExp(object);

    case setTag$3:
      return new Ctor;

    case symbolTag$2:
      return cloneSymbol(object);
  }
}

var _initCloneByTag = initCloneByTag$1;

var isObject$1 = isObject_1;

/** Built-in value references. */
var objectCreate = Object.create;

/**
 * The base implementation of `_.create` without support for assigning
 * properties to the created object.
 *
 * @private
 * @param {Object} proto The object to inherit from.
 * @returns {Object} Returns the new object.
 */
var baseCreate$1 = (function() {
  function object() {}
  return function(proto) {
    if (!isObject$1(proto)) {
      return {};
    }
    if (objectCreate) {
      return objectCreate(proto);
    }
    object.prototype = proto;
    var result = new object;
    object.prototype = undefined;
    return result;
  };
}());

var _baseCreate = baseCreate$1;

var baseCreate = _baseCreate,
    getPrototype = _getPrototype,
    isPrototype = _isPrototype;

/**
 * Initializes an object clone.
 *
 * @private
 * @param {Object} object The object to clone.
 * @returns {Object} Returns the initialized clone.
 */
function initCloneObject$1(object) {
  return (typeof object.constructor == 'function' && !isPrototype(object))
    ? baseCreate(getPrototype(object))
    : {};
}

var _initCloneObject = initCloneObject$1;

var getTag$3 = _getTag,
    isObjectLike$2 = isObjectLike_1;

/** `Object#toString` result references. */
var mapTag$2 = '[object Map]';

/**
 * The base implementation of `_.isMap` without Node.js optimizations.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a map, else `false`.
 */
function baseIsMap$1(value) {
  return isObjectLike$2(value) && getTag$3(value) == mapTag$2;
}

var _baseIsMap = baseIsMap$1;

var baseIsMap = _baseIsMap,
    baseUnary$1 = _baseUnary,
    nodeUtil$1 = _nodeUtilExports;

/* Node.js helper references. */
var nodeIsMap = nodeUtil$1 && nodeUtil$1.isMap;

/**
 * Checks if `value` is classified as a `Map` object.
 *
 * @static
 * @memberOf _
 * @since 4.3.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a map, else `false`.
 * @example
 *
 * _.isMap(new Map);
 * // => true
 *
 * _.isMap(new WeakMap);
 * // => false
 */
var isMap$1 = nodeIsMap ? baseUnary$1(nodeIsMap) : baseIsMap;

var isMap_1 = isMap$1;

var getTag$2 = _getTag,
    isObjectLike$1 = isObjectLike_1;

/** `Object#toString` result references. */
var setTag$2 = '[object Set]';

/**
 * The base implementation of `_.isSet` without Node.js optimizations.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a set, else `false`.
 */
function baseIsSet$1(value) {
  return isObjectLike$1(value) && getTag$2(value) == setTag$2;
}

var _baseIsSet = baseIsSet$1;

var baseIsSet = _baseIsSet,
    baseUnary = _baseUnary,
    nodeUtil = _nodeUtilExports;

/* Node.js helper references. */
var nodeIsSet = nodeUtil && nodeUtil.isSet;

/**
 * Checks if `value` is classified as a `Set` object.
 *
 * @static
 * @memberOf _
 * @since 4.3.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a set, else `false`.
 * @example
 *
 * _.isSet(new Set);
 * // => true
 *
 * _.isSet(new WeakSet);
 * // => false
 */
var isSet$1 = nodeIsSet ? baseUnary(nodeIsSet) : baseIsSet;

var isSet_1 = isSet$1;

var Stack$1 = _Stack,
    arrayEach = _arrayEach,
    assignValue = _assignValue,
    baseAssign = _baseAssign,
    baseAssignIn = _baseAssignIn,
    cloneBuffer = _cloneBufferExports,
    copyArray = _copyArray,
    copySymbols = _copySymbols,
    copySymbolsIn = _copySymbolsIn,
    getAllKeys$1 = _getAllKeys,
    getAllKeysIn = _getAllKeysIn,
    getTag$1 = _getTag,
    initCloneArray = _initCloneArray,
    initCloneByTag = _initCloneByTag,
    initCloneObject = _initCloneObject,
    isArray$1 = isArray_1,
    isBuffer$1 = isBufferExports,
    isMap = isMap_1,
    isObject = isObject_1,
    isSet = isSet_1,
    keys = keys_1,
    keysIn = keysIn_1;

/** Used to compose bitmasks for cloning. */
var CLONE_DEEP_FLAG$2 = 1,
    CLONE_FLAT_FLAG = 2,
    CLONE_SYMBOLS_FLAG$2 = 4;

/** `Object#toString` result references. */
var argsTag$1 = '[object Arguments]',
    arrayTag$1 = '[object Array]',
    boolTag$1 = '[object Boolean]',
    dateTag$1 = '[object Date]',
    errorTag$1 = '[object Error]',
    funcTag = '[object Function]',
    genTag = '[object GeneratorFunction]',
    mapTag$1 = '[object Map]',
    numberTag$1 = '[object Number]',
    objectTag$1 = '[object Object]',
    regexpTag$1 = '[object RegExp]',
    setTag$1 = '[object Set]',
    stringTag$1 = '[object String]',
    symbolTag$1 = '[object Symbol]',
    weakMapTag = '[object WeakMap]';

var arrayBufferTag$1 = '[object ArrayBuffer]',
    dataViewTag$1 = '[object DataView]',
    float32Tag = '[object Float32Array]',
    float64Tag = '[object Float64Array]',
    int8Tag = '[object Int8Array]',
    int16Tag = '[object Int16Array]',
    int32Tag = '[object Int32Array]',
    uint8Tag = '[object Uint8Array]',
    uint8ClampedTag = '[object Uint8ClampedArray]',
    uint16Tag = '[object Uint16Array]',
    uint32Tag = '[object Uint32Array]';

/** Used to identify `toStringTag` values supported by `_.clone`. */
var cloneableTags = {};
cloneableTags[argsTag$1] = cloneableTags[arrayTag$1] =
cloneableTags[arrayBufferTag$1] = cloneableTags[dataViewTag$1] =
cloneableTags[boolTag$1] = cloneableTags[dateTag$1] =
cloneableTags[float32Tag] = cloneableTags[float64Tag] =
cloneableTags[int8Tag] = cloneableTags[int16Tag] =
cloneableTags[int32Tag] = cloneableTags[mapTag$1] =
cloneableTags[numberTag$1] = cloneableTags[objectTag$1] =
cloneableTags[regexpTag$1] = cloneableTags[setTag$1] =
cloneableTags[stringTag$1] = cloneableTags[symbolTag$1] =
cloneableTags[uint8Tag] = cloneableTags[uint8ClampedTag] =
cloneableTags[uint16Tag] = cloneableTags[uint32Tag] = true;
cloneableTags[errorTag$1] = cloneableTags[funcTag] =
cloneableTags[weakMapTag] = false;

/**
 * The base implementation of `_.clone` and `_.cloneDeep` which tracks
 * traversed objects.
 *
 * @private
 * @param {*} value The value to clone.
 * @param {boolean} bitmask The bitmask flags.
 *  1 - Deep clone
 *  2 - Flatten inherited properties
 *  4 - Clone symbols
 * @param {Function} [customizer] The function to customize cloning.
 * @param {string} [key] The key of `value`.
 * @param {Object} [object] The parent object of `value`.
 * @param {Object} [stack] Tracks traversed objects and their clone counterparts.
 * @returns {*} Returns the cloned value.
 */
function baseClone$2(value, bitmask, customizer, key, object, stack) {
  var result,
      isDeep = bitmask & CLONE_DEEP_FLAG$2,
      isFlat = bitmask & CLONE_FLAT_FLAG,
      isFull = bitmask & CLONE_SYMBOLS_FLAG$2;

  if (customizer) {
    result = object ? customizer(value, key, object, stack) : customizer(value);
  }
  if (result !== undefined) {
    return result;
  }
  if (!isObject(value)) {
    return value;
  }
  var isArr = isArray$1(value);
  if (isArr) {
    result = initCloneArray(value);
    if (!isDeep) {
      return copyArray(value, result);
    }
  } else {
    var tag = getTag$1(value),
        isFunc = tag == funcTag || tag == genTag;

    if (isBuffer$1(value)) {
      return cloneBuffer(value, isDeep);
    }
    if (tag == objectTag$1 || tag == argsTag$1 || (isFunc && !object)) {
      result = (isFlat || isFunc) ? {} : initCloneObject(value);
      if (!isDeep) {
        return isFlat
          ? copySymbolsIn(value, baseAssignIn(result, value))
          : copySymbols(value, baseAssign(result, value));
      }
    } else {
      if (!cloneableTags[tag]) {
        return object ? value : {};
      }
      result = initCloneByTag(value, tag, isDeep);
    }
  }
  // Check for circular references and return its corresponding clone.
  stack || (stack = new Stack$1);
  var stacked = stack.get(value);
  if (stacked) {
    return stacked;
  }
  stack.set(value, result);

  if (isSet(value)) {
    value.forEach(function(subValue) {
      result.add(baseClone$2(subValue, bitmask, customizer, subValue, value, stack));
    });
  } else if (isMap(value)) {
    value.forEach(function(subValue, key) {
      result.set(key, baseClone$2(subValue, bitmask, customizer, key, value, stack));
    });
  }

  var keysFunc = isFull
    ? (isFlat ? getAllKeysIn : getAllKeys$1)
    : (isFlat ? keysIn : keys);

  var props = isArr ? undefined : keysFunc(value);
  arrayEach(props || value, function(subValue, key) {
    if (props) {
      key = subValue;
      subValue = value[key];
    }
    // Recursively populate clone (susceptible to call stack limits).
    assignValue(result, key, baseClone$2(subValue, bitmask, customizer, key, value, stack));
  });
  return result;
}

var _baseClone = baseClone$2;

var baseClone$1 = _baseClone;

/** Used to compose bitmasks for cloning. */
var CLONE_DEEP_FLAG$1 = 1,
    CLONE_SYMBOLS_FLAG$1 = 4;

/**
 * This method is like `_.clone` except that it recursively clones `value`.
 *
 * @static
 * @memberOf _
 * @since 1.0.0
 * @category Lang
 * @param {*} value The value to recursively clone.
 * @returns {*} Returns the deep cloned value.
 * @see _.clone
 * @example
 *
 * var objects = [{ 'a': 1 }, { 'b': 2 }];
 *
 * var deep = _.cloneDeep(objects);
 * console.log(deep[0] === objects[0]);
 * // => false
 */
function cloneDeep(value) {
  return baseClone$1(value, CLONE_DEEP_FLAG$1 | CLONE_SYMBOLS_FLAG$1);
}

var cloneDeep_1 = cloneDeep;

var cloneDeep$1 = /*@__PURE__*/getDefaultExportFromCjs(cloneDeep_1);

/** Used to stand-in for `undefined` hash values. */

var HASH_UNDEFINED = '__lodash_hash_undefined__';

/**
 * Adds `value` to the array cache.
 *
 * @private
 * @name add
 * @memberOf SetCache
 * @alias push
 * @param {*} value The value to cache.
 * @returns {Object} Returns the cache instance.
 */
function setCacheAdd$1(value) {
  this.__data__.set(value, HASH_UNDEFINED);
  return this;
}

var _setCacheAdd = setCacheAdd$1;

/**
 * Checks if `value` is in the array cache.
 *
 * @private
 * @name has
 * @memberOf SetCache
 * @param {*} value The value to search for.
 * @returns {number} Returns `true` if `value` is found, else `false`.
 */

function setCacheHas$1(value) {
  return this.__data__.has(value);
}

var _setCacheHas = setCacheHas$1;

var MapCache = _MapCache,
    setCacheAdd = _setCacheAdd,
    setCacheHas = _setCacheHas;

/**
 *
 * Creates an array cache object to store unique values.
 *
 * @private
 * @constructor
 * @param {Array} [values] The values to cache.
 */
function SetCache$1(values) {
  var index = -1,
      length = values == null ? 0 : values.length;

  this.__data__ = new MapCache;
  while (++index < length) {
    this.add(values[index]);
  }
}

// Add methods to `SetCache`.
SetCache$1.prototype.add = SetCache$1.prototype.push = setCacheAdd;
SetCache$1.prototype.has = setCacheHas;

var _SetCache = SetCache$1;

/**
 * A specialized version of `_.some` for arrays without support for iteratee
 * shorthands.
 *
 * @private
 * @param {Array} [array] The array to iterate over.
 * @param {Function} predicate The function invoked per iteration.
 * @returns {boolean} Returns `true` if any element passes the predicate check,
 *  else `false`.
 */

function arraySome$1(array, predicate) {
  var index = -1,
      length = array == null ? 0 : array.length;

  while (++index < length) {
    if (predicate(array[index], index, array)) {
      return true;
    }
  }
  return false;
}

var _arraySome = arraySome$1;

/**
 * Checks if a `cache` value for `key` exists.
 *
 * @private
 * @param {Object} cache The cache to query.
 * @param {string} key The key of the entry to check.
 * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
 */

function cacheHas$1(cache, key) {
  return cache.has(key);
}

var _cacheHas = cacheHas$1;

var SetCache = _SetCache,
    arraySome = _arraySome,
    cacheHas = _cacheHas;

/** Used to compose bitmasks for value comparisons. */
var COMPARE_PARTIAL_FLAG$3 = 1,
    COMPARE_UNORDERED_FLAG$1 = 2;

/**
 * A specialized version of `baseIsEqualDeep` for arrays with support for
 * partial deep comparisons.
 *
 * @private
 * @param {Array} array The array to compare.
 * @param {Array} other The other array to compare.
 * @param {number} bitmask The bitmask flags. See `baseIsEqual` for more details.
 * @param {Function} customizer The function to customize comparisons.
 * @param {Function} equalFunc The function to determine equivalents of values.
 * @param {Object} stack Tracks traversed `array` and `other` objects.
 * @returns {boolean} Returns `true` if the arrays are equivalent, else `false`.
 */
function equalArrays$2(array, other, bitmask, customizer, equalFunc, stack) {
  var isPartial = bitmask & COMPARE_PARTIAL_FLAG$3,
      arrLength = array.length,
      othLength = other.length;

  if (arrLength != othLength && !(isPartial && othLength > arrLength)) {
    return false;
  }
  // Check that cyclic values are equal.
  var arrStacked = stack.get(array);
  var othStacked = stack.get(other);
  if (arrStacked && othStacked) {
    return arrStacked == other && othStacked == array;
  }
  var index = -1,
      result = true,
      seen = (bitmask & COMPARE_UNORDERED_FLAG$1) ? new SetCache : undefined;

  stack.set(array, other);
  stack.set(other, array);

  // Ignore non-index properties.
  while (++index < arrLength) {
    var arrValue = array[index],
        othValue = other[index];

    if (customizer) {
      var compared = isPartial
        ? customizer(othValue, arrValue, index, other, array, stack)
        : customizer(arrValue, othValue, index, array, other, stack);
    }
    if (compared !== undefined) {
      if (compared) {
        continue;
      }
      result = false;
      break;
    }
    // Recursively compare arrays (susceptible to call stack limits).
    if (seen) {
      if (!arraySome(other, function(othValue, othIndex) {
            if (!cacheHas(seen, othIndex) &&
                (arrValue === othValue || equalFunc(arrValue, othValue, bitmask, customizer, stack))) {
              return seen.push(othIndex);
            }
          })) {
        result = false;
        break;
      }
    } else if (!(
          arrValue === othValue ||
            equalFunc(arrValue, othValue, bitmask, customizer, stack)
        )) {
      result = false;
      break;
    }
  }
  stack['delete'](array);
  stack['delete'](other);
  return result;
}

var _equalArrays = equalArrays$2;

/**
 * Converts `map` to its key-value pairs.
 *
 * @private
 * @param {Object} map The map to convert.
 * @returns {Array} Returns the key-value pairs.
 */

function mapToArray$1(map) {
  var index = -1,
      result = Array(map.size);

  map.forEach(function(value, key) {
    result[++index] = [key, value];
  });
  return result;
}

var _mapToArray = mapToArray$1;

/**
 * Converts `set` to an array of its values.
 *
 * @private
 * @param {Object} set The set to convert.
 * @returns {Array} Returns the values.
 */

function setToArray$1(set) {
  var index = -1,
      result = Array(set.size);

  set.forEach(function(value) {
    result[++index] = value;
  });
  return result;
}

var _setToArray = setToArray$1;

var Symbol = _Symbol,
    Uint8Array = _Uint8Array,
    eq = eq_1,
    equalArrays$1 = _equalArrays,
    mapToArray = _mapToArray,
    setToArray = _setToArray;

/** Used to compose bitmasks for value comparisons. */
var COMPARE_PARTIAL_FLAG$2 = 1,
    COMPARE_UNORDERED_FLAG = 2;

/** `Object#toString` result references. */
var boolTag = '[object Boolean]',
    dateTag = '[object Date]',
    errorTag = '[object Error]',
    mapTag = '[object Map]',
    numberTag = '[object Number]',
    regexpTag = '[object RegExp]',
    setTag = '[object Set]',
    stringTag = '[object String]',
    symbolTag = '[object Symbol]';

var arrayBufferTag = '[object ArrayBuffer]',
    dataViewTag = '[object DataView]';

/** Used to convert symbols to primitives and strings. */
var symbolProto = Symbol ? Symbol.prototype : undefined,
    symbolValueOf = symbolProto ? symbolProto.valueOf : undefined;

/**
 * A specialized version of `baseIsEqualDeep` for comparing objects of
 * the same `toStringTag`.
 *
 * **Note:** This function only supports comparing values with tags of
 * `Boolean`, `Date`, `Error`, `Number`, `RegExp`, or `String`.
 *
 * @private
 * @param {Object} object The object to compare.
 * @param {Object} other The other object to compare.
 * @param {string} tag The `toStringTag` of the objects to compare.
 * @param {number} bitmask The bitmask flags. See `baseIsEqual` for more details.
 * @param {Function} customizer The function to customize comparisons.
 * @param {Function} equalFunc The function to determine equivalents of values.
 * @param {Object} stack Tracks traversed `object` and `other` objects.
 * @returns {boolean} Returns `true` if the objects are equivalent, else `false`.
 */
function equalByTag$1(object, other, tag, bitmask, customizer, equalFunc, stack) {
  switch (tag) {
    case dataViewTag:
      if ((object.byteLength != other.byteLength) ||
          (object.byteOffset != other.byteOffset)) {
        return false;
      }
      object = object.buffer;
      other = other.buffer;

    case arrayBufferTag:
      if ((object.byteLength != other.byteLength) ||
          !equalFunc(new Uint8Array(object), new Uint8Array(other))) {
        return false;
      }
      return true;

    case boolTag:
    case dateTag:
    case numberTag:
      // Coerce booleans to `1` or `0` and dates to milliseconds.
      // Invalid dates are coerced to `NaN`.
      return eq(+object, +other);

    case errorTag:
      return object.name == other.name && object.message == other.message;

    case regexpTag:
    case stringTag:
      // Coerce regexes to strings and treat strings, primitives and objects,
      // as equal. See http://www.ecma-international.org/ecma-262/7.0/#sec-regexp.prototype.tostring
      // for more details.
      return object == (other + '');

    case mapTag:
      var convert = mapToArray;

    case setTag:
      var isPartial = bitmask & COMPARE_PARTIAL_FLAG$2;
      convert || (convert = setToArray);

      if (object.size != other.size && !isPartial) {
        return false;
      }
      // Assume cyclic values are equal.
      var stacked = stack.get(object);
      if (stacked) {
        return stacked == other;
      }
      bitmask |= COMPARE_UNORDERED_FLAG;

      // Recursively compare objects (susceptible to call stack limits).
      stack.set(object, other);
      var result = equalArrays$1(convert(object), convert(other), bitmask, customizer, equalFunc, stack);
      stack['delete'](object);
      return result;

    case symbolTag:
      if (symbolValueOf) {
        return symbolValueOf.call(object) == symbolValueOf.call(other);
      }
  }
  return false;
}

var _equalByTag = equalByTag$1;

var getAllKeys = _getAllKeys;

/** Used to compose bitmasks for value comparisons. */
var COMPARE_PARTIAL_FLAG$1 = 1;

/** Used for built-in method references. */
var objectProto$1 = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty$1 = objectProto$1.hasOwnProperty;

/**
 * A specialized version of `baseIsEqualDeep` for objects with support for
 * partial deep comparisons.
 *
 * @private
 * @param {Object} object The object to compare.
 * @param {Object} other The other object to compare.
 * @param {number} bitmask The bitmask flags. See `baseIsEqual` for more details.
 * @param {Function} customizer The function to customize comparisons.
 * @param {Function} equalFunc The function to determine equivalents of values.
 * @param {Object} stack Tracks traversed `object` and `other` objects.
 * @returns {boolean} Returns `true` if the objects are equivalent, else `false`.
 */
function equalObjects$1(object, other, bitmask, customizer, equalFunc, stack) {
  var isPartial = bitmask & COMPARE_PARTIAL_FLAG$1,
      objProps = getAllKeys(object),
      objLength = objProps.length,
      othProps = getAllKeys(other),
      othLength = othProps.length;

  if (objLength != othLength && !isPartial) {
    return false;
  }
  var index = objLength;
  while (index--) {
    var key = objProps[index];
    if (!(isPartial ? key in other : hasOwnProperty$1.call(other, key))) {
      return false;
    }
  }
  // Check that cyclic values are equal.
  var objStacked = stack.get(object);
  var othStacked = stack.get(other);
  if (objStacked && othStacked) {
    return objStacked == other && othStacked == object;
  }
  var result = true;
  stack.set(object, other);
  stack.set(other, object);

  var skipCtor = isPartial;
  while (++index < objLength) {
    key = objProps[index];
    var objValue = object[key],
        othValue = other[key];

    if (customizer) {
      var compared = isPartial
        ? customizer(othValue, objValue, key, other, object, stack)
        : customizer(objValue, othValue, key, object, other, stack);
    }
    // Recursively compare objects (susceptible to call stack limits).
    if (!(compared === undefined
          ? (objValue === othValue || equalFunc(objValue, othValue, bitmask, customizer, stack))
          : compared
        )) {
      result = false;
      break;
    }
    skipCtor || (skipCtor = key == 'constructor');
  }
  if (result && !skipCtor) {
    var objCtor = object.constructor,
        othCtor = other.constructor;

    // Non `Object` object instances with different constructors are not equal.
    if (objCtor != othCtor &&
        ('constructor' in object && 'constructor' in other) &&
        !(typeof objCtor == 'function' && objCtor instanceof objCtor &&
          typeof othCtor == 'function' && othCtor instanceof othCtor)) {
      result = false;
    }
  }
  stack['delete'](object);
  stack['delete'](other);
  return result;
}

var _equalObjects = equalObjects$1;

var Stack = _Stack,
    equalArrays = _equalArrays,
    equalByTag = _equalByTag,
    equalObjects = _equalObjects,
    getTag = _getTag,
    isArray = isArray_1,
    isBuffer = isBufferExports,
    isTypedArray = isTypedArray_1;

/** Used to compose bitmasks for value comparisons. */
var COMPARE_PARTIAL_FLAG = 1;

/** `Object#toString` result references. */
var argsTag = '[object Arguments]',
    arrayTag = '[object Array]',
    objectTag = '[object Object]';

/** Used for built-in method references. */
var objectProto = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty = objectProto.hasOwnProperty;

/**
 * A specialized version of `baseIsEqual` for arrays and objects which performs
 * deep comparisons and tracks traversed objects enabling objects with circular
 * references to be compared.
 *
 * @private
 * @param {Object} object The object to compare.
 * @param {Object} other The other object to compare.
 * @param {number} bitmask The bitmask flags. See `baseIsEqual` for more details.
 * @param {Function} customizer The function to customize comparisons.
 * @param {Function} equalFunc The function to determine equivalents of values.
 * @param {Object} [stack] Tracks traversed `object` and `other` objects.
 * @returns {boolean} Returns `true` if the objects are equivalent, else `false`.
 */
function baseIsEqualDeep$1(object, other, bitmask, customizer, equalFunc, stack) {
  var objIsArr = isArray(object),
      othIsArr = isArray(other),
      objTag = objIsArr ? arrayTag : getTag(object),
      othTag = othIsArr ? arrayTag : getTag(other);

  objTag = objTag == argsTag ? objectTag : objTag;
  othTag = othTag == argsTag ? objectTag : othTag;

  var objIsObj = objTag == objectTag,
      othIsObj = othTag == objectTag,
      isSameTag = objTag == othTag;

  if (isSameTag && isBuffer(object)) {
    if (!isBuffer(other)) {
      return false;
    }
    objIsArr = true;
    objIsObj = false;
  }
  if (isSameTag && !objIsObj) {
    stack || (stack = new Stack);
    return (objIsArr || isTypedArray(object))
      ? equalArrays(object, other, bitmask, customizer, equalFunc, stack)
      : equalByTag(object, other, objTag, bitmask, customizer, equalFunc, stack);
  }
  if (!(bitmask & COMPARE_PARTIAL_FLAG)) {
    var objIsWrapped = objIsObj && hasOwnProperty.call(object, '__wrapped__'),
        othIsWrapped = othIsObj && hasOwnProperty.call(other, '__wrapped__');

    if (objIsWrapped || othIsWrapped) {
      var objUnwrapped = objIsWrapped ? object.value() : object,
          othUnwrapped = othIsWrapped ? other.value() : other;

      stack || (stack = new Stack);
      return equalFunc(objUnwrapped, othUnwrapped, bitmask, customizer, stack);
    }
  }
  if (!isSameTag) {
    return false;
  }
  stack || (stack = new Stack);
  return equalObjects(object, other, bitmask, customizer, equalFunc, stack);
}

var _baseIsEqualDeep = baseIsEqualDeep$1;

var baseIsEqualDeep = _baseIsEqualDeep,
    isObjectLike = isObjectLike_1;

/**
 * The base implementation of `_.isEqual` which supports partial comparisons
 * and tracks traversed objects.
 *
 * @private
 * @param {*} value The value to compare.
 * @param {*} other The other value to compare.
 * @param {boolean} bitmask The bitmask flags.
 *  1 - Unordered comparison
 *  2 - Partial comparison
 * @param {Function} [customizer] The function to customize comparisons.
 * @param {Object} [stack] Tracks traversed `value` and `other` objects.
 * @returns {boolean} Returns `true` if the values are equivalent, else `false`.
 */
function baseIsEqual$1(value, other, bitmask, customizer, stack) {
  if (value === other) {
    return true;
  }
  if (value == null || other == null || (!isObjectLike(value) && !isObjectLike(other))) {
    return value !== value && other !== other;
  }
  return baseIsEqualDeep(value, other, bitmask, customizer, baseIsEqual$1, stack);
}

var _baseIsEqual = baseIsEqual$1;

var baseIsEqual = _baseIsEqual;

/**
 * Performs a deep comparison between two values to determine if they are
 * equivalent.
 *
 * **Note:** This method supports comparing arrays, array buffers, booleans,
 * date objects, error objects, maps, numbers, `Object` objects, regexes,
 * sets, strings, symbols, and typed arrays. `Object` objects are compared
 * by their own, not inherited, enumerable properties. Functions and DOM
 * nodes are compared by strict equality, i.e. `===`.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Lang
 * @param {*} value The value to compare.
 * @param {*} other The other value to compare.
 * @returns {boolean} Returns `true` if the values are equivalent, else `false`.
 * @example
 *
 * var object = { 'a': 1 };
 * var other = { 'a': 1 };
 *
 * _.isEqual(object, other);
 * // => true
 *
 * object === other;
 * // => false
 */
function isEqual(value, other) {
  return baseIsEqual(value, other);
}

var isEqual_1 = isEqual;

var isEqual$1 = /*@__PURE__*/getDefaultExportFromCjs(isEqual_1);

/**
 * An enumeration of the available drawing modes.
 */
var DrawingMode;
(function (DrawingMode) {
    /**
     * Draw individual points on the map.
     * Literal value `"draw-point"`
     */
    DrawingMode["drawPoint"] = "draw-point";
    /**
     * Draw lines on the map.
     * Literal value `"draw-line"`
     */
    DrawingMode["drawLine"] = "draw-line";
    /**
     * Draw polygons on the map.
     * Literal value `"draw-polygon"`
     */
    DrawingMode["drawPolygon"] = "draw-polygon";
    /**
     * Draw circles on the map.
     * Literal value `"draw-circle"`
     */
    DrawingMode["drawCircle"] = "draw-circle";
    /**
     * Draw rectangles on the map.
     * Literal value `"draw-rectangle"`
     */
    DrawingMode["drawRectangle"] = "draw-rectangle";
    // /**
    //  * Select shapes and edit their properties.
    //  */
    // TODO
    // editProperties = "edit-properties",
    /**
     * When in this mode the user can add/remove/move points/coordinates of a shape, rotate shapes, drag shapes.
     */
    DrawingMode["editGeometry"] = "edit-geometry";
    /**
     * When in this mode the user can erase (delete) shapes tracked by the DrawingManager.
     */
    DrawingMode["eraseGeometry"] = "erase-geometry";
    /**
     * Sets the drawing manager into an idle state.
     * Completes any drawing/edit that are in progress.
     * Literal value `"idle"`
     */
    DrawingMode["idle"] = "idle";
})(DrawingMode || (DrawingMode = {}));

var __assign = (undefined && undefined.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
/**
 * @private
 */
var Options = /** @class */ (function () {
    function Options() {
    }
    /**
     * @internal
     */
    Options.prototype.merge = function () {
        var valuesList = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            valuesList[_i] = arguments[_i];
        }
        var defaults;
        for (var _a = 0, valuesList_1 = valuesList; _a < valuesList_1.length; _a++) {
            var values = valuesList_1[_a];
            if (!values) {
                continue;
            }
            for (var property in values) {
                if (values.hasOwnProperty(property) && this.hasOwnProperty(property)) {
                    if (values[property] !== undefined && values[property] != null) {
                        // Check for nested options and merge them rather than simply overwriting.
                        if (this[property] instanceof Options) {
                            this[property].merge(values[property]);
                        }
                        else {
                            if (property === 'dragHandleStyle' || property === 'secondaryDragHandleStyle') {
                                this[property] = __assign(__assign({}, this[property]), values[property]);
                            }
                            else {
                                this[property] = values[property];
                            }
                        }
                    }
                    else {
                        // Assume a value of undefined or null intends to take the default value.
                        // Create a new object to access its defaults.
                        if (!defaults) {
                            defaults = new (Object.getPrototypeOf(this).constructor)();
                        }
                        this[property] = defaults[property];
                    }
                }
            }
        }
        return this;
    };
    return Options;
}());

var __extends$4 = (undefined && undefined.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * Options for the DrawingToolbar control.
 */
var DrawingToolbarOptions = /** @class */ (function (_super) {
    __extends$4(DrawingToolbarOptions, _super);
    function DrawingToolbarOptions() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        /**
         * The id of a HTML element in which the toolbar should be added to.
         * If not specified, the toolbar will be added to the map.
         */
        _this.containerId = undefined;
        /**
         * If the toolbar is added to the map, this value will specify where on the map the toolbar control will be added.
         * Default is `atlas.ControlPosition.NonFixed`
         * @default atlas.ControlPosition.NonFixed
         */
        _this.position = azmaps__namespace.ControlPosition.NonFixed;
        /**
         * An array of buttons to display in the toolbar.
         * The order of this array will match the order of the buttons in the toolbar.
         * Valid values are any drawing mode except `"idle"`.
         * Default is all drawing modes except `"idle"`.
         * @default All drawing modes except "idle"
         */
        _this.buttons = [
            DrawingMode.drawPoint,
            DrawingMode.drawLine,
            DrawingMode.drawPolygon,
            DrawingMode.drawCircle,
            DrawingMode.drawRectangle,
            DrawingMode.editGeometry,
            DrawingMode.eraseGeometry
        ];
        /**
         * The number of columns to display the buttons with.
         * If the number of columns is greater than or equal to the number of buttons
         * the toolbar will be a single horizontal row.
         * If only one column is used the toolbar will be a single vertical column.
         * Default is `Infinity`.
         * @default Infinity
         */
        _this.numColumns = Infinity;
        /**
         * The style of the DrawingToolbar.
         * Possible values are: `"light"` or `"dark"`.
         * Default is `"light"`.
         * @default "light"
         */
        _this.style = "light";
        /**
         * Specifies if the toolbar is visible or not.
         * Default `true`.
         * @default true
         */
        _this.visible = true;
        return _this;
    }
    return DrawingToolbarOptions;
}(Options));

/**
 * A control for changing the drawing mode.
 */
var DrawingToolbar = /** @class */ (function () {
    /**
     * Constructs a DrawingToolbar.
     * @param options The options for the DrawingToolbar.
     */
    function DrawingToolbar(options) {
        var _this = this;
        /**
         * Call back for styledata event, updates the toolbar's style based on the map's style.
         */
        this._updateStyle = function () {
            _this._setStyle(_this.options);
        };
        /**
         * Sets the effective drawing mode for the toolbar.
         * Updates the buttons active state.
         */
        this._updateMode = function (mode) {
            for (var i = 0; i < _this.toolbar.children.length; i++) {
                var child = _this.toolbar.children.item(i);
                if (child.dataset.mode === mode) {
                    child.classList.add(DrawingToolbar.Css.active);
                }
                else {
                    child.classList.remove(DrawingToolbar.Css.active);
                }
            }
        };
        this.options = new DrawingToolbarOptions().merge(cloneDeep$1(options));
    }
    /**
     * Gets the options used by the DrawingToolbar.
     */
    DrawingToolbar.prototype.getOptions = function () {
        return cloneDeep$1(this.options);
    };
    /**
     * Sets the options for the DrawingToolbar.
     * @param options The new options for the DrawingToolbar.
     */
    DrawingToolbar.prototype.setOptions = function (options) {
        var newOptions = new DrawingToolbarOptions().merge(this.options, cloneDeep$1(options));
        // Only worry about updating the settings if the toolbar has already been opened.
        if (this.toolbar) {
            // Update toolbar's visibility
            if (newOptions.visible !== this.options.visible) {
                if (newOptions.visible) {
                    this.toolbar.classList.remove(DrawingToolbar.Css.hide);
                }
                else {
                    this.toolbar.classList.add(DrawingToolbar.Css.hide);
                }
            }
            // Update the location/position of the toolbar
            if (newOptions.containerId !== this.options.containerId) {
                if (newOptions.containerId) {
                    var container = document.getElementById(newOptions.containerId);
                    if (!container) {
                        throw new Error("There is no container with ID '".concat(this.options.containerId, " ") +
                            "to add the toolbar to.");
                    }
                    this.map.controls.remove(this);
                    container.appendChild(this.toolbar);
                }
                else {
                    this.toolbar.remove();
                    // If the control is not in the non-fixed position use a container
                    // which will use the standard container control css class.
                    if (newOptions.position !== azmaps__namespace.ControlPosition.NonFixed) {
                        this._constructControl();
                    }
                    this.map.controls.add(this, { position: newOptions.position });
                }
            }
            else if (!newOptions.containerId && newOptions.position !== this.options.position) {
                this.map.controls.remove(this);
                // If the control is not in the non-fixed position use a container
                // which will use the standard container control css class.
                if (newOptions.position !== azmaps__namespace.ControlPosition.NonFixed) {
                    this._constructControl();
                }
                this.map.controls.add(this, { position: newOptions.position });
            }
            // Update the toolbar's style
            if (newOptions.style !== this.options.style) {
                this._setStyle(newOptions);
                // If the style is auto setup the event listener.
                // Otherwise disable the existing listener.
                if (newOptions.style === "auto") {
                    this.map.events.add("styledata", this._updateStyle);
                }
                else {
                    this.map.events.remove("styledata", this._updateStyle);
                }
            }
            // Update the toolbar's layout/buttons
            if (!isEqual$1(newOptions.buttons, this.options.buttons)) {
                // If new buttons are needed first remove the old ones.
                while (this.toolbar.firstChild) {
                    this.toolbar.removeChild(this.toolbar.firstChild);
                }
                // Add new buttons
                this._addButtons(this.drawMgr, newOptions);
            }
            else if (newOptions.numColumns !== this.options.numColumns) {
                var children = this.toolbar.children;
                for (var i = 0; i < children.length; i++) {
                    var child = children.item(i);
                    if ((i + 1) % newOptions.numColumns !== 0) {
                        child.style.cssFloat = "left";
                    }
                    else {
                        child.style.cssFloat = null;
                    }
                }
            }
        }
        this.options = newOptions;
    };
    /**
     * Initialization method for the control which is called when added to the map.
     * @return An HTMLElement to be placed on the map for the control.
     */
    DrawingToolbar.prototype.onAdd = function () {
        if (!this.toolbar) {
            throw new Error("The toolbar cannot be added directly to the map, it must be passed to a DrawingManager");
        }
        return this.control || this.toolbar;
    };
    /**
     * Method that is called when the control is removed from the map. Should perform any necessary cleanup for the
     * control.
     */
    DrawingToolbar.prototype.onRemove = function () {
        (this.control || this.toolbar).remove();
        delete this.control;
    };
    /**
     * Opens the toolbar on the page.
     * @param manager The drawing manager which owns the toolbar.
     * @param map The map the drawing manager is connected to.
     * @internal
     */
    DrawingToolbar.prototype._open = function (manager, map) {
        if (this.toolbar) {
            throw new Error("The toolbar is already opened, it cannot be opened again.");
        }
        // Keep track of the map the drawing toolbar is associated with.
        this.map = map;
        this.drawMgr = manager;
        // If a containerId is specified add the toolbar to it,
        // otherwise add the toolbar to the map.
        if (this.options.containerId) {
            var container = document.getElementById(this.options.containerId);
            if (!container) {
                throw new Error("There is no container with ID '".concat(this.options.containerId, " to add the toolbar to."));
            }
            this._constructToolbar(manager, map);
            container.appendChild(this.toolbar);
        }
        else {
            this._constructToolbar(manager, map);
            // If the control is not in the non-fixed position use a container
            // which will use the standard container control css class.
            if (this.options.position !== azmaps__namespace.ControlPosition.NonFixed) {
                this._constructControl();
            }
            map.controls.add(this, { position: this.options.position });
        }
    };
    /**
     * Closes the toolbar removing it from the page.
     * @internal
     */
    DrawingToolbar.prototype._close = function () {
        if (!this.toolbar) {
            throw new Error("Cannot close the toolbar, it has not been opened yet.");
        }
        if (!this.options.containerId) {
            this.map.controls.remove(this);
        }
        else {
            this.toolbar.remove();
        }
        // Remove the drawing mode change listener.
        this.map.events.remove("drawingmodechanged", this.drawMgr, this._updateMode);
        this.map.events.remove("styledata", this._updateStyle);
        // Remove the old toolbar.
        delete this.toolbar;
        delete this.drawMgr;
        delete this.map;
    };
    /**
     * Check if the toolbar is open
     * @internal
     */
    DrawingToolbar.prototype._isOpen = function () {
        return !!this.toolbar;
    };
    /**
     * Removes the toolbar and releases all resources used by it.
     */
    DrawingToolbar.prototype._dispose = function () {
        this._close();
    };
    /**
     * Constructs the container for the toolbar.
     */
    DrawingToolbar.prototype._constructToolbar = function (manager, map) {
        this.toolbar = document.createElement("div");
        this.toolbar.classList.add(DrawingToolbar.Css.toolbar);
        this._setStyle(this.options);
        // If the style is auto setup the event listener.
        if (this.options.style === "auto") {
            map.events.add("styledata", this._updateStyle);
        }
        // Set toolbar visibility.
        if (!this.options.visible) {
            this.toolbar.classList.add(DrawingToolbar.Css.hide);
        }
        // Update the active buttons when the manager changes modes.
        map.events.add("drawingmodechanged", manager, this._updateMode);
        this._addButtons(manager, this.options);
    };
    /**
     * Adds buttons to a toolbar based on the specified options.
     */
    DrawingToolbar.prototype._addButtons = function (manager, options) {
        var mode = manager.getOptions().mode;
        for (var i = 0; i < options.buttons.length; i++) {
            var buttonType = options.buttons[i];
            var button = document.createElement("button");
            button.type = "button";
            button.dataset.mode = buttonType;
            button.setAttribute("aria-label", buttonType);
            button.setAttribute("title", buttonType);
            button.classList.add(DrawingToolbar.Css.button, buttonType);
            button.addEventListener("click", this._getBtnCallback(button, manager));
            // If the button isn't on the end of a row allow
            // it to float with the other buttons of that row.
            if ((i + 1) % options.numColumns !== 0) {
                button.style.cssFloat = "left";
            }
            // If the button's mode is already active
            // mark the button as active too.
            if (mode === buttonType) {
                button.classList.add(DrawingToolbar.Css.active);
            }
            this.toolbar.appendChild(button);
        }
    };
    /**
     * Creates the necessary callback for a button based on the button type.
     */
    DrawingToolbar.prototype._getBtnCallback = function (button, manager) {
        switch (button.dataset.mode) {
            case DrawingMode.drawPoint:
            case DrawingMode.drawLine:
            case DrawingMode.drawPolygon:
            case DrawingMode.drawCircle:
            case DrawingMode.drawRectangle:
            case DrawingMode.editGeometry:
            case DrawingMode.eraseGeometry:
                return function () {
                    var mode = manager.getOptions().mode;
                    if (button.dataset.mode === mode) {
                        // Change to idle mode if the button was already active.
                        manager.setOptions({ mode: DrawingMode.idle });
                    }
                    else {
                        // Change to the button's mode if the button isn't active.
                        manager.setOptions({ mode: button.dataset.mode });
                    }
                };
            default:
                throw new Error("Invalid button type specified '".concat(button.dataset.mode, "'."));
        }
    };
    /**
     * Constructs the control element for holding the toolbar.
     */
    DrawingToolbar.prototype._constructControl = function () {
        this.control = document.createElement("div");
        this.control.classList.add(DrawingToolbar.Css.control);
        this.control.appendChild(this.toolbar);
    };
    /**
     * Sets the effective style the toolbar should use based on the specified style and possibly the map's style.
     */
    DrawingToolbar.prototype._setStyle = function (options) {
        // Remove all possible styles to reset.
        for (var _i = 0, _a = Object.keys(DrawingToolbar.Css.styles); _i < _a.length; _i++) {
            var style = _a[_i];
            this.toolbar.classList.remove(DrawingToolbar.Css.styles[style]);
        }
        if (options.style === "auto") {
            // TODO Choose the style based on map state
            this.toolbar.classList.add(DrawingToolbar.Css.styles.light);
        }
        else if (DrawingToolbar.Css.styles.hasOwnProperty(options.style)) {
            this.toolbar.classList.add(DrawingToolbar.Css.styles[options.style]);
        }
        else {
            throw new Error("An invalid style '".concat(options.style, "' was specified for the toolbar."));
        }
    };
    // CSS classes used by the toolbar's elements.
    DrawingToolbar.Css = {
        active: "active",
        button: "azure-maps-drawtoolbar-button",
        container: "azure-maps-drawtoolbar-container",
        control: "azure-maps-control-container",
        hide: "hidden-accessible-element",
        styles: {
            dark: "dark",
            light: "light",
        },
        toolbar: "azure-maps-drawtoolbar"
    };
    return DrawingToolbar;
}());

/* TODO Expose once implementation is done.
export { PropertyEditorDialog } from "./PropertyEditorDialog";
*/

var baseControl = /*#__PURE__*/Object.freeze({
    __proto__: null,
    DrawingToolbar: DrawingToolbar
});

var baseClone = _baseClone;

/** Used to compose bitmasks for cloning. */
var CLONE_DEEP_FLAG = 1,
    CLONE_SYMBOLS_FLAG = 4;

/**
 * This method is like `_.cloneWith` except that it recursively clones `value`.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to recursively clone.
 * @param {Function} [customizer] The function to customize cloning.
 * @returns {*} Returns the deep cloned value.
 * @see _.cloneWith
 * @example
 *
 * function customizer(value) {
 *   if (_.isElement(value)) {
 *     return value.cloneNode(true);
 *   }
 * }
 *
 * var el = _.cloneDeepWith(document.body, customizer);
 *
 * console.log(el === document.body);
 * // => false
 * console.log(el.nodeName);
 * // => 'BODY'
 * console.log(el.childNodes.length);
 * // => 20
 */
function cloneDeepWith(value, customizer) {
  customizer = typeof customizer == 'function' ? customizer : undefined;
  return baseClone(value, CLONE_DEEP_FLAG | CLONE_SYMBOLS_FLAG, customizer);
}

var cloneDeepWith_1 = cloneDeepWith;

var cloneDeepWith$1 = /*@__PURE__*/getDefaultExportFromCjs(cloneDeepWith_1);

/**
 * A collection of the layers used by the drawing manager for rendering shapes.
 */
var DrawingLayers = /** @class */ (function () {
    function DrawingLayers() {
    }
    return DrawingLayers;
}());

var __extends$3 = (undefined && undefined.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * Options for the property editor dialog.
 */
var PropertyEditorDialogOptions = /** @class */ (function (_super) {
    __extends$3(PropertyEditorDialogOptions, _super);
    function PropertyEditorDialogOptions() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        /**
         * TODO: COMMENT
         * Specifies where the property editor should be rendered.
         * Valid options are a `atlas.Map` instance, the string ID of a div, or an HTMLElement already on the DOM.
         */
        _this.container = undefined;
        /**
         * TODO: COMMENT
         * The background color that is displayed behind the dialog window over top of the map.
         * Default `"rgba(0, 0, 0, 0.3)"`.
         * @default "rgba(0, 0, 0, 0.3)"
         */
        _this.backgroundColor = "rgba(0, 0, 0, 0.3)";
        /**
         * TODO: COMMENT
         * auto, light, dark
         */
        _this.style = "light";
        return _this;
    }
    return PropertyEditorDialogOptions;
}(Options));

/**
 * The property editor dialog control is a type of control that
 * displays all the property key/value information a shape has.
 * Each property should have a type option as well as a delete button.
 */
var PropertyEditorDialog = /** @class */ (function () {
    function PropertyEditorDialog(options) {
        this.options = new PropertyEditorDialogOptions().merge(Object.assign({}, options));
        this._constructDialog(this.options);
    }
    /**
     * TODO: COMMENT
     * Closes the property window, does not save any changes.
     */
    PropertyEditorDialog.prototype.close = function () {
        // TODO
    };
    /**
     * TODO: COMMENT
     * Opens the property editor for the specified shape.
     */
    PropertyEditorDialog.prototype.edit = function (shape) {
        // TODO
        // Update the property table.
        if (this.shape !== shape) {
            // Reset the table.
            this._clearProps();
            // Track the shape actively being edited.
            this.shape = shape;
            this.tempProps = shape.getProperties();
            // Populate the table with the shape's properties.
            for (var _i = 0, _a = Object.keys(this.tempProps); _i < _a.length; _i++) {
                var prop = _a[_i];
                if (!prop.startsWith("_azureMaps")) {
                    this._addProp(prop, this.tempProps[prop]);
                }
            }
        }
        // Show the UI.
        if (!this.container.parentElement) {
            if (typeof this.options.container === "string") {
                var parent_1 = document.getElementById(this.options.container);
                if (!parent_1) {
                    throw new Error("There is no element with ID '".concat(this.options.container, " to add the editor to."));
                }
                parent_1.appendChild(this.container);
            }
            else if (this.options.container instanceof azmaps__namespace.Map) ;
            else ;
        }
    };
    /**
     * TODO: COMMENT
     * Gets the options used by the control.
     */
    PropertyEditorDialog.prototype.getOptions = function () {
        return Object.assign({}, this.options);
    };
    /**
     * TODO: COMMENT
     * Saves the changes to the shape and closes the property editor window.
     */
    PropertyEditorDialog.prototype.save = function () {
        // TODO
        this.close();
    };
    /**
     * TODO: COMMENT
     * Sets the style of the drawing toolbar.
     * @param options
     */
    PropertyEditorDialog.prototype.setOptions = function (options) {
        var newOptions = new PropertyEditorDialogOptions().merge(this.options, Object.assign({}, options));
        this.options = newOptions;
    };
    /**
     * Constructs the dialog.
     */
    PropertyEditorDialog.prototype._constructDialog = function (options) {
        var _this = this;
        // The background container that fills the div.
        this.container = document.createElement("div");
        this.container.classList.add(PropertyEditorDialog.Css.container);
        this.container.style.backgroundColor = options.backgroundColor;
        // The actual dialog window.
        this.dialog = document.createElement("div");
        this.dialog.classList.add(PropertyEditorDialog.Css.dialog);
        this._updateStyle(options);
        this.container.appendChild(this.dialog);
        // The labels for property table.
        var propLabel = document.createElement("label");
        propLabel.classList.add(PropertyEditorDialog.Css.labels.base, PropertyEditorDialog.Css.labels.property);
        propLabel.innerHTML = "Property";
        this.dialog.appendChild(propLabel);
        var typeLabel = document.createElement("label");
        typeLabel.classList.add(PropertyEditorDialog.Css.labels.base, PropertyEditorDialog.Css.labels.type);
        typeLabel.innerHTML = "Type";
        this.dialog.appendChild(typeLabel);
        var valueLabel = document.createElement("label");
        valueLabel.classList.add(PropertyEditorDialog.Css.labels.base, PropertyEditorDialog.Css.labels.value);
        valueLabel.innerHTML = "Value";
        this.dialog.appendChild(valueLabel);
        var labelBar = document.createElement("hr");
        labelBar.classList.add(PropertyEditorDialog.Css.labels.base, PropertyEditorDialog.Css.labels.bar);
        this.dialog.appendChild(labelBar);
        // The property list.
        this.propsList = document.createElement("ul");
        this.propsList.classList.add(PropertyEditorDialog.Css.table.base, PropertyEditorDialog.Css.table.list);
        this.dialog.appendChild(this.propsList);
        // Button for adding a new property.
        var addPropButton = document.createElement("button");
        addPropButton.classList.add(PropertyEditorDialog.Css.buttons.base, PropertyEditorDialog.Css.buttons.add);
        addPropButton.addEventListener("click", function () { return _this._addProp(); });
        this.dialog.appendChild(addPropButton);
        var addPropDiv = document.createElement("div");
        addPropButton.appendChild(addPropDiv);
        this.addPropLbl = document.createElement("label");
        addPropButton.appendChild(this.addPropLbl);
        // Buttons for cancel and save.
        this.cancelBtn = document.createElement("button");
        this.cancelBtn.classList.add(PropertyEditorDialog.Css.buttons.base, PropertyEditorDialog.Css.buttons.cancel);
        this.cancelBtn.addEventListener("click", function () { return _this.close(); });
        this.dialog.appendChild(this.cancelBtn);
        this.saveBtn = document.createElement("button");
        this.saveBtn.classList.add(PropertyEditorDialog.Css.buttons.base, PropertyEditorDialog.Css.buttons.save);
        this.saveBtn.addEventListener("click", function () { return _this.save(); });
        this.dialog.appendChild(this.saveBtn);
        // Set localized text
        this._setLocalizedText();
    };
    PropertyEditorDialog.prototype._addProp = function (name, value) {
        var _this = this;
        // Contain the row in a div.
        var propRow = document.createElement("div");
        propRow.classList.add(PropertyEditorDialog.Css.table.base, PropertyEditorDialog.Css.table.row);
        this.propsList.appendChild(propRow);
        // Property name.
        var propName = document.createElement("input");
        propName.classList.add(PropertyEditorDialog.Css.table.base, PropertyEditorDialog.Css.table.name);
        propName.type = "text";
        propName.value = name ? name : "";
        propRow.appendChild(propName);
        // Property type.
        var propType = document.createElement("select");
        propType.classList.add(PropertyEditorDialog.Css.table.base, PropertyEditorDialog.Css.table.type);
        propRow.appendChild(propType);
        for (var _i = 0, _a = PropertyEditorDialog.Types; _i < _a.length; _i++) {
            var typeName = _a[_i];
            var option = document.createElement("option");
            option.value = typeName;
            option.innerText = typeName;
            propType.add(option);
            if (value && typeof value === typeName) {
                option.selected = true;
            }
            else if (!value && typeName === "string") {
                option.selected = true;
            }
        }
        // Property value.
        var propValue = document.createElement("div");
        propValue.classList.add(PropertyEditorDialog.Css.table.base, PropertyEditorDialog.Css.table.value);
        propValue.addEventListener("keydown", function (event) { return _this._constrainSize(propType, propValue, event); });
        propValue.innerText = value ? JSON.stringify(value, null, 2) : "";
        propValue.contentEditable = "true";
        propRow.appendChild(propValue);
        // Delete button.
        var deleteButton = document.createElement("button");
        deleteButton.classList.add(PropertyEditorDialog.Css.table.base, PropertyEditorDialog.Css.table.delete);
        deleteButton.addEventListener("click", function () { return _this.propsList.removeChild(propRow); });
        propRow.appendChild(deleteButton);
    };
    /**
     * Clears all properties from the table.
     */
    PropertyEditorDialog.prototype._clearProps = function () {
        // Clear temp list of properties.
        delete this.tempProps;
        // Remove all rows from the property.
        while (this.propsList.firstChild) {
            this.propsList.removeChild(this.propsList.firstChild);
        }
    };
    /**
     * Callback for selecting a properties type.
     */
    PropertyEditorDialog.prototype._constrainSize = function (typeSelect, valueText, event) {
        if (typeSelect.value !== "object" && event.keyCode === 13) {
            event.preventDefault();
        }
    };
    /**
     * Sets the effective style the toolbar should use based on the specified style and possibly the map's style.
     */
    PropertyEditorDialog.prototype._updateStyle = function (options) {
        // Remove all possible styles to reset.
        for (var _i = 0, _a = Object.keys(PropertyEditorDialog.Css.styles); _i < _a.length; _i++) {
            var style = _a[_i];
            this.dialog.classList.remove(PropertyEditorDialog.Css.styles[style]);
        }
        if (options.style === "auto") {
            // TODO Choose the style based on map state
            this.dialog.classList.add(PropertyEditorDialog.Css.styles.light);
        }
        else if (PropertyEditorDialog.Css.styles.hasOwnProperty(options.style)) {
            this.dialog.classList.add(PropertyEditorDialog.Css.styles[options.style]);
        }
        else {
            throw new Error("An invalid style '".concat(options.style, "' was specified for the editor."));
        }
    };
    /**
     * Updates UI elements to use localized text for the current map language.
     */
    PropertyEditorDialog.prototype._setLocalizedText = function () {
        // TODO Actually use localized strings
        this.saveBtn.innerText = "Save";
        this.cancelBtn.innerText = "Cancel";
        this.addPropLbl.innerText = "Add property";
    };
    PropertyEditorDialog._countLines = function (text) {
        var matches = text.match(this.LineCountRegEx);
        return matches ? matches.length + 1 : 1;
    };
    // CSS classes used by the dialog's elements.
    PropertyEditorDialog.Css = {
        buttons: {
            add: "add",
            base: "azure-maps-propedit-button",
            cancel: "cancel",
            save: "save"
        },
        container: "azure-maps-propedit-container",
        dialog: "azure-maps-propedit-dialog",
        hide: "hidden-accessible-element",
        labels: {
            bar: "bar",
            base: "azure-maps-propedit-label",
            property: "prop",
            type: "type",
            value: "value"
        },
        styles: {
            dark: "dark",
            light: "light",
        },
        table: {
            base: "azure-maps-propedit-table",
            delete: "delete",
            list: "list",
            name: "name",
            row: "row",
            type: "type",
            value: "value"
        }
    };
    // Property types the dialog supports.
    PropertyEditorDialog.Types = ["boolean", "number", "object", "string"];
    // Regex for line counting.
    PropertyEditorDialog.LineCountRegEx = new RegExp("\r*\n", "g");
    // Context for measuring string length.
    PropertyEditorDialog.Render = document.createElement("canvas").getContext("2d");
    return PropertyEditorDialog;
}());

/**
 * An enumeration of the available drawing interaction types.
 * The drawing interaction type specifies how certain drawing modes behave.
 */
var DrawingInteractionType;
(function (DrawingInteractionType) {
    /**
     * Coordinates are added when the mouse or touch is clicked or dragged.
     * Literal value `"hybrid"`
     */
    DrawingInteractionType["hybrid"] = "hybrid";
    /**
     * Coordinates are added when the mouse or touch is dragged on the map.
     * Literal value `"freehand"`
     */
    DrawingInteractionType["freehand"] = "freehand";
    /**
     * Coordinates are added when the mouse or touch is clicked.
     * Literal value `"click"`
     */
    DrawingInteractionType["click"] = "click";
})(DrawingInteractionType || (DrawingInteractionType = {}));

var __extends$2 = (undefined && undefined.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * Options for the drawing manager.
 */
var DrawingManagerOptions = /** @class */ (function (_super) {
    __extends$2(DrawingManagerOptions, _super);
    function DrawingManagerOptions() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        /**
         * The style options for the primary drag handles
         * @default: { anchor: "center", draggable: true, htmlContent: "<svg width='12' height='12' viewBox='0 0 12 12' fill='none' xmlns='http://www.w3.org/2000/svg'> <circle cx = '6' cy = '6' r = '5.5' fill='#FFFFFF' stroke='#4E4C4C'/> </svg>"}
         */
        _this.dragHandleStyle = { anchor: "center", draggable: true, htmlContent: "<svg width='12' height='12' viewBox='0 0 12 12' fill='none' xmlns='http://www.w3.org/2000/svg'> <circle class='dragHandleCircle' cx = '6' cy = '6' r = '5.5' fill='#FFFFFF' stroke='#4E4C4C'/> </svg>" };
        /**
         * Specifies the number of pixels the mouse or touch must move before another
         * coordinate is added to a shape when in `"freehand"` or `"hybrid"` drawing modes.
         * Default is `3`.
         * @default 3
         */
        _this.freehandInterval = 3;
        /**
         * The type of drawing interaction the manager should adhere to.
         * Default is `"hybrid"`.
         * @default "hybrid"
         */
        _this.interactionType = DrawingInteractionType.hybrid;
        /**
         * The drawing mode the manager is in.
         * Default is `"idle"`.
         * @default "idle"
         */
        _this.mode = DrawingMode.idle;
        // /**
        //  * TODO: COMMENTS
        //  * A property editor dialog control that can be displayed to allow the user to edit the properties of a shape.
        //  */
        // public propertyEditor?: PropertyEditorDialog = undefined;
        /**
         * The style options for the secondary drag handles.
         * These provide handles at mid-points for creating new coordinates between existing coordinates.
         * @default: { anchor: "center", draggable: true, htmlContent: "<svg width='12' height='12' viewBox='0 0 12 12' fill='none' xmlns='http://www.w3.org/2000/svg'> <circle cx = '6' cy = '6' r = '5.5' fill='#A6A6A6' stroke='#4E4C4C'/> </svg>"}
         */
        _this.secondaryDragHandleStyle = { anchor: "center", draggable: true, htmlContent: "<svg width='12' height='12' viewBox='0 0 12 12' fill='none' xmlns='http://www.w3.org/2000/svg'> <circle class='dragHandleCircle' cx = '6' cy = '6' r = '5.5' fill='#A6A6A6' stroke='#4E4C4C'/> </svg>" };
        /**
         * Specifies if shapes can be dragged when in edit or select mode.
         * @default: true
         */
        _this.shapeDraggingEnabled = true;
        /**
         * Specifies if shapes can be rotated when in edit mode.
         * @default: true
         */
        _this.shapeRotationEnabled = true;
        /**
         * A data source to add newly created shapes to.
         * If not specified when the drawing manager is constructed one will be created automatically.
         * If the data source is changed the drawing manager will be switched to `"idle"` mode.
         */
        _this.source = undefined;
        /**
         * A drawing toolbar to display as a control for the drawing manager.
         */
        _this.toolbar = undefined;
        return _this;
    }
    /**
     * Customizer for _.cloneDeep calls, allows Source, toolbar, propertyEditorDialog, DragHandleStyle
     * objects to pass through without cloning.
     * Source objects are designed to be modifiable so a reference to the actual Source is fine for users to have.
     * @param value The value being cloned.
     * @internal
     */
    DrawingManagerOptions._cloneCustomizer = function (value) {
        if (value instanceof DrawingToolbar ||
            value instanceof azmaps__namespace.source.DataSource ||
            value instanceof PropertyEditorDialog) {
            return value;
        }
    };
    return DrawingManagerOptions;
}(Options));

var __spreadArray = (undefined && undefined.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var DrawingHelper = /** @class */ (function () {
    function DrawingHelper(map, manager) {
        var _this = this;
        this.options = {};
        this.strokeColor = "#2266E3";
        this.parentIdProp = "parent_id";
        this.outlineProp = "outline";
        this.addCoord = function (e, fKeyPressed) {
            if (_this.options.mode === DrawingMode.drawPoint) {
                _this.finalShape = new azmaps__namespace.Shape(new azmaps__namespace.data.Point([]));
                _this.activeShape = new azmaps__namespace.Shape(new azmaps__namespace.data.Point(e.position));
                _this.activeShape.addProperty(_this.parentIdProp, _this.finalShape.getId());
                _this.drawMgr._invokeEvent("drawingstarted", null);
                _this.finish();
            }
            if (_this.options.mode === DrawingMode.drawLine || _this.options.mode === DrawingMode.drawPolygon) {
                if ((e.type === "click" || fKeyPressed) &&
                    (_this.options.interactionType === DrawingInteractionType.click ||
                        _this.options.interactionType === DrawingInteractionType.hybrid)) {
                    if (!_this.activeShape) {
                        _this.activeShape = new azmaps__namespace.Shape(new azmaps__namespace.data.LineString([]));
                        if (_this.options.mode === DrawingMode.drawPolygon) {
                            _this.finalShape = new azmaps__namespace.Shape(new azmaps__namespace.data.Polygon([]));
                            _this.activeShape.addProperty(_this.outlineProp, true);
                        }
                        else {
                            _this.finalShape = new azmaps__namespace.Shape(new azmaps__namespace.data.LineString([]));
                        }
                        _this.activeShape.addProperty(_this.parentIdProp, _this.finalShape.getId());
                        _this.options.source.add(_this.activeShape);
                    }
                    if (!_this.previewShape) {
                        _this.updateActiveShape(e);
                    }
                    if (_this.previewShape) {
                        _this.activeShapeCoordinates.push(e.position);
                        _this.activeShape.setCoordinates(_this.activeShapeCoordinates);
                        _this.drawMgr._invokeEvent("drawingchanged", _this.activeShape);
                        _this.previewSource.remove(_this.previewShape);
                        _this.previewShape = null;
                        _this.previewShapeCoordinates = [];
                    }
                }
                else if (_this.isMouseDown && (e.type === "mousemove" || e.type === "touchmove") &&
                    (_this.options.interactionType === DrawingInteractionType.freehand ||
                        _this.options.interactionType === DrawingInteractionType.hybrid)) {
                    if (_this.previewShape) {
                        _this.previewSource.remove(_this.previewShape);
                        _this.previewShape = null;
                        _this.previewShapeCoordinates = [];
                    }
                    if (!_this.activeShape) {
                        _this.activeShape = new azmaps__namespace.Shape(new azmaps__namespace.data.LineString([]));
                        if (_this.options.mode === DrawingMode.drawPolygon) {
                            _this.finalShape = new azmaps__namespace.Shape(new azmaps__namespace.data.Polygon([]));
                            _this.activeShape.addProperty(_this.outlineProp, true);
                        }
                        else {
                            _this.finalShape = new azmaps__namespace.Shape(new azmaps__namespace.data.LineString([]));
                        }
                        _this.activeShape.addProperty(_this.parentIdProp, _this.finalShape.getId());
                        _this.options.source.add(_this.activeShape);
                    }
                    var pixel = _this.map.positionsToPixels(_this.activeShapeCoordinates)[0];
                    if (_this.activeShapeCoordinates.length === 0 ||
                        (_this.pixelDifference(pixel, e.pixel) > _this.options.freehandInterval)) {
                        _this.updateActiveShape(e);
                    }
                }
            }
            if (_this.options.mode === DrawingMode.drawRectangle) {
                if (_this.isMouseDown && (e.type === "mousemove" || e.type === "touchmove")) {
                    if (!_this.activeShape) {
                        _this.finalShape = new azmaps__namespace.Shape(new azmaps__namespace.data.Polygon([]));
                        _this.activeShape = new azmaps__namespace.Shape(new azmaps__namespace.data.Polygon([]));
                        _this.activeShape.addProperty(_this.parentIdProp, _this.finalShape.getId());
                        _this.activeShape.addProperty("subType", "Rectangle");
                        _this.options.source.add(_this.activeShape);
                        _this.firstRectangleCorner = e.position;
                        _this.drawMgr._invokeEvent("drawingstarted", null);
                    }
                    else {
                        _this.activeShapeCoordinates = [
                            _this.firstRectangleCorner,
                            [e.position[0], _this.firstRectangleCorner[1]],
                            e.position,
                            [_this.firstRectangleCorner[0], e.position[1]],
                            _this.firstRectangleCorner
                        ];
                        _this.activeShape.setCoordinates(_this.activeShapeCoordinates);
                        _this.drawMgr._invokeEvent("drawingchanging", _this.activeShape);
                    }
                }
            }
            if (_this.options.mode === DrawingMode.drawCircle) {
                if (_this.isMouseDown && (e.type === "mousemove" || e.type === "touchmove")) {
                    if (!_this.activeShape) {
                        _this.finalShape = new azmaps__namespace.Shape(new azmaps__namespace.data.Point([]));
                        _this.activeShape = new azmaps__namespace.Shape(new azmaps__namespace.data.Point(e.position));
                        _this.activeShape.addProperty(_this.parentIdProp, _this.finalShape.getId());
                        _this.activeShape.addProperty("subType", "Circle");
                        _this.activeShape.addProperty("radius", 1);
                        _this.options.source.add(_this.activeShape);
                        _this.circleCenterPosition = e.position;
                        _this.drawMgr._invokeEvent("drawingstarted", null);
                    }
                    else {
                        _this.activeShape.addProperty("radius", azmaps__namespace.math.getDistanceTo(_this.circleCenterPosition, e.position));
                        _this.drawMgr._invokeEvent("drawingchanging", _this.activeShape);
                    }
                }
            }
        };
        this.previewCoord = function (e) {
            if (!_this.isMouseDown && _this.activeShape &&
                (_this.options.mode === DrawingMode.drawLine ||
                    _this.options.mode === DrawingMode.drawPolygon) &&
                (_this.options.interactionType === DrawingInteractionType.click ||
                    _this.options.interactionType === DrawingInteractionType.hybrid)) {
                if (!_this.previewShape) {
                    _this.previewShapeCoordinates = [
                        _this.activeShapeCoordinates[_this.activeShapeCoordinates.length - 1]
                    ];
                    _this.previewShape = new azmaps__namespace.Shape(new azmaps__namespace.data.LineString(_this.previewShapeCoordinates));
                    _this.previewSource.add(_this.previewShape);
                }
                _this.previewShapeCoordinates[1] = e.position;
                _this.previewShape.setCoordinates(_this.previewShapeCoordinates);
                var fullPreviewCoordinates = __spreadArray(__spreadArray([], _this.activeShapeCoordinates, true), [e.position], false);
                var fullPreviewShape = new azmaps__namespace.Shape(new azmaps__namespace.data.LineString(fullPreviewCoordinates));
                fullPreviewShape.addProperty(_this.parentIdProp, _this.finalShape.getId());
                _this.drawMgr._invokeEvent("drawingchanging", fullPreviewShape);
            }
        };
        this.finish = function (e) {
            if (e) {
                e.preventDefault();
            }
            var isDrawingComplete = false;
            if (_this.activeShape) {
                // If drawing circle or rectangles the drawingchanged and
                // drawingcomplete events occur at the same time.
                if (_this.options.mode === DrawingMode.drawCircle ||
                    _this.options.mode === DrawingMode.drawRectangle) {
                    _this.drawMgr._invokeEvent("drawingchanged", _this.activeShape);
                }
                if (_this.options.mode === DrawingMode.drawPolygon) {
                    if (_this.activeShapeCoordinates.length > 0) {
                        _this.activeShapeCoordinates.push(_this.activeShapeCoordinates[0]);
                        _this.finalShape.setCoordinates(_this.activeShapeCoordinates);
                    }
                }
                else {
                    _this.finalShape.setCoordinates(_this.activeShape.getCoordinates());
                }
                // Copy the active shape's properties except the outline and parent_id.
                var props = _this.activeShape.getProperties();
                delete props[_this.parentIdProp];
                delete props[_this.outlineProp];
                // Replace the active shape with the final shape.
                // TODO: remove this once the typings are fixed
                if (_this.options.source.getShapeById(_this.activeShape.getId())) {
                    _this.options.source.remove(_this.activeShape);
                }
                _this.finalShape.setProperties(props);
                _this.options.source.add(_this.finalShape);
                _this.activeShape = null;
                isDrawingComplete = true;
            }
            _this.activeShapeCoordinates = [];
            if (_this.previewShape) {
                _this.previewSource.remove(_this.previewShape);
            }
            _this.previewShapeCoordinates = [];
            _this.previewShape = null;
            _this.isMouseDown = false;
            if (isDrawingComplete) {
                isDrawingComplete = false;
                _this.drawMgr._invokeEvent("drawingcomplete", _this.finalShape);
            }
        };
        this.cancel = function () {
            if (_this.activeShape) {
                _this.options.source.remove(_this.activeShape);
                _this.activeShapeCoordinates = [];
                _this.activeShape = null;
                if (_this.previewShape) {
                    _this.previewSource.remove(_this.previewShape);
                    _this.previewShapeCoordinates = [];
                    _this.previewShape = null;
                }
                _this.isMouseDown = false;
            }
        };
        this.setMouseDown = function () {
            _this.isMouseDown = true;
        };
        this.setMouseUp = function () {
            _this.isMouseDown = false;
            if (_this.options.interactionType === DrawingInteractionType.freehand) {
                _this.finish();
            }
        };
        this.getPreviewLayers = function () {
            return _this.previewLayers;
        };
        this.drawMgr = manager;
        this.map = map;
        this.previewLayers = new DrawingLayers();
        this.previewSource = new azmaps__namespace.source.DataSource();
        this.map.sources.add(this.previewSource);
        this.previewLayers.pointLayer = new azmaps__namespace.layer.SymbolLayer(this.previewSource, null, {
            filter: ["==", ["geometry-type"], "Point"]
        });
        this.previewLayers.lineLayer = new azmaps__namespace.layer.LineLayer(this.previewSource, null, {
            filter: ["all", ["==", ["geometry-type"], "LineString"], ["!", ["has", this.outlineProp]]],
            strokeColor: this.strokeColor
        });
        this.previewLayers.polygonLayer = new azmaps__namespace.layer.PolygonLayer(this.previewSource, null, {
            filter: ["==", ["geometry-type"], "Polygon"],
            strokeColor: this.strokeColor
        });
        this.previewLayers.polygonOutlineLayer = new azmaps__namespace.layer.LineLayer(this.previewSource, null, {
            filter: ["all", ["==", ["geometry-type"], "LineString"], ["has", this.outlineProp]],
            strokeColor: this.strokeColor
        });
        this.map.layers.add([
            this.previewLayers.polygonLayer,
            this.previewLayers.polygonOutlineLayer,
            this.previewLayers.lineLayer,
            this.previewLayers.pointLayer
        ]);
        this.activeShapeCoordinates = [];
        this.previewShapeCoordinates = [];
    }
    DrawingHelper.prototype.dispose = function () {
        if (this.previewLayers) {
            this.map.layers.remove(this.previewLayers.lineLayer);
            this.map.layers.remove(this.previewLayers.polygonLayer);
            this.map.layers.remove(this.previewLayers.polygonOutlineLayer);
            this.map.layers.remove(this.previewLayers.pointLayer);
        }
        this.map = null;
        this.options = null;
        this.previewLayers = null;
    };
    DrawingHelper.prototype.setOptions = function (options) {
        if (this.options.mode !== options.mode) {
            this.finish();
        }
        this.options = options;
    };
    DrawingHelper.prototype.pixelDifference = function (pixelA, pixelB) {
        var dx = pixelA[0] - pixelB[0];
        var dy = pixelA[1] - pixelB[1];
        return Math.sqrt((dx * dx) + (dy * dy));
    };
    DrawingHelper.prototype.updateActiveShape = function (e) {
        // avoid duplicates
        var lastCoord = this.activeShapeCoordinates[this.activeShapeCoordinates.length - 1];
        if (this.activeShapeCoordinates.length > 0) {
            if ((lastCoord[0] !== e.position[0]) ||
                (lastCoord[1] !== e.position[1])) {
                this.activeShapeCoordinates.push(e.position);
                this.activeShape.setCoordinates(this.activeShapeCoordinates);
                this.drawMgr._invokeEvent("drawingchanged", this.activeShape);
            }
        }
        else {
            this.activeShapeCoordinates.push(e.position);
            this.activeShape.setCoordinates(this.activeShapeCoordinates);
            this.drawMgr._invokeEvent("drawingstarted", null);
        }
    };
    return DrawingHelper;
}());

/**
 * Drag Handle Types
 */
var HandleType;
(function (HandleType) {
    HandleType["primary"] = "primary";
    HandleType["secondary"] = "secondary";
    HandleType["rotational"] = "rotational";
})(HandleType || (HandleType = {}));

var __extends$1 = (undefined && undefined.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var DragHandle = /** @class */ (function (_super) {
    __extends$1(DragHandle, _super);
    function DragHandle(style, map, editHelper, handleType, index, drawingManagerOptions) {
        var _this = _super.call(this, style) || this;
        _this.promoteHandle = function (e) {
            if (_this.getHandleType() === HandleType.secondary) {
                _this.editHelper.promoteHandle(_this, _this.index, e);
            }
        };
        _this.moveHandle = function () {
            _this.editHelper.moveHandle(_this, _this.index);
        };
        _this.showHandles = function () {
            if (_this.getHandleType() === HandleType.primary) {
                _this.editHelper.showHandles(_this, _this.index);
            }
        };
        _this.primaryHtmlContent = drawingManagerOptions.dragHandleStyle.htmlContent;
        _this.secondaryHtmlContent = drawingManagerOptions.secondaryDragHandleStyle.htmlContent;
        _this.mp = map;
        _this.editHelper = editHelper;
        _this.handleType = handleType;
        _this.index = index;
        _this.mp.events.add("dragend", _this, _this.promoteHandle);
        _this.mp.events.add("dragend", _this, _this.showHandles);
        _this.mp.events.add("drag", _this, _this.moveHandle);
        return _this;
    }
    /**
     * Set draghandle style
     */
    DragHandle.prototype.setStyle = function (style) {
        this.style = style;
        this.setOptions(this.style);
    };
    DragHandle.prototype.setState = function (handleType) {
        this.handleType = handleType;
        if (this.handleType === HandleType.primary) {
            this.setOptions({ htmlContent: this.primaryHtmlContent });
        }
        else if (this.handleType === HandleType.secondary) {
            this.setOptions({ htmlContent: this.secondaryHtmlContent });
        }
    };
    DragHandle.prototype.setIndex = function (index) {
        this.index = index;
    };
    DragHandle.prototype.setPosition = function (pos) {
        this.setOptions({
            position: pos
        });
    };
    DragHandle.prototype.getPosition = function () {
        return this.getOptions().position;
    };
    DragHandle.prototype.getHandleType = function () {
        return this.handleType;
    };
    DragHandle.prototype.getIndex = function () {
        return this.index;
    };
    return DragHandle;
}(azmaps.HtmlMarker));

var MapInputHelper = /** @class */ (function () {
    function MapInputHelper(map, options, layers, drawingHelper, editHelper) {
        var _this = this;
        this.options = {};
        this.trackMousePosition = function (e) {
            _this.mouseEvent = e;
        };
        this.fKeyPressed = function (e) {
            if (e.keyCode === 70 || e.keyCode === 102) {
                _this.drawingHelper.addCoord(_this.mouseEvent, true);
            }
        };
        this.cKeyPressed = function (e) {
            if (e.keyCode === 67 || e.keyCode === 99) {
                _this.drawingHelper.finish();
                _this.editHelper.finish();
                return;
            }
        };
        this.deleteKeyPressed = function (e) {
            if (e.keyCode === 46 || e.keyCode === 8) {
                _this.editHelper.erase();
                return;
            }
        };
        this.escKeyPressed = function (e) {
            if (e.keyCode === 27) {
                _this.drawingHelper.cancel();
                _this.editHelper.finish();
                return;
            }
        };
        this.setMouseCursorToMove = function () {
            _this.map.getCanvas().style.cursor = 'move';
        };
        this.setMouseCursorToPointer = function () {
            _this.map.getCanvas().style.cursor = 'default';
        };
        this.setMouseCursorToCrossHair = function () {
            _this.map.getCanvas().style.cursor = 'crosshair';
        };
        this.setMouseCursorToGrab = function () {
            _this.map.getCanvas().style.cursor = 'grab';
        };
        this.map = map;
        this.layers = layers;
        this.editHelper = editHelper;
        this.drawingHelper = drawingHelper;
        this.setOptions(this.options);
    }
    MapInputHelper.prototype.setOptions = function (options) {
        // check if the interested options are changed
        if (this.options.mode === options.mode &&
            this.options.freehandInterval === options.freehandInterval &&
            this.options.interactionType === options.interactionType) {
            return;
        }
        this.options = options;
        if (this.options.mode === DrawingMode.editGeometry && this.options.shapeDraggingEnabled) {
            this.map.events.remove("mouseover", Object.values(this.layers), this.setMouseCursorToPointer);
            this.map.events.remove("mouseout", Object.values(this.layers), this.setMouseCursorToGrab);
            this.map.events.add("mouseover", Object.values(this.layers), this.setMouseCursorToMove);
            this.map.events.add("mouseout", Object.values(this.layers), this.setMouseCursorToGrab);
        }
        else if (this.options.mode === DrawingMode.eraseGeometry) {
            this.map.events.remove("mouseover", Object.values(this.layers), this.setMouseCursorToMove);
            this.map.events.remove("mouseout", Object.values(this.layers), this.setMouseCursorToGrab);
            this.map.events.add("mouseover", Object.values(this.layers), this.setMouseCursorToPointer);
            this.map.events.add("mouseout", Object.values(this.layers), this.setMouseCursorToGrab);
        }
        else {
            this.map.events.remove("mouseover", Object.values(this.layers), this.setMouseCursorToMove);
            this.map.events.remove("mouseover", Object.values(this.layers), this.setMouseCursorToPointer);
            this.map.events.remove("mouseout", Object.values(this.layers), this.setMouseCursorToGrab);
            if (this.options.mode === DrawingMode.idle) {
                this.setMouseCursorToGrab();
            }
            else {
                this.setMouseCursorToCrossHair();
            }
        }
        switch (this.options.mode) {
            case DrawingMode.drawPoint:
                this._clear();
                this.map.events.add("click", this.drawingHelper.addCoord);
                this.map.events.add("touchstart", this.drawingHelper.addCoord);
                // keyboard control
                this.map.events.add("mousemove", this.trackMousePosition);
                this.map.getMapContainer().addEventListener("keypress", this.fKeyPressed);
                this.map.getMapContainer().addEventListener("keypress", this.cKeyPressed);
                this.map.getMapContainer().addEventListener("keydown", this.escKeyPressed);
                break;
            case DrawingMode.drawLine:
                this._clear();
                MapInputHelper.lockMap(this.map);
                if (this.options.interactionType === DrawingInteractionType.click ||
                    this.options.interactionType === DrawingInteractionType.hybrid) {
                    this.map.events.add("click", this.drawingHelper.addCoord);
                    this.map.events.add("mousemove", this.drawingHelper.previewCoord);
                }
                if (this.options.interactionType === DrawingInteractionType.freehand ||
                    this.options.interactionType === DrawingInteractionType.hybrid) {
                    this.map.events.add("mousedown", this.drawingHelper.setMouseDown);
                    this.map.events.add("mousemove", this.drawingHelper.addCoord);
                    this.map.events.add("mouseup", this.drawingHelper.setMouseUp);
                    this.map.events.add("touchstart", this.drawingHelper.setMouseDown);
                    this.map.events.add("touchmove", this.drawingHelper.addCoord);
                    this.map.events.add("touchend", this.drawingHelper.finish);
                }
                this.map.events.add("dblclick", this.drawingHelper.finish);
                // keyboard control
                this.map.events.add("mousemove", this.trackMousePosition);
                this.map.getMapContainer().addEventListener("keypress", this.fKeyPressed);
                this.map.getMapContainer().addEventListener("keypress", this.cKeyPressed);
                this.map.getMapContainer().addEventListener("keydown", this.escKeyPressed);
                break;
            case DrawingMode.drawPolygon:
                this._clear();
                MapInputHelper.lockMap(this.map);
                if (this.options.interactionType === DrawingInteractionType.click ||
                    this.options.interactionType === DrawingInteractionType.hybrid) {
                    this.map.events.add("click", this.drawingHelper.addCoord);
                    this.map.events.add("mousemove", this.drawingHelper.previewCoord);
                }
                if (this.options.interactionType === DrawingInteractionType.freehand ||
                    this.options.interactionType === DrawingInteractionType.hybrid) {
                    this.map.events.add("mousedown", this.drawingHelper.setMouseDown);
                    this.map.events.add("mousemove", this.drawingHelper.addCoord);
                    this.map.events.add("mouseup", this.drawingHelper.setMouseUp);
                    this.map.events.add("touchstart", this.drawingHelper.setMouseDown);
                    this.map.events.add("touchmove", this.drawingHelper.addCoord);
                    this.map.events.add("touchend", this.drawingHelper.finish);
                }
                this.map.events.add("dblclick", this.drawingHelper.finish);
                // keyboard control
                this.map.events.add("mousemove", this.trackMousePosition);
                this.map.getMapContainer().addEventListener("keypress", this.fKeyPressed);
                this.map.getMapContainer().addEventListener("keypress", this.cKeyPressed);
                this.map.getMapContainer().addEventListener("keydown", this.escKeyPressed);
                break;
            case DrawingMode.drawCircle:
                this._clear();
                MapInputHelper.lockMap(this.map);
                this.map.events.add("mousedown", this.drawingHelper.setMouseDown);
                this.map.events.add("mousemove", this.drawingHelper.addCoord);
                this.map.events.add("mouseup", this.drawingHelper.finish);
                this.map.events.add("touchstart", this.drawingHelper.setMouseDown);
                this.map.events.add("touchmove", this.drawingHelper.addCoord);
                this.map.events.add("touchend", this.drawingHelper.finish);
                // keyboard control
                this.map.events.add("mousemove", this.trackMousePosition);
                this.map.getMapContainer().addEventListener("keypress", this.fKeyPressed);
                this.map.getMapContainer().addEventListener("keypress", this.cKeyPressed);
                this.map.getMapContainer().addEventListener("keydown", this.escKeyPressed);
                break;
            case DrawingMode.drawRectangle:
                this._clear();
                MapInputHelper.lockMap(this.map);
                this.map.events.add("mousedown", this.drawingHelper.setMouseDown);
                this.map.events.add("mousemove", this.drawingHelper.addCoord);
                this.map.events.add("mouseup", this.drawingHelper.finish);
                this.map.events.add("touchstart", this.drawingHelper.setMouseDown);
                this.map.events.add("touchmove", this.drawingHelper.addCoord);
                this.map.events.add("touchend", this.drawingHelper.finish);
                // keyboard control
                this.map.events.add("mousemove", this.trackMousePosition);
                this.map.getMapContainer().addEventListener("keypress", this.fKeyPressed);
                this.map.getMapContainer().addEventListener("keypress", this.cKeyPressed);
                this.map.getMapContainer().addEventListener("keydown", this.escKeyPressed);
                break;
            // TODO
            // case DrawingMode.editProperties:
            //     // TODO
            //     MapInputHelper.unLockMap(this.map);
            //     break;
            case DrawingMode.editGeometry:
                MapInputHelper.unLockMap(this.map);
                this.map.events.add("click", this.editHelper.selectShape);
                this.map.events.add("touchstart", this.editHelper.selectShape);
                this.map.events.add("mousedown", this.editHelper.setMouseDown);
                this.map.events.add("mouseup", this.editHelper.setMouseUp);
                this.map.events.add("touchstart", this.editHelper.setMouseDown);
                this.map.events.add("touchend", this.editHelper.setMouseUp);
                // keyboard control
                this.map.getMapContainer().addEventListener("keydown", this.escKeyPressed);
                this.map.getMapContainer().addEventListener("keydown", this.deleteKeyPressed);
                break;
            case DrawingMode.eraseGeometry:
                MapInputHelper.unLockMap(this.map);
                this.map.events.add("click", this.editHelper.selectShape);
                this.map.events.add("touchstart", this.editHelper.selectShape);
                this.map.events.add("mousedown", this.editHelper.setMouseDown);
                this.map.events.add("mouseup", this.editHelper.setMouseUp);
                this.map.events.add("touchstart", this.editHelper.setMouseDown);
                this.map.events.add("touchend", this.editHelper.setMouseUp);
                // keyboard control
                this.map.getMapContainer().addEventListener("keydown", this.deleteKeyPressed);
                break;
            default:
                MapInputHelper.unLockMap(this.map);
                this._clear();
                break;
        }
    };
    MapInputHelper.prototype._clear = function () {
        this.drawingHelper.finish();
        // DrawingHelper
        this.editHelper.finish();
        this.map.events.remove("click", this.drawingHelper.addCoord);
        this.map.events.remove("touchstart", this.drawingHelper.addCoord);
        this.map.events.remove("drag", this.drawingHelper.addCoord);
        this.map.events.remove("mousemove", this.drawingHelper.previewCoord);
        this.map.events.remove("mousemove", this.drawingHelper.addCoord);
        this.map.events.remove("mouseup", this.drawingHelper.finish);
        this.map.events.remove("mouseup", this.drawingHelper.addCoord);
        this.map.events.remove("mouseup", this.drawingHelper.setMouseUp);
        this.map.events.remove("mousedown", this.drawingHelper.setMouseDown);
        this.map.events.remove("dblclick", this.drawingHelper.finish);
        this.map.events.remove("mousemove", this.trackMousePosition);
        this.map.events.remove("touchstart", this.drawingHelper.setMouseDown);
        this.map.events.remove("touchmove", this.drawingHelper.addCoord);
        this.map.events.remove("touchend", this.drawingHelper.finish);
        // Edithelper
        this.map.events.remove("click", this.editHelper.selectShape);
        this.map.events.remove("touchstart", this.editHelper.selectShape);
        this.map.events.remove("mousedown", this.editHelper.setMouseDown);
        this.map.events.remove("mouseup", this.editHelper.setMouseUp);
        this.map.events.remove("touchstart", this.editHelper.setMouseDown);
        this.map.events.remove("touchend", this.editHelper.setMouseUp);
        // Keyboard
        this.map.getMapContainer().removeEventListener("keypress", this.fKeyPressed);
        this.map.getMapContainer().removeEventListener("keypress", this.cKeyPressed);
        this.map.getMapContainer().removeEventListener("keydown", this.deleteKeyPressed);
        this.map.getMapContainer().removeEventListener("keydown", this.escKeyPressed);
    };
    MapInputHelper.lockMap = function (map) {
        map.setUserInteraction({
            dblClickZoomInteraction: false,
            dragPanInteraction: false
        });
        map.getMapContainer().style.touchAction = "none";
    };
    MapInputHelper.unLockMap = function (map) {
        map.setUserInteraction({
            dblClickZoomInteraction: true,
            dragPanInteraction: true
        });
        map.getMapContainer().style.touchAction = null;
    };
    return MapInputHelper;
}());

var EditHelper = /** @class */ (function () {
    function EditHelper(map, options, layers, drawMgr) {
        var _this = this;
        this.editedPointStyle = "marker-blue";
        this.isDragging = false;
        this.erase = function () {
            if (_this.shape) {
                _this.options.source.remove(_this.shape);
                _this.selectedShapeCoordinates = [];
                _this._clearHandlesAndListeners();
                _this.drawMgr._invokeEvent("drawingerased", _this.shape);
                _this.shape = null;
                _this.isMouseDown = false;
            }
        };
        /**
         *  @internal
         */
        this.selectShape = function (e) {
            if (e.originalEvent.target !== _this.map.getCanvas()) {
                // only select the shape when user click on the canvas
                // to avoid conflicts of clicking with markers and the canvas
                return;
            }
            // get bounding box of near the point clicked and query the shape
            var southwestPixel = [e.pixel[0] - 3, e.pixel[1] + 3];
            var northeastPixel = [e.pixel[0] + 3, e.pixel[1] - 3];
            var southwestPosition = _this.map.pixelsToPositions([southwestPixel])[0];
            var northeastPosition = _this.map.pixelsToPositions([northeastPixel])[0];
            var bbox = new azmaps__namespace.data.BoundingBox(southwestPosition, northeastPosition);
            var shapes = _this.map.layers.getRenderedShapes(bbox, Object.values(_this.layers));
            if (shapes && shapes.length > 0) {
                var shape = shapes[0];
                if (shape) {
                    if (_this.options.mode === DrawingMode.eraseGeometry) {
                        _this.shape = shape;
                        _this.erase();
                        _this.drawMgr.setOptions({ mode: DrawingMode.idle });
                    }
                    else {
                        _this.edit(shape);
                    }
                }
            }
            e.originalEvent.stopImmediatePropagation();
        };
        ////////////////////// Triggered by Draghandle dragged ends ///////////////////////////
        this.setMouseDown = function () {
            _this.isMouseDown = true;
        };
        this.setMouseUp = function () {
            _this.isMouseDown = false;
        };
        this._startDragAndRotate = function (e) {
            if (_this.isEventShapeSameAsSelectedShape(e)) {
                if (_this.options.shapeDraggingEnabled) {
                    if (_this.rotateHandle) {
                        _this.rotateHandle.setOptions({ visible: false });
                    }
                    _this.isDragging = true;
                }
                _this._freezeMap(_this.shape, e);
            }
        };
        this._dragAndRotate = function (e) {
            if (_this.shape && _this.isMouseDown) {
                if (_this.isDragging) {
                    // As an optimization, only update the shape if the mouse has moved atleast 5 pixels.
                    // This will significantly reduce the number of recalculations and provide much better performance.
                    var dx = azmaps__namespace.Pixel.getX(_this.currentReferencedPixel) - azmaps__namespace.Pixel.getX(e.pixel);
                    var dy = azmaps__namespace.Pixel.getY(_this.currentReferencedPixel) - azmaps__namespace.Pixel.getY(e.pixel);
                    if (dx * dx + dy * dy <= 25) {
                        return;
                    }
                    _this.map.markers.remove(_this.primaryHandles);
                    _this.map.markers.remove(_this.secondaryHandles);
                    _this.primaryHandles = [];
                    _this.secondaryHandles = [];
                    _this._pixelAccurateUpdate(e);
                }
                if (_this.isRotating) {
                    //Get the pixel positions for the mouse.
                    var pixels = _this.map.positionsToPixels([_this.initCentroid, e.position]);
                    //Calculate the offset angle based on the heading.
                    var angle = azmaps.Pixel.getHeading(pixels[0], pixels[1]) - _this.initHeading + 180;
                    // hide drag handles
                    _this._showOrHideDragHandles(false);
                    //Rotate the shape and rotate handle.
                    _this.rotateShape(_this.shape, _this.initCoordinates, _this.initCentroid, angle);
                }
            }
        };
        /////////////////////////// Drag ends ///////////////////////////////////////////
        this._endDragAndRotate = function (e) {
            MapInputHelper.unLockMap(_this.map);
            if (_this.isDragging) {
                _this.isDragging = false;
                if (_this.shape && _this.shape.getType() === "Point" && !_this.shape.isCircle()) {
                    var properties = _this.shape.getProperties();
                    delete properties._azureMapsMarker;
                    _this.shape.setProperties(properties);
                }
                if (_this.rotateHandle) {
                    _this.rotateHandle.setOptions({ visible: true });
                }
            }
            if (_this.isRotating) {
                _this.isRotating = false;
                _this._showOrHideDragHandles(true);
            }
            // Set current shape to null, so that no updates will happen will mouse is up.
            _this.edit(_this.shape);
        };
        this._handleMouseDownOnRotateHandle = function (e) {
            //Calculate initial mouse heading relative to shape centroid.
            var pixels = _this.map.positionsToPixels([_this.rotateInitHandlePosition, _this.initCentroid]);
            _this.initHeading = azmaps.Pixel.getHeading(pixels[0], pixels[1]);
            //Disable map panning
            _this.map.setUserInteraction({ dragPanInteraction: false });
            _this.isRotating = true;
        };
        this._startRotate = function (e) {
            _this._freezeMap(_this.shape, e);
        };
        this.removeRotateHandle = function () {
            if (_this.rotateHandle) {
                _this.map.events.remove('mousedown', _this.rotateHandle, _this._handleMouseDownOnRotateHandle);
                _this.map.markers.remove(_this.rotateHandle);
                _this.rotateHandle = null;
            }
        };
        this.map = map;
        this.options = options;
        this.primaryHandles = [];
        this.secondaryHandles = [];
        this.layers = layers;
        this.drawMgr = drawMgr;
        this.defaultPointStyle = this.layers.pointLayer ? this.layers.pointLayer.getOptions().iconOptions.image : "marker-black";
    }
    EditHelper.prototype.setOptions = function (options) {
        this.finish();
        this.options = options;
    };
    EditHelper.prototype.finish = function () {
        this._clearHandlesAndListeners();
        var shape = this.shape;
        this.shape = null;
        if (shape) {
            this.drawMgr._invokeEvent("drawingcomplete", shape);
        }
        this.currentReferencedPixel = null;
        MapInputHelper.unLockMap(this.map);
    };
    EditHelper.prototype.edit = function (shape) {
        if (this.shape) {
            this.drawMgr._invokeEvent("drawingcomplete", this.shape);
        }
        this.drawMgr._invokeEvent("drawingstarted", shape);
        this._disableShapeDragAndRotate();
        this._clearHandlesAndListeners();
        this.shape = shape;
        // populate the shape with the draghandles
        this.selectedShapeCoordinates = this.shape.getCoordinates();
        if (this.shape.getType() === "Point" && !this.shape.isCircle()) {
            this.shape.addProperty("_azureMapsMarker", this.editedPointStyle);
        }
        else if (this.primaryHandles.length === 0) {
            // if there are no drag handles, populate the shape with them
            if (this.shape.isCircle()) {
                this._generateDragHandles(this.selectedShapeCoordinates);
            }
            else if (this.shape.isRectangle()) {
                this._generateDragHandles(this.selectedShapeCoordinates[0]);
            }
            else if (this.shape.getType() === "LineString") {
                this._generateDragHandles(this.selectedShapeCoordinates);
            }
            else if (this.shape.getType() === "Polygon") {
                this._generateDragHandles(this.selectedShapeCoordinates[0]);
            }
        }
        this._enableShapeDragAndRotate();
    };
    ////////////////////// Triggered by Draghandle events begins /////////////////////////
    /**
     * Called when drag on secondary handle ends or when clicked
     * @param selectedSecondaryDragHandle
     * @param index
     */
    EditHelper.prototype.promoteHandle = function (selectedSecondaryDragHandle, index, e) {
        // reset the flag. Secondary handle will be promoted when the drag ended
        this.isSecondaryHandleMoving = false;
        selectedSecondaryDragHandle.setOptions({ visible: true });
        var position = selectedSecondaryDragHandle.getPosition();
        var primaryHandlesSize = this.primaryHandles.length;
        var adjacentPrimaryDragHandleIndexA;
        var adjacentPrimaryDragHandleIndexB;
        if (this.shape.getType() === "LineString") {
            adjacentPrimaryDragHandleIndexA = index;
            adjacentPrimaryDragHandleIndexB = index + 1;
        }
        else if (this.shape.getType() === "Polygon") {
            adjacentPrimaryDragHandleIndexA = index === 0 ? primaryHandlesSize - 1 : index - 1;
            adjacentPrimaryDragHandleIndexB = index === primaryHandlesSize - 1 ? 0 : index + 1;
        }
        var adjacentPrimaryDragHandleA = this.primaryHandles[adjacentPrimaryDragHandleIndexA];
        var adjacentPrimaryDragHandleB = this.primaryHandles[adjacentPrimaryDragHandleIndexB];
        var midPointA = this._getMidPosition(position, adjacentPrimaryDragHandleA.getPosition());
        var midPointB = this._getMidPosition(position, adjacentPrimaryDragHandleB.getPosition());
        var newSecondaryDragHandleA = new DragHandle(this.options.secondaryDragHandleStyle, this.map, this, HandleType.secondary, index, this.options);
        var newSecondaryDragHandleB = new DragHandle(this.options.secondaryDragHandleStyle, this.map, this, HandleType.secondary, index + 1, this.options);
        newSecondaryDragHandleA.setPosition(midPointA);
        newSecondaryDragHandleB.setPosition(midPointB);
        // promote the handle and insert the newly created secondary handles on to the map
        selectedSecondaryDragHandle.setState(HandleType.primary);
        selectedSecondaryDragHandle.setIndex(index + 1);
        selectedSecondaryDragHandle.setStyle(this.options.dragHandleStyle);
        this.secondaryHandles[index] = newSecondaryDragHandleA;
        this.secondaryHandles.splice(index + 1, 0, newSecondaryDragHandleB);
        this.primaryHandles.splice(index + 1, 0, selectedSecondaryDragHandle);
        // update the rest of draghandle's index
        var i;
        for (i = index + 2; i < this.secondaryHandles.length; i++) {
            this.primaryHandles[i].setIndex(i);
            this.secondaryHandles[i].setIndex(i);
        }
        // primaryHandles always has more more element thatn secondaryHandles in LineString
        if (this.shape.getType() === "LineString") {
            this.primaryHandles[i].setIndex(i);
        }
        this.map.markers.add([newSecondaryDragHandleA, newSecondaryDragHandleB]);
    };
    /**
     * Hide the primary handle and the adjacent secondary handle when the drag begins
     * And disable shape dragging
     * @param draghandle
     * @param index
     */
    EditHelper.prototype.moveHandle = function (draghandle, index) {
        this.drawMgr._invokeEvent("drawingchanged", this.shape);
        this._disableShapeDragAndRotate();
        var position = draghandle.getPosition();
        if (this.shape.isCircle()) {
            var centroid = this.selectedShapeCoordinates;
            this.shape.setProperties({
                radius: azmaps__namespace.math.getDistanceTo(centroid, draghandle.getPosition()),
                subType: "Circle"
            });
            this.primaryHandles.forEach(function (handle) {
                handle.setOptions({ visible: false });
            });
        }
        else if (this.shape.isRectangle()) {
            draghandle.setOptions({ visible: false });
            // drag the handle and change the underlying shape
            var coordinates = this.selectedShapeCoordinates[0];
            // Rectangle's first and last coordiantes should be the same
            var adjacentPrimaryDragHandleIndexA = void 0;
            var adjacentPrimaryDragHandleIndexB = void 0;
            coordinates[index] = position;
            if (index === 0) {
                adjacentPrimaryDragHandleIndexA = this.primaryHandles.length - 1;
                adjacentPrimaryDragHandleIndexB = index + 1;
            }
            else {
                adjacentPrimaryDragHandleIndexA = index - 1;
                adjacentPrimaryDragHandleIndexB = index === this.primaryHandles.length - 1 ? 0 : index + 1;
            }
            var adjacentPrimaryDragHandleA = this.primaryHandles[adjacentPrimaryDragHandleIndexA];
            var adjacentPrimaryDragHandleB = this.primaryHandles[adjacentPrimaryDragHandleIndexB];
            if (index === 0 || index === 2) {
                coordinates[adjacentPrimaryDragHandleIndexA][0] = position[0];
                coordinates[adjacentPrimaryDragHandleIndexB][1] = position[1];
            }
            else if (index === 1 || index === 3) {
                coordinates[adjacentPrimaryDragHandleIndexA][1] = position[1];
                coordinates[adjacentPrimaryDragHandleIndexB][0] = position[0];
            }
            adjacentPrimaryDragHandleA.setPosition(coordinates[adjacentPrimaryDragHandleIndexA]);
            adjacentPrimaryDragHandleB.setPosition(coordinates[adjacentPrimaryDragHandleIndexB]);
            adjacentPrimaryDragHandleA.setOptions({ visible: false });
            adjacentPrimaryDragHandleB.setOptions({ visible: false });
            // rectangle's first and last coordiantes should be the same
            coordinates[coordinates.length - 1] = coordinates[0];
            this.shape.setCoordinates([coordinates]);
        }
        else if (this.shape.getType() === "LineString") {
            draghandle.setOptions({ visible: false });
            // check primary, update positions of secondary handles
            if (draghandle.getHandleType() === HandleType.primary) {
                // drag the handle and change the underlying shape
                var coordinates = this.selectedShapeCoordinates;
                coordinates[index] = position;
                this.shape.setCoordinates(coordinates);
                // hide adjacent secondary handles for better UI experience
                // will show them when the move ends
                if (index > 0) {
                    this.secondaryHandles[index - 1].setOptions({ visible: false });
                }
                if (index < this.primaryHandles.length - 1) {
                    this.secondaryHandles[index].setOptions({ visible: false });
                }
            }
            // check secondary
            // promote secondary handle, populate other secondary handles
            if (draghandle.getHandleType() === HandleType.secondary) {
                // drag the handle and change the underlying shape
                var coordinates = this.selectedShapeCoordinates;
                if (!this.isSecondaryHandleMoving) {
                    coordinates.splice(index + 1, 0, position);
                    this.isSecondaryHandleMoving = true;
                }
                else {
                    coordinates[index + 1] = position;
                }
                this.shape.setCoordinates(coordinates);
            }
        }
        else if (this.shape.getType() === "Polygon") {
            draghandle.setOptions({ visible: false });
            // check primary, update positions of secondary handles
            if (draghandle.getHandleType() === HandleType.primary) {
                // drag the handle and change the underlying shape
                var coordinates = this.selectedShapeCoordinates[0];
                coordinates[index] = position;
                if (index === 0) {
                    // hide adjacent secondary handles for better UI experience
                    // will show them when the move ends
                    this.secondaryHandles[index].setOptions({ visible: false });
                    this.secondaryHandles[this.secondaryHandles.length - 1].setOptions({ visible: false });
                }
                else {
                    // hide adjacent secondary handles for better UI experience
                    // will show them when the move ends
                    if (index > 0) {
                        this.secondaryHandles[index - 1].setOptions({ visible: false });
                    }
                    if (index < this.primaryHandles.length) {
                        this.secondaryHandles[index].setOptions({ visible: false });
                    }
                }
                // polygon's first and last coordiantes should be the same
                coordinates[coordinates.length - 1] = coordinates[0];
                this.shape.setCoordinates([coordinates]);
            }
            // check secondary
            // promote secondary handle, populate other secondary handles
            if (draghandle.getHandleType() === HandleType.secondary) {
                // drag the handle and change the underlying shape
                var coordinates = this.selectedShapeCoordinates[0];
                if (!this.isSecondaryHandleMoving) {
                    coordinates.splice(index + 1, 0, position);
                    this.isSecondaryHandleMoving = true;
                }
                else {
                    coordinates[index + 1] = position;
                }
                this.shape.setCoordinates([coordinates]);
            }
        }
        // if (draghandle.getHandleType() === HandleType.rotational) {
        //     // TODO
        //     return;
        // }
    };
    /**
     * Show the primary handle and the adjacent secondary handle when the drag ends
     * And enable shap dragging
     * @param draghandle
     * @param index
     */
    EditHelper.prototype.showHandles = function (draghandle, index) {
        if (this.shape.isCircle()) {
            var centroid_1 = this.selectedShapeCoordinates;
            var radius_1 = this.shape.getProperties().radius;
            // populate the drag handles on the circle in the order of North, East, South, West
            var headingOffset_1 = 0;
            this.primaryHandles.forEach(function (handle) {
                handle.setPosition(azmaps__namespace.math.getDestination(centroid_1, headingOffset_1 += 90, radius_1));
                handle.setOptions({ visible: true });
            });
        }
        else {
            var position = draghandle.getPosition();
            var primaryHandlesSize = this.primaryHandles.length;
            var adjacentPrimaryDragHandleIndexA = void 0;
            var adjacentPrimaryDragHandleIndexB = void 0;
            var adjacentSecondaryDragHandleIndexA = void 0;
            var adjacentSecondaryDragHandleIndexB = void 0;
            if (this.shape.getType() === "LineString") {
                adjacentPrimaryDragHandleIndexA = index > 0 ? index - 1 : null;
                adjacentPrimaryDragHandleIndexB = index < primaryHandlesSize - 1 ? index + 1 : null;
                adjacentSecondaryDragHandleIndexA = index - 1;
                adjacentSecondaryDragHandleIndexB = index;
            }
            else if (this.shape.getType() === "Polygon") {
                adjacentPrimaryDragHandleIndexA = index === 0 ? primaryHandlesSize - 1 : index - 1;
                adjacentPrimaryDragHandleIndexB = index === primaryHandlesSize - 1 ? 0 : index + 1;
                adjacentSecondaryDragHandleIndexA = index === 0 ? primaryHandlesSize - 1 : index - 1;
                adjacentSecondaryDragHandleIndexB = index;
            }
            // has to use null because adjacentPrimaryDragHandleIndexA can be 0, which won't pass the if statement
            if (adjacentPrimaryDragHandleIndexA != null) {
                var adjacentPrimaryDragHandleA = this.primaryHandles[adjacentPrimaryDragHandleIndexA];
                // rectangles don't have secondary handles
                if (this.shape.isRectangle()) {
                    adjacentPrimaryDragHandleA.setOptions({ visible: true });
                }
                else {
                    var midPointA = this._getMidPosition(position, adjacentPrimaryDragHandleA.getPosition());
                    var adjacentSecondaryDragHandleA = this.secondaryHandles[adjacentSecondaryDragHandleIndexA];
                    adjacentSecondaryDragHandleA.setPosition(midPointA);
                    this.map.markers.add(adjacentSecondaryDragHandleA);
                    adjacentSecondaryDragHandleA.setOptions({ visible: true });
                }
            }
            if (adjacentPrimaryDragHandleIndexB != null) {
                var adjacentPrimaryDragHandleB = this.primaryHandles[adjacentPrimaryDragHandleIndexB];
                // rectangles don't have secondary handles
                if (this.shape.isRectangle()) {
                    adjacentPrimaryDragHandleB.setOptions({ visible: true });
                }
                else {
                    var midPointB = this._getMidPosition(position, adjacentPrimaryDragHandleB.getPosition());
                    var adjacentSecondaryDragHandleB = this.secondaryHandles[adjacentSecondaryDragHandleIndexB];
                    adjacentSecondaryDragHandleB.setPosition(midPointB);
                    this.map.markers.add(adjacentSecondaryDragHandleB);
                    adjacentSecondaryDragHandleB.setOptions({ visible: true });
                }
            }
        }
        draghandle.setOptions({ visible: true });
        this._enableShapeDragAndRotate();
    };
    /**
     * Helper method for populate drag handles on linestrings and polygons
     */
    EditHelper.prototype._generateDragHandles = function (coords) {
        if (this.shape.isCircle()) {
            var centroid = coords;
            var radius = this.shape.getProperties().radius;
            // populate the drag handles on the circle in the order of North, East, South, West
            var headingOffset = 0;
            for (var i = 0; i < 4; i++) {
                var position = azmaps__namespace.math.getDestination(centroid, headingOffset += 90, radius);
                var primaryDragHandle = new DragHandle(this.options.dragHandleStyle, this.map, this, HandleType.primary, i, this.options);
                primaryDragHandle.setPosition(position);
                this.map.markers.add(primaryDragHandle);
                this.primaryHandles.push(primaryDragHandle);
            }
            return;
        }
        coords = coords;
        for (var i = 0; i < coords.length; i++) {
            // Add primary drag handles
            var primaryDragHandle = new DragHandle(this.options.dragHandleStyle, this.map, this, HandleType.primary, i, this.options);
            primaryDragHandle.setPosition(coords[i]);
            this.primaryHandles.push(primaryDragHandle);
            this.map.markers.add(primaryDragHandle);
            // Add secondary drag handles between two primary drag handles
            // Only applies to LineString and Polygon
            if (!this.shape.isRectangle()) {
                if (i < coords.length - 1) {
                    var midpoint = this._getMidPosition(coords[i], coords[i + 1]);
                    var secondaryDragHandle = new DragHandle(this.options.secondaryDragHandleStyle, this.map, this, HandleType.secondary, i, this.options);
                    secondaryDragHandle.setPosition(midpoint);
                    this.map.markers.add(secondaryDragHandle);
                    this.secondaryHandles.push(secondaryDragHandle);
                }
            }
        }
        if (this.shape.getType() === "Polygon") {
            // polygon's first and last coord are the same, so only need to generate one
            this.map.markers.remove(this.primaryHandles.pop());
        }
    };
    EditHelper.prototype._getMidPosition = function (positionA, positionB) {
        // first convert latlnt to pixel and get the mid point
        var pixelA = this.map.positionsToPixels([positionA])[0];
        var pixelB = this.map.positionsToPixels([positionB])[0];
        var midPixel = [(pixelA[0] + pixelB[0]) / 2, (pixelA[1] + pixelB[1]) / 2];
        // then convert the pixel back to position
        return this.map.pixelsToPositions([midPixel])[0];
    };
    EditHelper.prototype._clearHandlesAndListeners = function () {
        this.map.markers.remove(this.primaryHandles);
        this.map.markers.remove(this.secondaryHandles);
        this.primaryHandles = [];
        this.secondaryHandles = [];
        this._disableShapeDragAndRotate();
        this.removeRotateHandle();
        if (this.shape && this.shape.getType() === "Point" && !this.shape.isCircle()) {
            this.shape.addProperty("_azureMapsMarker", this.defaultPointStyle);
        }
    };
    /////////////////////////// Drag begins ///////////////////////////////////////////
    EditHelper.prototype._enableShapeDragAndRotate = function () {
        if (this._dragOrRotateEnabled()) {
            this.map.events.add("mousedown", this._startDragAndRotate);
            this.map.events.add("mousemove", this._dragAndRotate);
            this.map.events.add("mouseup", this._endDragAndRotate);
            if (this._shouldRotate()) {
                this._unselectShapeForRotate();
                this.initCentroid = azmaps.data.BoundingBox.getCenter(azmaps.data.BoundingBox.fromData(this.shape));
                this.initCoordinates = this.shape.getCoordinates();
                this.initHeading = null;
                this.rotateInitHandlePosition = this.getInitHandlePosition(this.shape);
                this.rotateHandle = new azmaps__namespace.HtmlMarker({
                    position: this.rotateInitHandlePosition,
                    htmlContent: '<div class="rotateHandleIcon" />',
                });
                this.map.markers.add(this.rotateHandle);
                this.map.events.add("mousedown", this.rotateHandle, this._handleMouseDownOnRotateHandle);
            }
        }
    };
    EditHelper.prototype._dragOrRotateEnabled = function () {
        return this.options && (this.options.shapeDraggingEnabled || this.options.shapeRotationEnabled);
    };
    EditHelper.prototype._shouldRotate = function () {
        return this.options && this.options.shapeRotationEnabled && this.shape.getType() !== 'Point' && !this.shape.isCircle();
    };
    EditHelper.prototype._disableShapeDragAndRotate = function () {
        if (this._dragOrRotateEnabled()) {
            this.map.events.remove("mousedown", this._startDragAndRotate);
            this.map.events.remove("mousemove", this._dragAndRotate);
            this.map.events.remove("mouseup", this._endDragAndRotate);
        }
    };
    EditHelper.prototype.isEventShapeSameAsSelectedShape = function (e) {
        var shape;
        var shapes = e.shapes && e.shapes.filter(function (s) { return s && s.getProperties; });
        if (shapes && shapes.length > 0) {
            shape = shapes[0];
        }
        return shape && this.shape && this.shape.getId() === shape.getId();
    };
    EditHelper.prototype._freezeMap = function (shape, e) {
        this.shape = shape;
        // Lock the maps ability to pan so that we can drag the symbol.
        MapInputHelper.lockMap(this.map);
        this.currentReferencedPixel = e.pixel;
    };
    /**
     * Updates the position of a shape as it dragged using a pixel accurate shift.
     * @param e The mouse event argument.
     */
    EditHelper.prototype._pixelAccurateUpdate = function (e) {
        // Shift the shape based on pixel offset.
        var dx = azmaps__namespace.Pixel.getX(this.currentReferencedPixel) - azmaps__namespace.Pixel.getX(e.pixel);
        var dy = azmaps__namespace.Pixel.getY(this.currentReferencedPixel) - azmaps__namespace.Pixel.getY(e.pixel);
        if (this.shape.getType() === "Point") {
            var coordinate = this.shape.getCoordinates();
            this.shape.setCoordinates(this._pixelShiftLocations(coordinate, dx, dy));
        }
        else {
            var coordinates = void 0;
            if (this.shape.getType() === "Polygon") {
                coordinates = this.shape.getCoordinates()[0];
            }
            else if (this.shape.getType() === "LineString") {
                coordinates = this.shape.getCoordinates();
            }
            for (var i = 0, len = coordinates.length; i < len; i++) {
                coordinates[i] = this._pixelShiftLocations(coordinates[i], dx, dy);
            }
            this.shape.setCoordinates(coordinates);
        }
        // Store the new point that was used to update the shape.
        this.currentReferencedPixel = e.pixel;
    };
    /**
     * Takes an array of locations and shifts them a specified distance in pixels.
     * @param locs The locations to shift.
     * @param dx Horizontal offset distance to shift the locations in pixels.
     * @param dy Vertical offset distance to shift the locations in pixels.
     * @returns An array of shifted locations.
     */
    EditHelper.prototype._pixelShiftLocations = function (locs, dx, dy) {
        // Based on the distance and heading, shift all locations in the array accordingly.
        var p = this.map.positionsToPixels([locs])[0];
        p[0] -= dx;
        p[1] -= dy;
        return this.map.pixelsToPositions([p])[0];
    };
    EditHelper.prototype._showOrHideDragHandles = function (show) {
        this.primaryHandles.forEach(function (handle) {
            handle.setOptions({ visible: show });
        });
        this.secondaryHandles.forEach(function (handle) {
            handle.setOptions({ visible: show });
        });
    };
    /////////////////////////// Rotate begins ///////////////////////////////////////////
    EditHelper.prototype._unselectShapeForRotate = function () {
        //Stop rotating shape, release it. 
        this.initCentroid = null;
        this.initCoordinates = null;
        this.initHeading = null;
        this.isRotating = false;
        this.removeRotateHandle();
    };
    EditHelper.prototype.rotateShape = function (shape, shapeCoords, centroid, angle) {
        //Rotate the coordinates of the shape.
        switch (shape.getType()) {
            case 'LineString':
            case 'MultiPoint':
                shape.setCoordinates(azmaps__namespace.math.rotatePositions(shapeCoords, centroid, angle));
                break;
            case 'Polygon':
            case 'MultiLineString':
                var newPolyCoords = shapeCoords.map(function (ring) {
                    return azmaps__namespace.math.rotatePositions(ring, centroid, angle);
                });
                shape.setCoordinates(newPolyCoords);
                break;
            case 'MultiPolygon':
                var newMultiPolyCoords = shapeCoords.map(function (polys) {
                    return polys.map(function (ring) {
                        return azmaps__namespace.math.rotatePositions(ring, centroid, angle);
                    });
                });
                shape.setCoordinates(newMultiPolyCoords);
                break;
        }
        //Rotate the rotation handle as needed.
        if (this.rotateHandle) {
            this.rotateHandle.setOptions({
                position: azmaps__namespace.math.rotatePositions([this.rotateInitHandlePosition], centroid, angle)[0]
            });
        }
    };
    EditHelper.prototype.getInitHandlePosition = function (shape) {
        var coordinates = shape.getCoordinates();
        return azmaps__namespace.math.getPositions(coordinates)[0];
    };
    return EditHelper;
}());

var __extends = (undefined && undefined.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * The drawing manager is the primary class that manages all the drawing functionality on the map.
 * It can be used directly (programmatically or with custom toolbars)
 * or in combination with the drawing toolbar control.
 */
var DrawingManager = /** @class */ (function (_super) {
    __extends(DrawingManager, _super);
    /**
     * Constructs a DrawingManager.
     * @param map The map to draw on.
     * @param options The options for the DrawingManager.
     */
    function DrawingManager(map, options) {
        var _this = _super.call(this) || this;
        _this.map = map;
        _this.options = new DrawingManagerOptions().merge(cloneDeepWith$1(options, DrawingManagerOptions._cloneCustomizer));
        _this.drawingLayers = new DrawingLayers();
        _this.drawingHelper = new DrawingHelper(_this.map, _this);
        _this.editHelper = new EditHelper(_this.map, options, _this.drawingLayers, _this);
        _this.inputHelper = new MapInputHelper(_this.map, _this.options, _this.drawingLayers, _this.drawingHelper, _this.editHelper);
        _this.setOptions(_this.options);
        return _this;
    }
    /**
     * Disposes the DrawingManager.
     * When disposed, all resources used by the DrawingManager are released.
     * Any attached toolbars or dialogs will also be disposed.
     */
    DrawingManager.prototype.dispose = function () {
        // Dispose UI elements.
        if (this.options.toolbar) {
            this.options.toolbar._dispose();
        }
        // Remove layers from map
        if (this.drawingLayers) {
            this.map.layers.remove(this.drawingLayers.lineLayer);
            this.map.layers.remove(this.drawingLayers.polygonLayer);
            this.map.layers.remove(this.drawingLayers.polygonOutlineLayer);
            this.map.layers.remove(this.drawingLayers.pointLayer);
        }
        if (this.drawingHelper) {
            this.drawingHelper.dispose();
        }
        this.map = null;
        this.options = null;
        this.drawingLayers = null;
        this.source = null;
        this.drawingHelper = null;
        this.editHelper = null;
        this.inputHelper = null;
    };
    /**
     * Edits a shape. If the shape is not already in the data source, it adds it to it.
     * @param shape
     */
    DrawingManager.prototype.edit = function (shape) {
        if (shape) {
            // If the shape is not already in the data source, add it to datasource.
            if (this.source && !this.source.getShapeById(shape.getId())) {
                this.source.add(shape);
            }
            this.setOptions({ mode: DrawingMode.editGeometry });
            this.editHelper.edit(shape);
            // TODO
            // if (this.options.propertyEditor) {
            //     this.options.propertyEditor.edit(shape);
            // }
        }
    };
    /**
     * Gets the options used by the DrawingManager.
     */
    DrawingManager.prototype.getOptions = function () {
        return this.options;
    };
    /**
     * Gets the collection of layers used for rendering the shapes draw on the map.
     * Edit these layers' options to customize the rendering.
     */
    DrawingManager.prototype.getLayers = function () {
        return this.drawingLayers;
    };
    /**
     * Gets the collection of  preview layers used for rendering the shapes draw on the map.
     * Edit these layers' options to customize the rendering.
     */
    DrawingManager.prototype.getPreviewLayers = function () {
        return this.drawingHelper.getPreviewLayers();
    };
    /**
     * Gets the data source used by the DrawingManager to store the completed shapes.
     */
    DrawingManager.prototype.getSource = function () {
        return this.source;
    };
    /**
     * Sets the options for the DrawingManager.
     * @param options The new options for the DrawingManager.
     */
    DrawingManager.prototype.setOptions = function (options) {
        // use a new options object for merge so that this.options is not modified.
        var newOptions = new DrawingManagerOptions().merge(this.options, cloneDeepWith$1(options, DrawingManagerOptions._cloneCustomizer));
        // Always set draggable to true
        newOptions.dragHandleStyle.draggable = true;
        newOptions.secondaryDragHandleStyle.draggable = true;
        // test if users pass in empty source in setOptions
        newOptions.source = newOptions.source || this.options.source;
        if (this.options.toolbar !== newOptions.toolbar) {
            if (this.options.toolbar) {
                this.options.toolbar._close();
            }
            this.options.toolbar = newOptions.toolbar;
            if (this.options.toolbar) {
                this.options.toolbar._open(this, this.map);
            }
        }
        else if (this.options.toolbar && !this.options.toolbar._isOpen()) {
            // open the initial toolbar if it's defined
            this.options.toolbar._open(this, this.map);
        }
        if (!this.options.source) {
            // If not defined when the drawing manager is created, automatically create a data source.
            this.source = new azmaps__namespace.source.DataSource();
            this.map.sources.add(this.source);
            this._setLayerSources();
        }
        else if (this.options.source !== newOptions.source) {
            /* The user should be able to swap out the source at any time.
            * Doing so should put the drawing manager into ‘idle’ mode.
            */
            this.source = this.options.source;
            newOptions.mode = DrawingMode.idle;
            this._setLayerSources();
        }
        if (this.options.mode !== newOptions.mode) {
            this._invokeEvent("drawingmodechanged", newOptions.mode);
        }
        this.options = newOptions;
        this.options.source = this.source;
        this.editHelper.setOptions(this.options);
        this.inputHelper.setOptions(this.options);
        this.drawingHelper.setOptions(this.options);
        this.inputHelper.setOptions(this.options);
    };
    /**
     * Returns the map the DrawingManager is attached to.
     * @internal
     */
    DrawingManager.prototype._getMap = function () {
        return this.map;
    };
    DrawingManager.prototype._setLayerSources = function () {
        if (!this.drawingLayers.polygonLayer) {
            this.drawingLayers.polygonLayer = new azmaps__namespace.layer.PolygonLayer(this.source, null, {
                fillColor: "rgba(0, 0, 0, 0.12)",
                filter: ["all", ["==", ["geometry-type"], "Polygon"], ["!", ["has", "_incomplete"]]]
            });
            this.map.layers.add(this.drawingLayers.polygonLayer);
        }
        else {
            this.drawingLayers.polygonLayer.setOptions({
                filter: ["==", ["geometry-type"], "Polygon"],
                source: this.source
            });
        }
        if (!this.drawingLayers.polygonOutlineLayer) {
            this.drawingLayers.polygonOutlineLayer = new azmaps__namespace.layer.LineLayer(this.source, null, {
                filter: ["any", ["==", ["geometry-type"], "Polygon"],
                    ["all", ["==", ["geometry-type"], "LineString"], ["has", "_outline"]]],
                strokeColor: "#000000"
            });
            this.map.layers.add(this.drawingLayers.polygonOutlineLayer);
        }
        else {
            this.drawingLayers.polygonOutlineLayer.setOptions({
                filter: ["any", ["==", ["geometry-type"], "Polygon"],
                    ["all", ["==", ["geometry-type"], "LineString"], ["has", "_outline"]]],
                source: this.source
            });
        }
        if (!this.drawingLayers.lineLayer) {
            this.drawingLayers.lineLayer = new azmaps__namespace.layer.LineLayer(this.source, null, {
                filter: ["all", ["==", ["geometry-type"], "LineString"], ["!", ["has", "_outline"]]],
                strokeColor: "#000000"
            });
            this.map.layers.add(this.drawingLayers.lineLayer);
        }
        else {
            this.drawingLayers.lineLayer.setOptions({
                filter: ["all", ["==", ["geometry-type"], "LineString"], ["!", ["has", "_outline"]]],
                source: this.source,
            });
        }
        if (!this.drawingLayers.pointLayer) {
            this.drawingLayers.pointLayer = new azmaps__namespace.layer.SymbolLayer(this.source, null, {
                filter: ["==", ["geometry-type"], "Point"],
                iconOptions: {
                    allowOverlap: true,
                    ignorePlacement: true,
                    image: ["case", ["has", "_azureMapsMarker"], ["get", "_azureMapsMarker"], "marker-black"],
                    size: .5
                }
            });
            this.map.layers.add(this.drawingLayers.pointLayer);
        }
        else {
            this.drawingLayers.pointLayer.setOptions({
                filter: ["==", ["geometry-type"], "Point"],
                source: this.source
            });
        }
    };
    return DrawingManager;
}(azmaps__namespace.internal.EventEmitter));

/**
 * Manages a pixel based grid for snapping positions at integer based zoom levels.
 */
var SnapGridManager = /** @class */ (function () {
    /**********************
    * Constructor
    ***********************/
    /**
     * Manages a pixel based grid for snapping positions at integer based zoom levels.
     * @param map The map to attache the snap grid manager to.
     * @param options Options to apply to the snap grid manager.
     */
    function SnapGridManager(map, options) {
        var _this = this;
        this._options = {
            resolution: 15,
            showGrid: false,
            removeDuplicates: true,
            enabled: true,
            simplify: true
        };
        this._mapSize24 = 512 * Math.pow(2, 24);
        /**********************
        * Private Functions
        ***********************/
        /** Method that calculates the grid lines. */
        this._updateGrid = function () {
            var self = _this;
            var cam = self._map.getCamera();
            var zoom = Math.round(cam.zoom);
            var gridSize = self._options.resolution * Math.pow(2, 24 - zoom);
            //Cache commonly used namespaces, variables, and functions for better minification.   
            var bbox = azmaps__namespace.data.BoundingBox;
            var mapSize24 = self._mapSize24;
            var clip = self.clip;
            //The map camera might cross anti-merdian. This will return an array of one or more bounding boxes.
            //NOTE: there is a bug in the BoundingBox code. I made a workaround, fix the bug then update this code with the commented out code.
            var worldBounds = _this.splitOnAntimeridian(cam.bounds); //bbox.splitOnAntimeridian(cam.bounds);
            var lines = [];
            worldBounds.forEach(function (bounds) {
                var corners = self.fastPositionsToPixels([
                    bbox.getNorthWest(bounds),
                    bbox.getSouthEast(bounds)
                ], false, false, gridSize);
                var topLeftPixel = corners[0];
                var bottomRightPixel = corners[1];
                var left = clip(topLeftPixel[0] - topLeftPixel[0] % gridSize - gridSize, 0, mapSize24);
                var right = clip(bottomRightPixel[0] - bottomRightPixel[0] % gridSize + gridSize, 0, mapSize24);
                var top = clip(topLeftPixel[1] - topLeftPixel[1] % gridSize - gridSize, 0, mapSize24);
                var bottom = clip(bottomRightPixel[1] - bottomRightPixel[1] % gridSize + gridSize, 0, mapSize24);
                //Create rows
                for (var y = top; y < bottom; y = y + gridSize) {
                    lines.push(new azmaps__namespace.data.LineString(self.fastPixelsToPositions([
                        [left, y],
                        [right, y]
                    ])));
                }
                //Create cols
                for (var x = left; x < right; x = x + gridSize) {
                    lines.push(new azmaps__namespace.data.LineString(self.fastPixelsToPositions([
                        [x, top],
                        [x, bottom]
                    ])));
                }
            });
            self._source.setShapes(lines);
        };
        var self = this;
        self._map = map;
        self._source = new azmaps__namespace.source.DataSource();
        map.sources.add(self._source);
        self._layer = new azmaps__namespace.layer.LineLayer(self._source, null, {
            strokeColor: '#c3a77e',
            strokeWidth: 1,
            visible: false
        });
        map.layers.add(self._layer, 'transit');
        self.setOptions(options || {});
    }
    /**********************
    * Public Functions
    ***********************/
    /**
     * Disposes the manager.
     */
    SnapGridManager.prototype.dispose = function () {
        var self = this;
        self._map.events.remove('move', self._updateGrid);
        self._map.events.remove('resize', self._updateGrid);
        Object.keys(self).forEach(function (k) {
            self[k] = null;
        });
    };
    /**
     * Gets the options used by the SnapGridManager.
     */
    SnapGridManager.prototype.getOptions = function () {
        return Object.assign({}, this._options);
    };
    /**
     * Gets the line layer used to render the grid lines.
     * @returns A line layer used to render the grid lines.
     */
    SnapGridManager.prototype.getGridLayer = function () {
        return this._layer;
    };
    /**
     * Perform a Douglas-Peucker simplification on an array of positions or pixels.
     * @param points The position or pixel points to simplify.
     * @param tolerance A tolerance to use in the simplification.
     * @returns A new array of the simplified set of points.
     */
    SnapGridManager.simplify = function (points, tolerance) {
        //Perform a Douglas-Peucker simplification of the pixels.
        return azmaps__namespace.math.simplify(points, tolerance);
    };
    /**
     * Snaps an array of positions to the grid. If `optimize` is set, duplicate sequential positions will be removed from the shape.
     * @param positions The positions to snap.
     * @param zoom Optionally specify which zoom level to optimize the snapping for. If not specified, the maps zoom level will be used.
     * @returns A new array of snapped positions.
     */
    SnapGridManager.prototype.snapPositions = function (positions, zoom) {
        var self = this;
        var opt = self._options;
        if (!opt.enabled) {
            return positions;
        }
        zoom = (typeof zoom === 'number') ? Math.round(Math.abs(zoom)) : Math.round(self._map.getCamera().zoom);
        var gridSize = opt.resolution * Math.pow(2, 24 - zoom);
        //Convert the positions to pixels.
        var pixels = self.fastPositionsToPixels(positions, opt.removeDuplicates, opt.simplify, gridSize);
        //Snap the pixels to the grid.
        var p;
        var dx;
        for (var i = 0, len = pixels.length; i < len; i++) {
            p = pixels[i];
            dx = p[0] % gridSize;
            if (dx >= gridSize * 0.5) {
                dx -= gridSize;
            }
            var dy = p[1] % gridSize;
            if (dy >= gridSize * 0.5) {
                dy -= gridSize;
            }
            p[0] -= dx;
            p[1] -= dy;
        }
        //Convert the snapped pixels back to positions.
        return self.fastPixelsToPositions(pixels);
    };
    /**
     * Snaps a Shape or GeoJSON feature coordinates to the grid.
     * @param shape A shape or GeoJSON feature to snap.
     * @param zoom Optionally specify which zoom level to optimize the snapping for. If not specified, the maps zoom level will be used.
     */
    SnapGridManager.prototype.snapShape = function (shape, zoom) {
        var self = this;
        if (self._options.enabled) {
            if (shape instanceof azmaps__namespace.Shape) {
                var f = shape.toJson();
                self.snapFeature(f, zoom);
                shape.setCoordinates(f.geometry.coordinates);
            }
            else if (shape['type'] === 'Feature') {
                self.snapFeature(shape, zoom);
            }
        }
    };
    /**
     * Sets the options of the snap grid manager.
     * @param options Options to set.
     */
    SnapGridManager.prototype.setOptions = function (options) {
        if (options) {
            var self_1 = this;
            var map = self_1._map;
            var opt = self_1._options;
            var triggerUpdate = false;
            if (typeof options.removeDuplicates === 'boolean' && options.removeDuplicates !== opt.removeDuplicates) {
                opt.removeDuplicates = options.removeDuplicates;
            }
            if (typeof options.simplify === 'boolean' && options.simplify !== opt.simplify) {
                opt.simplify = options.simplify;
            }
            if (typeof options.enabled === 'boolean' && options.enabled !== opt.enabled) {
                opt.enabled = options.enabled;
            }
            if (typeof options.resolution === 'number' && options.resolution > 0) {
                opt.resolution = options.resolution;
                triggerUpdate = true;
            }
            if (typeof options.showGrid === 'boolean' && options.showGrid !== opt.showGrid) {
                opt.showGrid = options.showGrid;
                if (opt.showGrid) {
                    map.events.add('move', self_1._updateGrid);
                    map.events.add('resize', self_1._updateGrid);
                    triggerUpdate = true;
                }
                else {
                    map.events.remove('move', self_1._updateGrid);
                    map.events.remove('resize', self_1._updateGrid);
                }
                self_1._layer.setOptions({ visible: opt.showGrid });
            }
            if (triggerUpdate) {
                self_1._source.clear();
                self_1._updateGrid();
            }
        }
    };
    /**
     * Snaps the coordinates of a GeoJSON feature to the grid.
     * @param feature A GeoJSON feature to snap the coordinates of.
     * @param zoom Optionally specify which zoom level to optimize the snapping for. If not specified, the maps zoom level will be used.
     */
    SnapGridManager.prototype.snapFeature = function (feature, zoom) {
        var self = this;
        var geom = feature.geometry;
        switch (geom.type) {
            case 'Point':
                geom.coordinates = self.snapPositions([geom.coordinates], zoom)[0];
                break;
            case 'LineString':
            case 'MultiPoint':
                geom.coordinates = self.snapPositions(geom.coordinates, zoom);
                break;
            case 'Polygon':
            case 'MultiLineString':
                geom.coordinates = geom.coordinates.map(function (ring) {
                    return self.snapPositions(ring, zoom);
                });
                break;
            case 'MultiPolygon':
                geom.coordinates = geom.coordinates.map(function (polygon) {
                    return polygon.map(function (ring) {
                        return self.snapPositions(ring, zoom);
                    });
                });
                break;
        }
    };
    /**
     * This is an enhanced version of the mercator position to pixel calculation, locked to zoom level 24, that normalizes longitude values, optionally removes duplicate sequential values, or performs line based simplification.
     * @param positions An array of positions to convert to pixels.
     * @param removeDuplicates Specifies if duplicate points should be removed.
     * @param simplify Specifies if a Douglas-Peucker simplification should be done on the pixels.
     * @param gridSize The size of the grid.
     * @returns A set of positions that have been converted to pixels at zoom level 24.
     */
    SnapGridManager.prototype.fastPositionsToPixels = function (positions, removeDuplicates, simplify, gridSize) {
        var pixels = [];
        var xt;
        var yt;
        var mapSize = this._mapSize24;
        for (var i = 0, len = positions.length; i < len; i++) {
            var sinLatitude = Math.sin(positions[i][1] * Math.PI / 180);
            var x = Math.round((azmaps__namespace.math.normalizeLongitude(positions[i][0]) + 180) / 360 * mapSize);
            var y = Math.round((0.5 - Math.log((1 + sinLatitude) / (1 - sinLatitude)) / (4 * Math.PI)) * mapSize);
            if (i === 0 || !removeDuplicates || !(xt === x && yt === y)) {
                pixels.push([x, y]);
            }
            xt = x;
            yt = y;
        }
        if (simplify && pixels.length > 1) {
            //Perform a Douglas-Peucker simplification of the pixels.
            return azmaps__namespace.math.simplify(pixels, gridSize * 0.5);
        }
        return pixels;
    };
    /**
     * Converts an array of pixels from zoom level 24 mercator to an array of positions.
     * @param pixels Pixels from zoom level 24 mercator to convert.
     * @returns Array of positions.
     */
    SnapGridManager.prototype.fastPixelsToPositions = function (pixels) {
        var pos = [];
        for (var i = 0, len = pixels.length; i < len; i++) {
            pos.push(this.fastPixelToPosition(pixels[i]));
        }
        return pos;
    };
    /**
     * Converts a pixel from zoom level 24 mercator to a position.
     * @param pixel Pixel from zoom level 24 mercator to convert.
     * @returns A position.
     */
    SnapGridManager.prototype.fastPixelToPosition = function (pixel) {
        var mapSize = this._mapSize24;
        return [
            360 * ((pixel[0] / mapSize) - 0.5),
            90 - 360 * Math.atan(Math.exp(-(0.5 - (pixel[1] / mapSize)) * 2 * Math.PI)) / Math.PI
        ];
    };
    /**
     * Clips a number between a min and max range.
     * @param num Number to clip.
     * @param min Min number.
     * @param max Max number.
     * @returns A clipped number.
     */
    SnapGridManager.prototype.clip = function (num, min, max) {
        return Math.max(Math.min(num, max), min);
    };
    //The following are workarounds for bugs as outlined here: https://msazure.visualstudio.com/One/_workitems/edit/10129719 Fix these bugs, then remove these functions from this code.
    SnapGridManager.prototype.splitOnAntimeridian = function (bounds) {
        var bboxes = [];
        //Test the case when the bounding box is wider than a single globe.
        if (bounds.length >= 6 && bounds[3] - bounds[0] > 360) {
            return [[-180, bounds[1], bounds[2], 180, bounds[4], bounds[5]]];
        }
        else if (bounds.length < 6 && bounds[2] - bounds[0] > 360) {
            return [[-180, bounds[1], 180, bounds[3]]];
        }
        else if (this.crossesAntimeridian(bounds)) { //Case when map less than full globe width, but crosses anti-meridian.
            var bbox1 = void 0;
            var bbox2 = void 0;
            var west = azmaps__namespace.math.normalizeLongitude(azmaps__namespace.data.BoundingBox.getWest(bounds));
            var east = azmaps__namespace.math.normalizeLongitude(azmaps__namespace.data.BoundingBox.getEast(bounds));
            var north = azmaps__namespace.math.normalizeLatitude(azmaps__namespace.data.BoundingBox.getNorth(bounds));
            var south = azmaps__namespace.math.normalizeLatitude(azmaps__namespace.data.BoundingBox.getSouth(bounds));
            // has elevations
            if (bounds.length >= 6) {
                bbox1 = [west, south, bounds[2], 180, north, bounds[5]];
                bbox2 = [-180, south, bounds[2], east, north, bounds[5]];
            }
            else {
                bbox1 = [west, south, 180, north];
                bbox2 = [-180, south, east, north];
            }
            bboxes.push(bbox1, bbox2);
        }
        else {
            bboxes.push(bounds);
        }
        return bboxes;
    };
    SnapGridManager.prototype.crossesAntimeridian = function (bounds) {
        var east = azmaps__namespace.math.normalizeLongitude(azmaps__namespace.data.BoundingBox.getEast(bounds));
        var west = azmaps__namespace.math.normalizeLongitude(azmaps__namespace.data.BoundingBox.getWest(bounds));
        return (east - west) < 0 || (bounds.length >= 6 && bounds[3] - bounds[0] > 360) || (bounds.length < 6 && bounds[2] - bounds[9] > 360);
    };
    return SnapGridManager;
}());

var snapGridInternal = /*#__PURE__*/Object.freeze({
    __proto__: null,
    SnapGridManager: SnapGridManager
});

var baseDrawing = /*#__PURE__*/Object.freeze({
    __proto__: null,
    get DrawingInteractionType () { return DrawingInteractionType; },
    DrawingManager: DrawingManager,
    get DrawingMode () { return DrawingMode; },
    SnapGridManager: SnapGridManager
});

var control = Namespace.merge("atlas.control", baseControl);
var drawing = Namespace.merge("atlas.drawing", baseDrawing);
var snapGrid = Namespace.merge("atlas.drawing", snapGridInternal);

exports.control = control;
exports.drawing = drawing;
exports.snapGrid = snapGrid;
